Attribute VB_Name = "modPEInfo"

'#Uses "modCommon.bas"

Option Explicit

Public Const FILE_BIT_TYPE32 = 224 + 24
Public Const FILE_BIT_TYPE64 = 240 + 24

'дԻƽ̨
Public Enum PELangType
	DELPHI_FILE_SIGNATURE = &H50
	NET_FILE_SIGNATURE = &H424A5342
End Enum

'ڴӳļ
Private Enum FileMaping
	PAGE_READONLY = &H02
	PAGE_READWRITE = &H04
	PAGE_WRITECOPY = &H08
	PAGE_EXECUTE = &H10
	PAGE_EXECUTE_READ = &H20
	PAGE_EXECUTE_READWRITE = &H40
	PAGE_EXECUTE_WRITECOPY = &H80
	SEC_COMMIT = &H8000000
	SEC_IMAGE = &H1000000
	SEC_NOCACHE = &H10000000
	SEC_RESERVE = &H4000000
	SEC_IMAGE_NO_EXECUTE = &H11000000
	SEC_LARGE_PAGES = &H80000000
	SEC_WRITECOMBINE = &H40000000
	GENERIC_READ = &H80000000
	GENERIC_WRITE = &H40000000
	OPEN_EXISTING = 3
	OPEN_ALWAYS = 4
	FILE_MAP_COPY = &H01
	FILE_MAP_WRITE = &H02
	FILE_MAP_READ = &H04
	FILE_MAP_ALL_ACCESS = &H02 Or &H04
	FILE_MAP_EXECUTE = &H20
	FILE_SHARE_READ = &H01
	FILE_SHARE_WRITE = &H02
	FILE_ATTRIBUTE_NORMAL = &H80
	FILE_ATTRIBUTE_ARCHIVE = &H20
	FILE_ATTRIBUTE_READONLY = &H01
	FILE_ATTRIBUTE_HIDDEN = &H02
	FILE_ATTRIBUTE_SYSTEM = &H04
End Enum

'Ϣ
Private Enum FormatMSG
	FORMAT_MESSAGE_FROM_SYSTEM = &H1000
	FORMAT_MESSAGE_IGNORE_INSERTS = &H200
End Enum

'PEļṹ(Visual Basic)ִһ
'ǩ
Private Enum ImageSignatureTypes
	IMAGE_DOS_SIGNATURE = &H5A4D			'// MZ
	IMAGE_OS2_SIGNATURE = &H454E			'// NE
	IMAGE_OS2_SIGNATURE_LE = &H454C			'// LE
	IMAGE_VXD_SIGNATURE = &H454C			'// LE
	IMAGE_NT_SIGNATURE = &H4550				'// PE00
End Enum

'ж32λ64λPEļ
Private Enum ImageOptionalHeaderMagicType
	IMAGE_NT_OPTIONAL_HDR32_MAGIC = &H10B			'32λPEļ
	IMAGE_NT_OPTIONAL_HDR64_MAGIC = &H20B			'64λPEļ
End Enum

'ļ(־)
'IMAGE_FILE.Characteristics
Private Enum ImageFileCharacteristicsTypes
	IMAGE_FILE_RELOCS_STRIPPED = &H1				'ضλϢƳ
	IMAGE_FILE_EXECUTABLE_IMAGE = &H2				'ļִ
	IMAGE_FILE_LINE_NUMS_STRIPPED = &H4				'кűƳ
	IMAGE_FILE_LOCAL_SYMS_STRIPPED = &H8			'űƳ
	IMAGE_FILE_AGGRESIVE_WS_TRIM = &H10				'Agressively Trim working Set
	IMAGE_FILE_LARGE_ADDRESS_AWARE = &H20			'ܴ2Gĵַ
	IMAGE_FILE_BYTES_REVERSED_LO = &H80				'Ļ͵λ
	IMAGE_FILE_32BIT_MACHINE = &H100				'32λ
	IMAGE_FILE_DEBUG_STRIPPED = &H200				'.dbgļĵϢƳ
	IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP = &H400		'ƶ,ļ
	IMAGE_FILE_NET_RUN_FROM_SWAP = &H800			',ļ
	IMAGE_FILE_SYSTEM = &H1000						'ϵͳļ
	IMAGE_FILE_DLL = &H2000							'ļһdll
	IMAGE_FILE_UP_SYSTEM_ONLY = &H4000				'ļֻڵ
	IMAGE_FILE_BYTES_REVERSED_HI = &H8000			'Ļ͸λ.
End Enum


'ӦóִеĻƽ̨붨
'IMAGE_FILE_HEADER.iMachine
'======================================================================================
Private Enum ImageFileMachineTypes
	IMAGE_FILE_MACHINE_UNKNOWN = &H0		'δ֪
	IMAGE_FILE_MACHINE_I386 = &H14C			'Intel 80386 
	IMAGE_FILE_MACHINE_I486 = &H14D			'Intel 80486 
	IMAGE_FILE_MACHINE_IPTM = &H14E			'Intel Pentium 
	IMAGE_FILE_MACHINE_R 	= &H160			'R3000(MIPS)big endian
	IMAGE_FILE_MACHINE_R3000 = &H162		'R3000(MIPS)little endian
	IMAGE_FILE_MACHINE_R4000 = &H166		'R4000(MIPS)little endian
	IMAGE_FILE_MACHINE_R10000 = &H168		'R10000(MIPS)little endian
	IMAGE_FILE_MACHINE_WCEMIPSV2 = &H169	'MIPS Little-endian WCE v2
	IMAGE_FILE_MACHINE_ALPHA = &H184		'DEC Alpha AXP
	IMAGE_FILE_MACHINE_POWERPC= &H1F0		'IBM Power PClittle endian
	IMAGE_FILE_MACHINE_SH3 = &H1A2			'SH3 little-endian
	IMAGE_FILE_MACHINE_SH3E = &H1A4			'SH3E little-endian
	IMAGE_FILE_MACHINE_SH4 = &H1A6			'SH4 little-endian
	IMAGE_FILE_MACHINE_SH5 = &H1A8			'SH5
	IMAGE_FILE_MACHINE_ARM = &H1C0			'ARM Little-Endian
	IMAGE_FILE_MACHINE_THUMB = &H1C2
	IMAGE_FILE_MACHINE_ARM33 = &H1D3
	IMAGE_FILE_MACHINE_IA64 = &H200			'Intel 64
	IMAGE_FILE_MACHINE_MIPS16 = &H266		'MIPS
	IMAGE_FILE_MACHINE_ALPHA64 = &H284		'ALPHA64
	IMAGE_FILE_MACHINE_MIPSFPU = &H366		'MIPS
	IMAGE_FILE_MACHINE_MIPSFPU16 = &H466	'MIPS
	'IMAGE_FILE_MACHINE_AMD64 = &H500		'AMD K8
	IMAGE_FILE_MACHINE_TRICORE = &H520		'Infineon
	IMAGE_FILE_MACHINE_CEF = &HCEF
	IMAGE_FILE_MACHINE_AMD64 = &H8664  		'AMD64 (K8)
End Enum


'Ŀ¼
'======================================================================================
Private Enum ImageDirectoryEntry
	IMAGE_DIRECTORY_ENTRY_EXPORT = 0				'Ŀ¼
	IMAGE_DIRECTORY_ENTRY_IMPORT = 1				'Ŀ¼
	IMAGE_DIRECTORY_ENTRY_RESOURCE = 2				'ԴĿ¼
	IMAGE_DIRECTORY_ENTRY_EXCEPTION = 3				'쳣Ŀ¼
	IMAGE_DIRECTORY_ENTRY_SECURITY = 4				'ȫĿ¼
	IMAGE_DIRECTORY_ENTRY_BASERELOC = 5				'ضλ
	IMAGE_DIRECTORY_ENTRY_DEBUG = 6					'Ŀ¼
	IMAGE_DIRECTORY_ENTRY_COPYRIGHT = 7				'X86ʹ-
	'IMAGE_DIRECTORY_ENTRY_ARCHITECTURE = 7			'Architecture Specific Data
	IMAGE_DIRECTORY_ENTRY_GLOBALPTR = 8				'ֵ(MIPS GP), RVA of GlobalPtr
	IMAGE_DIRECTORY_ENTRY_TLS = 9					'̱߳ش洢(Thread Local Storage,TLS)Ŀ¼
	IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG = 10			'Ŀ¼
	IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT = 11			'(Bound Import Directory in headers)
	IMAGE_DIRECTORY_ENTRY_IAT = 12					'ַ
	IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT = 13			'Delay Load Import Descriptors
	IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR = 14		'COM б־
	IMAGE_DIRECTORY_ENTRY_RESERVED = 15				'
End Enum

'Զ
Public Enum ImageSectionType
	IMAGE_SCN_CNT_CODE = &H20						'а
	IMAGE_SCN_CNT_INITIALIZED_DATA = &H40			'аѳʼ
	IMAGE_SCN_CNT_UNINITIALIZED_DATA = &H80			'аδʼ
	IMAGE_SCN_MEM_DISCARDABLE = &H2000000			'һɶĽڣеڽ̿ʼ󽫱
	IMAGE_SCN_MEM_NOT_CACHED = &H4000000			'ݲ
	IMAGE_SCN_MEM_NOT_PAGED = &H8000000				'ݲڴ
	IMAGE_SCN_MEM_SHARED = &H10000000				'ݿɹ
	IMAGE_SCN_MEM_EXECUTE = &H20000000				'ִн
	IMAGE_SCN_MEM_READ = &H40000000					'ɶ
	IMAGE_SCN_MEM_WRITE = &H80000000				'д
End Enum

'Դ
'======================================================================================
Private Enum ImageResourceEntry
	IMAGE_RESOURCE_CURSOR = 1						'						'
	IMAGE_RESOURCE_BITMAP = 2						'λͼ
	IMAGE_RESOURCE_ICON = 3							'ͼ
	IMAGE_RESOURCE_MENU = 4							'˵
	IMAGE_RESOURCE_DIALOG = 5						'Ի
	IMAGE_RESOURCE_STRING_TABLE = 6					'ַ
	IMAGE_RESOURCE_FONT_DIRECTORY = 7				'Ŀ¼
	IMAGE_RESOURCE_FONT	= 8							'
	IMAGE_RESOURCE_ACCELERATORS = 9					'
	IMAGE_RESOURCE_UNFORMATTED_RESOURCE_DATA = 10	'δʽԴ
	IMAGE_RESOURCE_MESSAGE_TABEL = 11				'Ϣ
	IMAGE_RESOURCE_GROUP_CURSOR = 12				'
	IMAGE_RESOURCE_GROUP_ICON = 13					'ͼ
	IMAGE_RESOURCE_VERSION_INFO = 14				'汾Ϣ
End Enum

'======================================================================================
'ṹ: IMAGE_DOS_HEADER
'ṹС: 64ֽ
'ṹ˵: DOSӳͷ(EXEͷ)
'======================================================================================
Public Type IMAGE_DOS_HEADER
	iSignature						As Integer		'&H0    ǩ("MZ",&H5A4D)
	iLastPageBytes					As Integer		'&H2    ļҳеֽ
	iPages							As Integer		'&H4    ļҳ
	iRelocateItems					As Integer		'&H6    ضλԪظ
	iHeaderSize						As Integer		'&H8    ͷС
	iMinAlloc						As Integer		'&HA    СӶ
	iMaxAlloc						As Integer		'&HC    󸽼Ӷ
	iInitialSS						As Integer		'&HE    ʼSSֵ
	iInitialSP						As Integer		'&H10   ʼSPֵ
	iCheckSum						As Integer		'&H12   У
	iInitialIP						As Integer		'&H14   ʼIPֵ
	iInitialCS						As Integer		'&H16   ʼCSֵ(ƫ)
	iRelocateTable					As Integer		'&H18   ضļַ
	iOverlay						As Integer		'&H1A   Ǻ
	iReserved(3)					As Integer		'&H22   
	iOEMID							As Integer		'&H24   OEMʶ
	iOEMInformation					As Integer		'&H26   OEMϢ
	iReserved2(9)					As Integer		'&H28   2
	lPointerToPEHeader				As Long			'&H3C   PEͷλ
End Type

'======================================================================================
'ṹ: IMAGE_FILE_HEADER
'ṹС: 20ֽ
'ṹ˵: ӳļͷ
'======================================================================================
Private Type IMAGE_FILE_HEADER
	iMachine						As Integer		'&H4    ִиóĻƽ̨
	iNumberOfSections				As Integer		'&H6    ļнڵĸ
	lTimeDateStamp					As Long			'&H8    ļʱ(ʱ)
	lPointerToSymbolTable			As Long			'&HC    COFFűƫ
	lNumberOfSymbols				As Long			'&H10   Ŀ
	iSizeOfOptionalHeader			As Integer		'&H14   ѡͷС
	iCharacteristics				As Integer		'&H16   ־
End Type

'======================================================================================
'ṹ: IMAGE_DATA_DIRECTORY
'ṹС: ÿĿ¼8ֽڣ16Ŀ¼120ֽ
'ṹ˵: Ŀ¼
'0 = Ŀ¼
'1 = Ŀ¼
'2 = ԴĿ¼
'3 = 쳣Ŀ¼
'4 = ȫĿ¼
'5 = ַضλ
'6 = Ŀ¼
'7 = ȨĿ¼
'8 = ֵ(GP RVA)
'9 = ̱߳ش洢
'10 = Ŀ¼
'11 = 󶨵Ŀ¼
'12 = ַ
'13 = ӳټص
'14 = COM п־(.NET  RVA = CLR ַSize = CLR header ĴС̶Ϊ48ֽ)
'15 = Ŀ¼
'======================================================================================
Public Type IMAGE_DATA_DIRECTORY
	lVirtualAddress			As Long			'ʼRVAַ
	lSize					As Long			'lVirtualAddressָݽṹֽ
End Type

'======================================================================================
'ṹ: .NET CLR 2.0 ͷṹ
'ṹС: 72ֽ
'ṹ˵: CLR ͷ
'======================================================================================
Private Type IMAGE_CLR20_HEADER
	'Header versioning
	cb						As Long					'CLRͷĴСbyteΪλ
	MajorRuntimeVersion		As Integer				'иóС.NET汾汾
	MinorRuntimeVersion		As Integer				'иó.NET汾ĸ汾

	'Symbol table And startup information
	METADATA				As IMAGE_DATA_DIRECTORY	'ԪݵRVASize
	Flags					As Long					'ֶΣIL.corflagsʽã
													'Ҳڱʱ/FLAGSѡãõȼϸ
	EntryPointToken			As Long					'ڷԪIDҲtokenEXEļУ
													'DLLļдΪ0.NET 2.0УǱڴRVAֵ
	'Binding information
	Resources				As IMAGE_DATA_DIRECTORY	'йԴRVASize
	StrongNameSignature		As IMAGE_DATA_DIRECTORY	'ǿݵRVASizeǿƵںܣ

	'Regular fixup And binding information
	CodeManagerTable		As IMAGE_DATA_DIRECTORY	'CodeManagerTableRVASizeδʹãΪ0
    VTableFixups			As IMAGE_DATA_DIRECTORY	'v-tableRVASizeҪʹv-tableC++Խضλ
    ExportAddressTableJumps	As IMAGE_DATA_DIRECTORY	'C++תַRVASizeΪ0

    'Precompiled image info (internal use only - Set To zero)
    ManagedNativeHeader		As IMAGE_DATA_DIRECTORY	'ngenɱģиΪ0Ϊ0
End Type

'Ŀ¼ CLR Header Flags
'======================================================================================
Private Enum CLR_HEADER_FLAGES
	COMIMAGE_FLAGS_ILONLY = &H1				'CLRɴIL
	COMIMAGE_FLAGS_32BITREQUIRED = &H2		'CLRӳֻ32λϵͳִ
	COMIMAGE_FLAGS_IL_LIBRARY = &H4			'CLRӳΪILڵ
	COMIMAGE_FLAGS_STRONGNAMESIGNED = &H8	'ļܵǿǩı
	COMIMAGE_FLAGS_NATIVE_ENTRYPOINT =&H8	'˳ڷΪй
	COMIMAGE_FLAGS_TRACKDEBUGDATA = &H10000	'LoaderJITҪ׷ٵϢȱʡ0
End Enum

'======================================================================================
'ṹ: .NET MetaData ͷṹ
'ṹС: ̶
'ṹ˵: MetaData ͷ
'======================================================================================
Private Type IMAGE_METADATA_HEADER
	lSignature		As Long   		'Magic signature For physical metadata, currently 0x424A5342(BSJB Ϊ.Net ļı־)
	iMajorVersion	As Integer		'Major version (1 for the first release of the common language runtime)
	iMinorVersion	As Integer		'Minor Version (1 For the first release of the common language runtime)
	lExtraData		As Long			'Reserved, always 0
	lLength			As Long			'Length of Version String In bytes
	Version()		As Byte			'汾ַ, UTF8 룬4ֽڶ
	fFlags			As Integer		'Reserved, always 0
	iStreams		As Integer		'Number of streams
	'StreamHeader()	As IMAGE_STREAM_HEADER
End Type

'======================================================================================
'ṹ: .NET Stream ͷṹ
'ṹС: 72ֽ
'ṹ˵: Stream ͷ
'
'#Strings: UTF8ʽַѣԪݵƣԱȣ
'          ײһ0Ϊַַ0ʾβCLRЩƵ󳤶1024
'#Blob:    ݶѣ洢еķַϢ糣ֵsignaturePublicKeyȡ
'          ÿݵĳɸݵǰ13λ0ʾȣֽڣ10ʾ2ֽڣ110ʾ4ֽڡ
'#GUID:    洢еȫΨһʶGlobal Unique Identifier
'#US:      UnicodeʽŵILʹõûַUser Stringldstrõַ
'#~:       ԪݱҪеԪϢԱʽڴˡÿ.Net 򶼱
'#-:       #~δѹΪδŻ洢
'======================================================================================
Private Type IMAGE_STREAM_HEADER
    lOffset			As Long			' Metadata Root ڴƫ
    lSize			As Long			'ֽڴС4 ı
    rcName()		As Byte			'Կֹֽ ASCII ַ飬4ֽڶ
    RWA				As Long			'ƫƵַ (ʵûֵֻΪ˷㶨λλ)
End Type

'#Blob
'#Blobһݶѣезַʽݶѷ棬
'糣ֵPublic KeyֵSignatureȵȡ
'ÿݿͷһ鳤ݣΪ˽Լ洢ռ䣬CLRʹ˱Ƚ鷳ı뷽
'ʼһֽλΪ0ݿ鳤Ϊһֽڣ
'ʼһֽλΪ10ݿ鳤Ϊֽڣ
'ʼһֽλΪ110ݿ鳤Ϊĸֽڣ
'α־λͨλ㼴ɼݿʵʳֵݴ˻ݡ

'#US
'һBlobѣûԶַ
'˶ûеַЩַUTF-16ıʽ棬ŶһβΪ01ֽڣ
'ַָǷд0x007FĴַ
'βֽڱӵϵûַɵַϵĴת
'ȤǣûַᱻԪݱõʾرILַʹldstrָ
'⣬ΪһʵϵblobѣUSѲԴ洢UnicodeַԴ洢ƶʹЩȤʵֳΪܡ

'======================================================================================
'ṹ: .NET #~ Stream ṹ
'ṹС: 24ֽ
'ṹ˵: #~ Streamǿǩص
'======================================================================================
'Private Type TClrTableStreamHeader
'	Reserved		As Long			'Ϊ0
'	MajorVersion	As Byte			'Ԫݱ汾ţ.Net汾һ
'	MinorVersion	As Byte			'Ԫݱĸ汾ţһΪ0
'	HeapSizes		As Byte			'heaps жλʱĴСΪ0ʾ16λֵ
									'ݳ16λݱʾΧʹ32λֵ
									'01h strings ѣ02h GUID ѣ04h blob 
									'#-пΪ20h80hǰߴаEdit-and-Continueĵ޸ĵݣ
									'߱ʾԪиʶΪɾ
'	Rid				As Byte			'Ԫݱм¼ֵʱ.Net㣬ļͨΪ1
'	MaskValid		As Double		'8ֽڳȵ룬ÿλһΪ1ʾñЧΪ0ʾ޸ñ
'	Sorted			As Double		'8ֽڳȵ룬ÿλһΪ1ʾñ򣬷֮Ϊ0
'End Type

'MaskValid (¼ Ԫݱ ˵)
'0(0x0) ModuleDef					ǰģ
'1(0x1) TypeRef						TypeΪÿõͱһ¼
'2(0x2) TypeDef						Type壬ÿTypeTypeDefбһ¼
'3(0x3) FieldPtr					ֶָ룬ֶʱмұ
'4(0x4) FieldDef					ֶζ
'5(0x5) MethodPtr					ָ룬ķʱмұ
'6(0x6) MethodDef					
'7(0x7) ParamPtr					ָ룬Ĳʱмұ
'8(0x8) ParamDef					Ĳ
'9(0x9) InterfaceImpl				ЩʵЩӿ
'10(0xa) MemberRef					óԱóԱǷֶλԡ
'11(0xb) Constant					ֶκԵĳֵ
'12(0xc) CustomAttribute			ԵĶ
'13(0xd) FieldMarshal				йܴ뽻ʱֶεĴݷʽ
'14(0xe) DeclSecurity				ࡢͳ򼯵İȫ
'15(0xf) ClassLayout				ʱĲϢ
'16(0x10) FieldLayout				ֶεƫƻ
'17(0x11) StandAloneSig				δκõǩ
'18(0x12) EventMap					¼б
'19(0x13) EventPtr					¼ָ룬¼ʱмұ
'20(0x14) Event						¼
'21(0x15) PropertyMap				б
'22(0x16) PropertyPtr				ָ룬ʱмұ
'23(0x17) Property					
'24(0x18) MethodSemantics			¼뷽Ĺ
'25(0x19) MethodImpl				ʵ
'26(0x1a) ModuleRef					ⲿģ
'27(0x1b) TypeSpec					TypeDefTypeRef˵
'28(0x1c) ImplMap					ʹõзйܴķ
'29(0x1d) FieldRVA					ֶαչRVAһֶεԭʼֵλ
'30(0x1e) ENCLog					Edit-And-ContinueģʽЩԪݱ޸Ĺ
'31(0x1f) ENCMap					Edit-And-Continueģʽеӳ
'32(0x20) Assembly					򼯶
'33(0x21) AssemblyProcessor			δʹ
'34(0x22) AssemblyOS				δʹ
'35(0x23) AssemblyRef				õĳ
'36(0x24) AssemblyRefProcessor		δʹ
'37(0x25) AssemblyRefOS				δʹ
'38(0x26) File						ⲿļ
'39(0x27) ExportedType				ͬһ򼯵ͬģ飬Щ
'40(0x28) ManifestResource			ԴϢ
'41(0x29) NestedClass				ǶͶ
'42(0x2a) GenericParam				˷Ͷ߷ͷʹõķͲ
'43(0x2b) MethodSpec				ͷʵ
'44(0x2c) GenericParamConstraint	ÿͲԼ

'======================================================================================
'ṹ: .NET #~ Assembly Table ṹ
'ṹС: 72ֽ
'ṹ˵: #~ Assembly Table
'======================================================================================
'Private Type IMAGE_ASSEMBLY_TABLE
'	HashAlgId 		As Long			'Ըóhash㷨һΪ0x8004ʾCALG_SHA/CALG_SHA1CALG_*Ϊǰ׺㷨wincrypt.hļУ
'	MajorVersion	As Integer		'Assembly汾
'	MinorVersion	As Integer		'Assemblyĸ汾
'	BuildNumber		As Integer		'Assemblyı
'	RevisionNumber	As Integer		'Assembly޶
'	Flags			As Long			'ԣҪAssemblyзʽһǿƱʶ
'	PublicKey()		As Byte			'2-4ֽڣǿƣʾǿ#Blobеƫƣ֮Ϊ0
'	Name()			As Byte			'2-4ֽڣָ#StringsеƫƣʾAssemblyƣ·չ
'	Locale()		As Byte			'2-4ֽڣָ#StringsеƫƣʾAssemblyĵԣen-US,fr-CA
'End Type

'======================================================================================
'ṹ: .NET #~ MethodDef Table ṹ
'ṹС: 72ֽ
'ṹ˵: #~ MethodDef Table
'======================================================================================
'Private Type IMAGE_METHODDEF_TABLE
'	RVA				As Long			'÷RVAͷIL롢쳣壩
'	ImplFlags		As Integer		'޶˷ִзʽabstractP/Invokeȣ
'	Flags			As Integer		'޶˷ĵԺһЩʣPublicPrivatevirtualȣ
'	Name()			As Byte			'2-4ֽڣָ#Stringsƫƣʾ÷
' 	Signature()		As Byte			'2-4ֽڣָ#BlobƫƣSignature˷ĵ÷ʽ緵ֵͣCalling Conventionȣ
' 	ParamList		As Integer		'ָParamָ˷Ĳ
'End Type

'======================================================================================
'ṹ: IMAGE_OPTIONAL_HEADER32
'ṹС: 224ֽ
'ṹ˵: ѡӳͷ
'======================================================================================
Private Type IMAGE_OPTIONAL_HEADER32
	'******************
	'׼
	'******************
	iMagic							As Integer		'&H18   32λPE&H10B64λPE&H20B
	bMajorLinkerVersion				As Byte			'&H1A   汾
	bMinorLinkerVersion				As Byte			'&H1B   ΰ汾
	lSizeOfCode						As Long			'&H1C   ִд볤
	lSizeOfInitializedData			As Long			'&H20   ʼݳ(ݽ)
	lSizeOfUninitializedData		As Long			'&H24   δʼݳ(bss)
	lAddressOfEntryPoint			As Long			'&H28   RVAַ,⿪ʼִ
	lBaseOfCode						As Long			'&H2C   ִдʼλ
	lBaseOfData						As Long			'&H30   ʼʼλ
	'******************
	'NT 
	'******************
	lImageBase						As Long			'&H34   ѡRVAַ(32λ)
	lSectionAlignment				As Long			'&H38   غڴеĶ뷽ʽ
	lFileAlignment					As Long			'&H3C   ļеĶ뷽ʽ
	iMajorOperatingSystemVersion	As Integer		'&H40   ϵͳ汾
	iMinorOperatingSystemVersion	As Integer		'&H42   ϵͳΰ汾
	iMajorImageVersion				As Integer		'&H44   ִļ汾
	iMinorImageVersion				As Integer		'&H46   ִļΰ汾
	iMajorSubsystemVersion			As Integer		'&H48   ϵͳ汾
	iMinorSubsystemVersion			As Integer		'&H50   ϵͳΰ汾
	lWin32VersionValue				As Long			'&H52   Win32汾,һΪ0
	lSizeOfImage					As Long			'&H56   ռڴС(С)
	lSizeOfHeaders					As Long			'&H5A   ͷС(С)
	lCheckSum						As Long			'&H5E   У
	iSubsystem						As Integer		'&H62   ִļϵͳ
	iDllCharacteristics				As Integer		'&H64   ʱDllMain,һΪ0
	lSizeOfStackReserve				As Long			'&H66   ʼ߳ʱջС
	lSizeOfStackCommit				As Long			'&H6A   ʼ߳ʱύջС
	lSizeOfHeapReserve				As Long			'&H6E   ̳ʼʱջС
	lSizeOfHeapCommit				As Long			'&H72   ̳ʼʱύջС
	lLoaderFlags					As Long			'&H76   װر־,
	lNumberOfRvaAndSizes			As Long			'&H7A   Ŀ¼,һΪ16
	DataDirectory(15) 				As IMAGE_DATA_DIRECTORY			'DataDirectory(14)
End Type

'======================================================================================
'ṹ: IMAGE_OPTIONAL_HEADER64
'ṹС: 240ֽ
'ṹ˵: ѡӳͷ
'======================================================================================
Private Type IMAGE_OPTIONAL_HEADER64
	'******************
	'׼
	'******************
	iMagic							As Integer		'&H18   32λPE&H10B64λPE&H20B
	bMajorLinkerVersion				As Byte			'&H1A   汾
	bMinorLinkerVersion				As Byte			'&H1B   ΰ汾
	lSizeOfCode						As Long			'&H1C   ִд볤
	lSizeOfInitializedData			As Long			'&H20   ʼݳ(ݽ)
	lSizeOfUninitializedData		As Long			'&H24   δʼݳ(bss)
	lAddressOfEntryPoint			As Long			'&H28   RVAַ,⿪ʼִ
	lBaseOfCode						As Long			'&H2C   ִдʼλ
	'lBaseOfData					As Long			'&H30   ʼʼλ
	'******************
	'NT 
	'******************
	dImageBase						As Double		'&H34   ѡRVAַ(64λ)
	lSectionAlignment				As Long			'&H38   غڴеĶ뷽ʽ
	lFileAlignment					As Long			'&H3C   ļеĶ뷽ʽ
	iMajorOperatingSystemVersion	As Integer		'&H40   ϵͳ汾
	iMinorOperatingSystemVersion	As Integer		'&H42   ϵͳΰ汾
	iMajorImageVersion				As Integer		'&H44   ִļ汾
	iMinorImageVersion				As Integer		'&H46   ִļΰ汾
	iMajorSubsystemVersion			As Integer		'&H48   ϵͳ汾
	iMinorSubsystemVersion			As Integer		'&H50   ϵͳΰ汾
	lWin32VersionValue				As Long			'&H52   Win32汾,һΪ0
	lSizeOfImage					As Long			'&H56   ռڴС(С)
	lSizeOfHeaders					As Long			'&H5A   ͷС(С)
	lCheckSum						As Long			'&H5E   У
	iSubsystem						As Integer		'&H62   ִļϵͳ
	iDllCharacteristics				As Integer		'&H64   ʱDllMain,һΪ0
	dSizeOfStackReserve				As Double		'&H66   ʼ߳ʱջС(64λ)
	dSizeOfStackCommit				As Double		'&H6A   ʼ߳ʱύջС(64λ)
	dSizeOfHeapReserve				As Double		'&H6E   ̳ʼʱջС(64λ)
	dSizeOfHeapCommit				As Double		'&H72   ̳ʼʱύջС(64λ)
	lLoaderFlags					As Long			'&H76   װر־,
	lNumberOfRvaAndSizes			As Long			'&H7A   Ŀ¼,һΪ16
	DataDirectory(15) 				As IMAGE_DATA_DIRECTORY
End Type


'======================================================================================
'ṹ: IMAGE_OPTIONAL_HEADER
'ṹС: 244ֽ
'ṹ˵: ѡӳͷڼ32λ64λPEΪ޷ض
'======================================================================================
Private Type IMAGE_OPTIONAL_HEADER
	'******************
	'׼
	'******************
	iMagic							As Integer		'&H18   32λPE&H10B64λPE&H20B
	bMajorLinkerVersion				As Byte			'&H1A   汾
	bMinorLinkerVersion				As Byte			'&H1B   ΰ汾
	lSizeOfCode						As Long			'&H1C   ִд볤
	lSizeOfInitializedData			As Long			'&H20   ʼݳ(ݽ)
	lSizeOfUninitializedData		As Long			'&H24   δʼݳ(bss)
	lAddressOfEntryPoint			As Long			'&H28   RVAַ,⿪ʼִ
	lBaseOfCode						As Long			'&H2C   ִдʼλ
	lBaseOfData						As Long			'&H30   ʼʼλ
	'******************
	'NT 
	'******************
	dImageBase						As Double		'&H34   ѡRVAַ(64λ)
	lSectionAlignment				As Long			'&H38   غڴеĶ뷽ʽ
	lFileAlignment					As Long			'&H3C   ļеĶ뷽ʽ
	iMajorOperatingSystemVersion	As Integer		'&H40   ϵͳ汾
	iMinorOperatingSystemVersion	As Integer		'&H42   ϵͳΰ汾
	iMajorImageVersion				As Integer		'&H44   ִļ汾
	iMinorImageVersion				As Integer		'&H46   ִļΰ汾
	iMajorSubsystemVersion			As Integer		'&H48   ϵͳ汾
	iMinorSubsystemVersion			As Integer		'&H50   ϵͳΰ汾
	lWin32VersionValue				As Long			'&H52   Win32汾,һΪ0
	lSizeOfImage					As Long			'&H56   ռڴС(С)
	lSizeOfHeaders					As Long			'&H5A   ͷС(С)
	lCheckSum						As Long			'&H5E   У
	iSubsystem						As Integer		'&H62   ִļϵͳ
	iDllCharacteristics				As Integer		'&H64   ʱDllMain,һΪ0
	dSizeOfStackReserve				As Double		'&H66   ʼ߳ʱջС(64λ)
	dSizeOfStackCommit				As Double		'&H6A   ʼ߳ʱύջС(64λ)
	dSizeOfHeapReserve				As Double		'&H6E   ̳ʼʱջС(64λ)
	dSizeOfHeapCommit				As Double		'&H72   ̳ʼʱύջС(64λ)
	lLoaderFlags					As Long			'&H76   װر־,
	lNumberOfRvaAndSizes			As Long			'&H7A   Ŀ¼,һΪ16
	DataDirectory(15) 				As IMAGE_DATA_DIRECTORY
End Type

'======================================================================================
'ṹ: IMAGE_NT_HEADERS
'ṹС: 248ֽ
'ṹ˵: NTӳͷ
'======================================================================================
Private Type IMAGE_NT_HEADERS32
	lSignature						As Long						'PEļͷ־("PE00",&H4550),4ֽ
	FileHeader						As IMAGE_FILE_HEADER		'PEļֲϢ,20ֽ
	OptionalHeader					As IMAGE_OPTIONAL_HEADER32	'PEļ߼ֲϢ,224ֽ
End Type

'======================================================================================
'ṹ: IMAGE_NT_HEADERS64
'ṹС: 264ֽ
'ṹ˵: NTӳͷ
'======================================================================================
Private Type IMAGE_NT_HEADERS64
	lSignature						As Long						'PEļͷ־("PE00",&H4550),4ֽ
	FileHeader						As IMAGE_FILE_HEADER		'PEļֲϢ,20ֽ
	OptionalHeader					As IMAGE_OPTIONAL_HEADER64	'PEļ߼ֲϢ,240ֽ
End Type

'======================================================================================
'ṹ: IMAGE_NT_HEADERS
'ṹС: 268ֽ
'ṹ˵: NTӳͷڼ32λ64λPEΪ޷ض
'======================================================================================
Public Type IMAGE_NT_HEADERS
	lSignature						As Long						'PEļͷ־("PE00",&H4550),4ֽ
	FileHeader						As IMAGE_FILE_HEADER		'PEļֲϢ,20ֽ
	OptionalHeader					As IMAGE_OPTIONAL_HEADER	'PEļ߼ֲϢ,244ֽ
End Type

'======================================================================================
'ṹ: IMAGE_SECTION_HEADER
'ṹС: 40ֽ
'ṹ˵: ӳͷ
'======================================================================================
Public Type IMAGE_SECTION_HEADER
	sName(7)						As Byte			'&H0    (8ַֽ)
	'lPhysicalAddress				As Long			'&H8    OBJļбʾڵַ
	lVirtualSize					As Long			'&H8    EXEļбʾڵʵֽ
	lVirtualAddress					As Long			'&HC    ڵRVA
	lSizeOfRawData					As Long			'&H10   ھļĳߴ
	lPointerToRawData				As Long			'&H14   ԭʼļеλ
	lPointerToRelocations			As Long			'&H18   OBJļбʾضλϢƫ,EXEļ
	lPointerToLineNumbers			As Long			'&H1C   кƫ
	iNumberOfRelocations			As Integer		'&H20   ضλĿ
	iNumberOfLineNumbers			As Integer		'&H22   кűекĿ
	lCharacteristics				As Long			'&H24   
End Type

'======================================================================================
'ṹ: IMAGE_IMPORT_DESCRIPTOR
'ṹС: 20ֽ
'ṹ˵: 
'======================================================================================
Private Type IMAGE_IMPORT_DESCRIPTOR
	'Characteristics				As Long			'0 For terminating Null import descriptor
	OriginalFirstThunk				As Long			'RVA To original unbound IAT (PIMAGE_THUNK_DATA)
	TimeDateStamp					As Long			'0 if not bound
	ForwarderChain					As Long			'-1 if no forwarders
	pName							As Long
	FirstThunk						As Long			'RVA to IAT (if bound this IAT has actual addresses)
End Type
 
'======================================================================================
'ṹ: IMAGE_EXPORT_DIRECTORY
'ṹС: 20ֽ
'ṹ˵: 
'======================================================================================
Private Type IMAGE_EXPORT_DIRECTORY
	Characteristics					As Long
	TimeDateStamp					As Long
	MajorVersion					As Integer
	MinorVersion					As Integer
	pName							As Long
	Base							As Long
	NumberOfFunctions				As Long
	NumberOfNames					As Long
	AddressOfFunctions				As Long
	AddressOfNames					As Long
	AddressOfNameOrdinals			As Long
End Type

Private Type IMPORT_API_LOOKUP
	ApiName							As String
	Address							As Long
End Type

Private Type IMPORT_LIST_TYPE
	strName							As String
	strGuid							As String
	strLib							As String
End Type

Private Type IMAGE_IMPORT_BY_NAME
	Hint							As Integer		'
	pName(259)						As Byte			'
End Type

Private Type IMAGE_THUNK_DATA
	AddressOfData					As Long			'ָ IMAGE_IMPORT_BY_NAME ָ
End Type

Private Type IMAGE_THUNK_DATA32
	pForwarderString				As Long			'RVA,ָ뺯ָ
	pFunction						As Long			'뺯32λڴַ
	Ordinal							As Long			'жǰṹǲΪģǵĻֵΪ0x800000000
	AddressOfData					As Long			'ָ IMAGE_IMPORT_BY_NAME ָ
End Type
 
Private Type IMAGE_THUNK_DATA64
	pForwarderString				As Double		'RVA,ָ뺯ָ
	pFunction						As Double		'뺯64λڴַ
	Ordinal							As Double		'жǰṹǲΪģǵĻֵΪ0x800000000
	AddressOfData					As Double		'ָ IMAGE_IMPORT_BY_NAME ָ
End Type

'ض
Private Type IMAGE_BASE_RELOCATION
	VirtualAddress					As Long			'ضλݿʼRVAַ
	SizeOfBlock						As Long			'ضλó
	TypeOffset						As Integer		'ضλ
End Type

'typedef struct _IMAGE_IMPORT_DESCRIPTOR {
'    union {
'        DWORD   Characteristics;            // 0 for terminating null import descriptor
'        DWORD   OriginalFirstThunk;         // RVA to original unbound IAT (PIMAGE_THUNK_DATA)
'    };
'    DWORD   TimeDateStamp;                  // 0 if not bound,
'                                            // -1 if bound, and real date/time stamp
'                                            //     in IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT (new BIND)
'                                            // O.W. date/time stamp of DLL bound to (Old BIND)
'
'    DWORD   ForwarderChain;                 // -1 if no forwarders
'    DWORD   Name;
'    DWORD   FirstThunk;                     // RVA to IAT (if bound this IAT has actual addresses)
'} IMAGE_IMPORT_DESCRIPTOR;
'typedef IMAGE_IMPORT_DESCRIPTOR UNALIGNED *PIMAGE_IMPORT_DESCRIPTOR;
 
'typedef struct _IMAGE_EXPORT_DIRECTORY {
'    DWORD   Characteristics;
'    DWORD   TimeDateStamp;
'    WORD    MajorVersion;
'    WORD    MinorVersion;
'    DWORD   Name;
'    DWORD   Base;
'    DWORD   NumberOfFunctions;
'    DWORD   NumberOfNames;
'    DWORD   AddressOfFunctions;     // RVA from base of image
'    DWORD   AddressOfNames;         // RVA from base of image
'    DWORD   AddressOfNameOrdinals;  // RVA from base of image
'} IMAGE_EXPORT_DIRECTORY, *PIMAGE_EXPORT_DIRECTORY;
 
'typedef struct _IMAGE_IMPORT_BY_NAME {
'    WORD    Hint;
'    BYTE    Name[1];
'} IMAGE_IMPORT_BY_NAME, *PIMAGE_IMPORT_BY_NAME;
 
'typedef struct _IMAGE_THUNK_DATA32 {
'    union {
'        PBYTE  ForwarderString;
'        PDWORD Function;
'        DWORD Ordinal;
'        PIMAGE_IMPORT_BY_NAME  AddressOfData;
'    } u1;
'} IMAGE_THUNK_DATA32;
'typedef IMAGE_THUNK_DATA32 * PIMAGE_THUNK_DATA32;
 

'======================================================================================
'ṹ: IMAGE_RESOURCE_DIRECTORY
'ṹС: 16ֽ
'ṹ˵: ԴĿ¼
'======================================================================================
Private Type IMAGE_RESOURCE_DIRECTORY
	Characteristics				As Long			'ʶԴ
	TimeStamp					As Long			'ԴԴʱ
	MajorVersion				As Integer		'Դ汾
	MinorVersion				As Integer		'Դΰ汾
	NumberOfNamedEntries		As Integer		'ַбʶIMAGE_RESOURCE_DIRECTORY_ENTRYĳԱ
	NumberofIDEntries			As Integer		'бʶIMAGE_RESOURCE_DIRECTORY_ENTRYĳԱ
End Type

'======================================================================================
'ṹ: IMAGE_RESOURCE_DIRECTORY_ENTRY
'ṹС: 8ֽ
'ṹ˵: ԴĿ¼
'======================================================================================
Private Type IMAGE_RESOURCE_DIRECTORY_ENTRY
	Name						As Long
	Offset						As Long
End Type

'======================================================================================
'ṹ: IMAGE_RESOURCE_DIRECTORY_ENTRY
'ṹС: 16ֽ
'ṹ˵: Դ
'======================================================================================
Private Type IMAGE_RESOURCE_DATA_ENTRY
	OffsetToData				As Long			'һڴеRVAתļеλ
	Size						As Long			'ԴĴСֽΪλ
	CodePage					As Long			'ҳ
	Reserved					As Long			'
End Type

'======================================================================================
'ṹ: IMAGE_RESOURCE_DIRECTORY_STRING
'ṹС:
'ṹ˵:ԴĿ¼
'======================================================================================
Private Type IMAGE_RESOURCE_DIRECTORY_STRING
	Length						As Long			'Դ
	NameString					As String		'ַ
End Type

'Դ
'Private Type IconDescriptor
'	ID					As Long
'	offset				As Long
'	Size				As Long
'End Type
 
Private Type EXPORT_INFO
	strDllName					As String
	strFuns()					As String
End Type
 
Private Type IMPORT_DETAIL_INFO
	strDllName					As String
	strFuns()					As String
End Type
 
Private Type IMPORT_INFO
	strExePath					As String
	pDetailInfo()				As IMPORT_DETAIL_INFO
End Type

'ļ
Private Type DATA_FILE_PROPERTIE
	SourceFileName		 		As String		'ļԴļ
	SourceFileVersion			As String		'ļԴļ汾
	SourceFileSize				As Long			'ļԴļС
	SourceFileDateTime			As Date			'ļԴļ޸
	SourceFileLangID			As String		'ļԴļID
	AppVersion					As String		'ļõĺ汾
	DateLastModified			As Date			'ļ޸
	FilePath					As String		'ļ· (ļ)
	FileFormat					As Boolean		'ļĸʽTure ΪҪ
End Type

'ļ
Public Type FILE_PROPERTIE
	CompanyName					As String		'˾
	FileDescription				As String		'ļ
	FileVersion					As String		'ļ汾
	InternalName				As String		'ڲ
	LegalCopyright				As String		'Ȩ
	OrigionalFileName			As String		'ԭʼļ
	ProductName					As String		'Ʒ
	ProductVersion				As String		'Ʒ汾
	LanguageID					As String		'ID
	FileSize					As Long			'ļС
	DateCreated					As Date			'ļ
	DateLastModified			As Date			'ļ޸
	CopePage					As Long			'ļҳ
	FileName					As String		'ļ (·)
	FilePath					As String		'ļ· (ļ)
	MinSecID 					As Integer		'Сƫƿʼַڽ
	MaxSecID 					As Integer		'ƫƿʼַڽ
	USStreamID 					As Integer		'.NET ַ
	PEBitType					As Long			'ļ(32λ=224+24,64λ=240+24ֽ)
	PELangType					As Long			'ļıд
	iNumberOfSubPE				As Integer		'Ƕ PE 
	DosHeader 					As IMAGE_DOS_HEADER
	PEHeader 					As IMAGE_NT_HEADERS
	PEHeader32 					As IMAGE_NT_HEADERS32
	PEHeader64 					As IMAGE_NT_HEADERS64
	SecHeader() 				As IMAGE_SECTION_HEADER
	HideSecHeader 				As IMAGE_SECTION_HEADER
	CLRHeader					As IMAGE_CLR20_HEADER
	MetaDataHeader				As IMAGE_METADATA_HEADER
	StreamHeader()				As IMAGE_STREAM_HEADER
	hcsFile						As DATA_FILE_PROPERTIE
End Type

Private PEImport As IMAGE_IMPORT_DESCRIPTOR
Private PEExport As IMAGE_EXPORT_DIRECTORY
Private pIMPTable As IMAGE_IMPORT_BY_NAME
'Public FN As LOADED_IMAGE
'Public pExportInfo As EXPORT_INFO
'Public pImportInfo As IMPORT_INFO

'***************************************************************************************************************************************************
'ڶȡļ汾Ϣ
Private Declare Function GetFileVersionInfo Lib "Version.dll" Alias "GetFileVersionInfoA" ( _
	ByVal lptstrFilename As String, _
	ByVal dwhandle As Long, _
	ByVal dwlen As Long, _
	lpData As Any) As Long
Private Declare Function GetFileVersionInfoSize Lib "Version.dll" Alias "GetFileVersionInfoSizeA" ( _
	ByVal lptstrFilename As String, _
	lpdwHandle As Long) As Long
Private Declare Function VerQueryValue Lib "Version.dll" Alias "VerQueryValueA" ( _
	pBlock As Any, _
	ByVal lpSubBlock As String, _
	lplpBuffer As Any, _
	puLen As Long) As Long
'Private Declare Sub MoveMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
'	Dest As Any, _
'	ByVal Source As Long, _
'	ByVal Length As Long)
Private Declare Function lstrcpy Lib "kernel32.dll" Alias "lstrcpyA" ( _
	ByVal lpString1 As String, _
	ByVal lpString2 As Long) As Long

'MapAndLoad Ľṹ(48ֽ)
'Public Type LOADED_IMAGE
'	ModuleName					As Long			'ļļ
'	hFile						As Long			' Create ļӳľ
'	MappedAddress				As Long			'ļӳ䵽ڴַ
'	pFileHeader					As Long			'ָӳļ IMAGE_PE_FILE_HEADER ָ
'	pLastRvaSection				As Long			'ֵΪһ Section
'	NumberOfSections			As Long			'ص PE ļ Sections Ŀ
'	pSections					As Long			'ָӳļĵһ Section Header
'	Characteristics				As Long			'PE ļֵ
'	fSystemImage				As Byte			'ָʾǷںģʽ/DLL ı־
'	fDOSImage					As Byte			'ָʾǷ DOS ִļı־
'	Links(7)					As Byte			'ص Images б
'	SizeOfImage					As Long			'ӳ Image С
'End Type

'ڶдļ
Private Declare Function CreateFile Lib "kernel32.dll" Alias "CreateFileA" ( _
	ByVal lpFileName As String, _
	ByVal dwDesiredAccess As Long, _
	ByVal dwShareMode As Long, _
	ByVal lpSecurityAttributes As Long, _
	ByVal dwCreationDisposition As Long, _
	ByVal dwFlagsAndAttributes As Long, _
	ByVal hTemplateFile As Long) As Long
Private Declare Function SetFilePointer Lib "kernel32.dll" ( _
	ByVal lngFile As Long, _
	ByVal lDistanceToMove As Long, _
	lpDistanceToMoveHigh As Long, _
	ByVal dwMoveMethod As Long) As Long
Private Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Long) As Long
Private Declare Function ReadFile Lib "kernel32.dll" ( _
	ByVal lngFile As Long, _
	lpBuffer As Any, _
	ByVal nNumberOfBytesToRead As Long, _
	lpNumberOfBytesRead As Long, _
	ByVal lpOverlapped As Long) As Long
Private Declare Function WriteFile Lib "kernel32.dll" ( _
	ByVal hFile As Long, _
	ByVal lpBuffer As Long, _
	ByVal nNumberOfBytesToWrite As Long, _
	lpNumberOfBytesWritten As Long, _
	ByVal lpOverlapped As Long) As Long
Private Declare Function GetFileSize Lib "kernel32.dll" ( _
	ByVal hFile As Long, _
	ByVal lpFileSizeHigh As Long) As Long
Private Declare Function SetEndOfFile Lib "kernel32.dll" (ByVal hFile As Long) As Long

'ļӳ亯
Private Declare Function CreateFileMapping Lib "kernel32.dll" Alias "CreateFileMappingA" ( _
	ByVal hFile As Long, _
	ByVal lpFileMappigAttributes As Long, _
	ByVal flProtect As Long, _
	ByVal dwMaximumSizeHigh As Long, _
	ByVal dwMaximumSizeLow As Long, _
	ByVal lpName As String) As Long
Private Declare Function MapViewOfFile Lib "kernel32.dll" ( _
	ByVal hFileMappingObject As Long, _
	ByVal dwDesiredAccess As Long, _
	ByVal dwFileOffsetHigh As Long, _
	ByVal dwFileOffsetLow As Long, _
	ByVal dwNumberOfBytesToMap As Long) As Long
Private Declare Function MapViewOfFileEx Lib "kernel32.dll" ( _
	ByVal hFileMappingObject As Long, _
	ByVal dwDesiredAccess As Long, _
	ByVal dwFileOffsetHigh As Long, _
	ByVal dwFileOffsetLow As Long, _
	ByVal dwNumberOfBytesToMap As Long, _
	lpBaseAddress As Any) As Long
Private Declare Function UnmapViewOfFile Lib "kernel32.dll" (ByVal lpBaseAddress As Long) As Long
Private Declare Function FlushViewOfFile Lib "kernel32.dll" ( _
	ByVal lpBaseAddress As Long, _
	ByVal dwNumberOfBytesToFlush As Long) As Long
'Public Declare Function MapAndLoad Lib "imagehlp.dll" ( _
'	ByVal ImageName As String, _
'	ByVal DllPath As String, _
'	LoadedImage As LOADED_IMAGE, _
'	ByVal DotDll As Boolean, _
'	ByVal ReadOnly As Boolean) As Boolean
	'ImageName	 PE ļļ
	'DllPath λļ· Null PATH е·
	'LoadedImage ṹ LOADED_IMAGE  IMAGEHLP.H file
	'DotDll ҪҸļûָչʹ .exe  .dll չ
	' DotDll ־Ϊ Trueʹ .dll չ;  .exe չ
	'ReadOnly Ϊ TrueļӳΪ Read-only
	'ֵ ɹ True; 򷵻 False
'Public Declare Function UnMapAndLoad Lib "imagehlp.dll" (LoadedImage As LOADED_IMAGE) As Boolean
	'ʹӳļӦõ UnMapAndLoad()  ˺ PE ļӳ䲢 MapAndLoad() Դ
	'LoadedImage ָ LOADED_IMAGE ṹָ룬ָǰ MapAndLoad() صָ롣
	'ֵ ɹ򷵻 True; 򷵻 False
Private Declare Function ImageRvaToVa Lib "imagehlp.dll" ( _
	ByVal NtHeaders As Long, _
	ByVal hBase As Long, _
	ByVal RVA As Long, _
	ByVal LastRvaSection As Long) As Long   'Ҳ dbghelp.dll

'ʾϢ
Private Declare Function GetLastError Lib "kernel32.dll" () As Long
Private Declare Function FormatMessage Lib "kernel32.dll" Alias "FormatMessageA" ( _
	ByVal dwFlags As Long, _
	lpSource As Any, _
	ByVal dwMessageId As Long, _
	ByVal dwLanguageId As Long, _
	ByVal lpBuffer As String, _
	ByVal nSize As Long, _
	Arguments As Long) As Long

'޸ļʱ
Private Type FILETIME
	dwLowDateTime As Long
	dwHighDateTime As Long
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

'޸ļʱԺ
Private Declare Function SetFileTime Lib "kernel32.dll" ( _
	ByVal hFile As Long, _
	lpCreationTime As FILETIME, _
	lpLastAccessTime As FILETIME, _
	lpLastWriteTime As FILETIME) As Long
Private Declare Function LocalFileTimeToFileTime Lib "kernel32.dll" ( _
	lpLocalFileTime As FILETIME, _
	lpFileTime As FILETIME) As Long
Private Declare Function SystemTimeToFileTime Lib "kernel32.dll" ( _
	lpSystemTime As SYSTEMTIME, _
	lpFileTime As FILETIME) As Long


'ļǷѱ򿪻ռ
Public Function IsOpen(ByVal strFilePath As String,Optional ByVal Continue As Long = 3,Optional ByVal WaitTime As Double = 0.5) As Boolean
	Dim i As Long,FN As Variant
	'Դļ
	On Error Resume Next
	FN = FreeFile
	Do
		Open strFilePath For Binary Access Read Lock Write As #FN
		If Err.Number = 0 Or i > 10 Then Exit Do
		Wait WaitTime
		Err.Clear
		i = i + 1
	Loop
	Close #FN
	If Err.Number = 0 Then Exit Function
	ErrorHandle:
	IsOpen = True
	Err.Source = "NotOpenFile"
	Err.Description = Err.Description & JoinStr & strFilePath
	Call sysErrorMassage(Err,Continue)
End Function


'ȡļ汾Ϣ
Public Function GetFileInfo(ByVal strFilePath As String,File As FILE_PROPERTIE) As Boolean
	Dim lngBufferlen As Long,lngRc As Long,lngVerPointer As Long
	Dim bytBuffer() As Byte,bytBuff(255) As Byte
	Dim strBuffer As String,strLangCharset As String,strVersionInfo(7) As String
	Dim strTemp As String,i As Integer
	'ļѴʱ˳
	If IsOpen(strFilePath) = True Then Exit Function
	' get file size
	lngBufferlen = GetFileVersionInfoSize(strFilePath, 0&)
	If lngBufferlen > 0 Then
		ReDim bytBuffer(lngBufferlen) As Byte
		lngRc = GetFileVersionInfo(strFilePath, 0&, lngBufferlen, bytBuffer(0))
		If lngRc <> 0 Then
			lngRc = VerQueryValue(bytBuffer(0), "\VarFileInfo\Translation", lngVerPointer, lngBufferlen)
			If lngRc <> 0 Then
				'lngVerPointer is a pointer to four 4 bytes of Hex number,
				'first two bytes are language id, and last two bytes are code
				'page. However, strLangCharset needs a  string of
				'4 hex digits, the first two characters correspond to the
				'language id and last two the last two character correspond
				'to the code page id.
				MoveMemory bytBuff(0), lngVerPointer, lngBufferlen
				strLangCharset = Hex(bytBuff(2) + bytBuff(3) * &H100 + bytBuff(0) * &H10000 + bytBuff(1) * &H1000000)
				'now we change the order of the language id and code page
				'and convert it into a string representation.
				'For example, it may look like 040904E4
				'Or to pull it all apart:
				'04------        = SUBLANG_ENGLISH_USA
				'--09----        = LANG_ENGLISH
				' ----04E4 = 1252 = Codepage for Windows:Multilingual

				'If Len(strLangCharset) - 2 >= 2 Then
				'    If Mid$(strLangCharset, 2, 2) = LANG_ENGLISH Then
				'    	strLangCharset2 = "English (US)"
				'    End If
				'End If

				Do While Len(strLangCharset) < 8
					strLangCharset = "0" & strLangCharset
				Loop

				' assign propertienames
				strVersionInfo(0) = "CompanyName"
				strVersionInfo(1) = "FileDescription"
				strVersionInfo(2) = "FileVersion"
				strVersionInfo(3) = "InternalName"
				strVersionInfo(4) = "LegalCopyright"
				strVersionInfo(5) = "OriginalFileName"
				strVersionInfo(6) = "ProductName"
				strVersionInfo(7) = "ProductVersion"
				' loop and get FILE_PROPERTIEs
				For i = 0 To 7
					strBuffer = String$(255, 0)
					strTemp = "\StringFileInfo\" & strLangCharset & "\" & strVersionInfo(i)
					lngRc = VerQueryValue(bytBuffer(0), strTemp, lngVerPointer, lngBufferlen)
					If lngRc <> 0 Then
						' get and format data
						lstrcpy strBuffer, lngVerPointer
						strVersionInfo(i) = Replace$(strBuffer,vbNullChar,"")
					Else
						' property not found
						strVersionInfo(i) = ""
					End If
				Next i
			End If
		End If
	End If
	' assign array to user-defined-type
	File.CompanyName = strVersionInfo(0)
	File.FileDescription = strVersionInfo(1)
	File.FileVersion = Trim$(strVersionInfo(2))
	File.InternalName = strVersionInfo(3)
	File.LegalCopyright = strVersionInfo(4)
	File.OrigionalFileName = strVersionInfo(5)
	File.ProductName = strVersionInfo(6)
	File.ProductVersion = strVersionInfo(7)
	File.LanguageID = Left$(strLangCharset,4)
	File.FileName = Mid$(File.FilePath,InStrRev(File.FilePath,"\") + 1)
	File.FileSize = FileLen(strFilePath)
	File.DateLastModified = FileDateTime(strFilePath)
	File.DateCreated = GetFileDate(strFilePath,0)
	GetFileInfo = True
End Function


'ȡļĴʡ޸
'Mode = 0 
'Mode = 1 
'Mode = 2 ޸
Public Function GetFileDate(ByVal strFilePath As String,ByVal Mode As Long) As Date
	Dim fso As Object,Obj As Object
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set Obj = fso.GetFile(strFilePath)
	If Mode = 0 Then
		GetFileDate = Obj.DateCreated
	ElseIf Mode = 1 Then
		GetFileDate = Obj.DateLastAccessed
	Else
		GetFileDate = Obj.DateLastModified
	End If
	Set fso = Nothing: Set Obj = Nothing
End Function


'ȡļļݽṹϢ
Public Function GetHeaders(ByVal strFilePath As String,File As FILE_PROPERTIE,ByVal Mode As Long) As Boolean
	Dim i As Long,FN As FILE_IMAGE,TempList() As String,Temp As String
	On Error GoTo ExitFunction
	'ļ
	Mode = LoadFile(strFilePath,FN,0,0,0,Mode)
	If Mode < -1 Then Exit Function
	'ȡļͷ
	GetHeaders = GetHeader(FN,File,Mode)
	If GetHeaders = False Then GoTo ExitFunction
	'ȡļͷ
	With File.HideSecHeader
		If .lSizeOfRawData = 0 Then GoTo ExitFunction
		Temp = ByteToString(GetBytes(FN,.lSizeOfRawData,.lPointerToRawData,Mode),CP_ISOLATIN1)
		TempList = GetVAListRegExp(Temp,"MZ[\x00-\xFF]{64,384}?PE\x00",.lPointerToRawData)
		If CheckArray(TempList) = False Then GoTo ExitFunction
		Dim SubFile As FILE_PROPERTIE
		File.iNumberOfSubPE = UBound(TempList) + 1
		For i = 0 To File.iNumberOfSubPE - 1
			If GetHeader(FN,SubFile,Mode,CLng(TempList(i))) = True Then
				'޸ļؽڴС
				.lSizeOfRawData = CLng(TempList(i)) - .lPointerToRawData
				Exit For
			End If
		Next i
		ExitFunction:
	End With
	'رļ
	On Error Resume Next
	UnLoadFile(FN,0,Mode)
End Function


'ȡļݽṹϢ
Private Function GetHeader(FN As FILE_IMAGE,File As FILE_PROPERTIE,ByVal Mode As Long,Optional ByVal Offset As Long) As Boolean
	Dim DosHeader As IMAGE_DOS_HEADER,PEHeader As IMAGE_NT_HEADERS
	Dim PEHeader32 As IMAGE_NT_HEADERS32,PEHeader64 As IMAGE_NT_HEADERS64
	Dim CLRHeader As IMAGE_CLR20_HEADER,MetaDataHeader As IMAGE_METADATA_HEADER
	On Error GoTo ExitFunction
	With File
		'ʼ
		.PEBitType = 0
		.PELangType = 0
		.MinSecID = 0
		.MaxSecID = 0
		.HideSecHeader.lPointerToRawData = 0
		.HideSecHeader.lSizeOfRawData = 0
		.HideSecHeader.lVirtualAddress = 0
		.HideSecHeader.lVirtualSize = 0
		.iNumberOfSubPE = 0
		.DosHeader = DosHeader
		.PEHeader = PEHeader
		.PEHeader32 = PEHeader32
		.PEHeader64 = PEHeader64
		.CLRHeader = CLRHeader
		.MetaDataHeader = MetaDataHeader
		.USStreamID = -1
		ReDim File.SecHeader(0) 'As IMAGE_SECTION_HEADER
		ReDim File.StreamHeader(0) 'As IMAGE_STREAM_HEADER
		'ȡ PE IMAGE_DOS_HEADERS ṹ
		'GetTypeValue(FN,Offset,.DosHeader,Mode)
		Select Case Mode
		Case Is < 0
			Get #FN.hFile, Offset + 1, .DosHeader
		Case 0
			CopyMemory .DosHeader, FN.ImageByte(Offset), Len(.DosHeader)
		Case Else
			MoveMemory .DosHeader, Offset + FN.MappedAddress, Len(.DosHeader)
		End Select
		If .DosHeader.iSignature <> IMAGE_DOS_SIGNATURE Then GoTo ExitFunction
		'Ǳ
		.PELangType = .DosHeader.iLastPageBytes
		'32λȡ PE IMAGE_NT_HEADERS ṹ
		'GetTypeValue(FN,Offset + .DosHeader.lPointerToPEHeader,.PEHeader32,Mode)
		Select Case Mode
		Case Is < 0
			Get #FN.hFile, Offset + .DosHeader.lPointerToPEHeader + 1, .PEHeader32
		Case 0
			CopyMemory .PEHeader32, FN.ImageByte(Offset + .DosHeader.lPointerToPEHeader), Len(.PEHeader32)
		Case Else
			MoveMemory .PEHeader32, Offset + FN.MappedAddress + .DosHeader.lPointerToPEHeader, Len(.PEHeader32)
		End Select
		If .PEHeader32.lSignature <> IMAGE_NT_SIGNATURE Then GoTo ExitFunction
		'жǷΪ32λPEļ
		If .PEHeader32.OptionalHeader.iMagic = IMAGE_NT_OPTIONAL_HDR32_MAGIC Then
			'ת32λ PE IMAGE_NT_HEADERS ṹݵPE IMAGE_NT_HEADERS ṹ
			If CovertPEHeader32(.PEHeader,.PEHeader32) = False Then GoTo ExitFunction
			'Ƿļڽṹ
			If .PEHeader.FileHeader.iNumberOfSections = 0 Then GoTo ExitFunction
			'ȡļڽṹ
			ReDim File.SecHeader(.PEHeader.FileHeader.iNumberOfSections - 1) 'As IMAGE_SECTION_HEADER
			'GetTypeArray(FN,Offset + .DosHeader.lPointerToPEHeader + Len(.PEHeader32),.SecHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, Offset + .DosHeader.lPointerToPEHeader + Len(.PEHeader32) + 1, .SecHeader
			Case 0
				CopyMemory .SecHeader(0), FN.ImageByte(Offset + .DosHeader.lPointerToPEHeader + Len(.PEHeader32)), Len(.SecHeader(0)) * (UBound(.SecHeader) + 1)
			Case Else
				MoveMemory .SecHeader(0), Offset + FN.MappedAddress + .DosHeader.lPointerToPEHeader + Len(.PEHeader32), Len(.SecHeader(0)) * (UBound(.SecHeader) + 1)
			End Select
			'ȡļ Bit λ
			.PEBitType = FILE_BIT_TYPE32
		ElseIf .PEHeader32.OptionalHeader.iMagic = IMAGE_NT_OPTIONAL_HDR64_MAGIC Then
			'64λȡ PE IMAGE_NT_HEADERS ṹ
			'GetTypeValue(FN,Offset + .DosHeader.lPointerToPEHeader,.PEHeader64,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, Offset + .DosHeader.lPointerToPEHeader + 1, .PEHeader64
			Case 0
				CopyMemory .PEHeader64, FN.ImageByte(Offset + .DosHeader.lPointerToPEHeader), Len(.PEHeader64)
			Case Else
				MoveMemory .PEHeader64, Offset + FN.MappedAddress + .DosHeader.lPointerToPEHeader, Len(.PEHeader64)
			End Select
			'ת64λ PE IMAGE_NT_HEADERS ṹݵPE IMAGE_NT_HEADERS ṹ
			If CovertPEHeader64(.PEHeader,.PEHeader64) = False Then GoTo ExitFunction
			'Ƿļڽṹ
			If .PEHeader.FileHeader.iNumberOfSections = 0 Then GoTo ExitFunction
			'ȡļڽṹ
			ReDim File.SecHeader(.PEHeader.FileHeader.iNumberOfSections - 1) 'As IMAGE_SECTION_HEADER
			'GetTypeArray(FN,Offset + .DosHeader.lPointerToPEHeader + Len(.PEHeader64),.SecHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, Offset + .DosHeader.lPointerToPEHeader + Len(.PEHeader64) + 1, .SecHeader
			Case 0
				CopyMemory .SecHeader(0), FN.ImageByte(Offset + .DosHeader.lPointerToPEHeader + Len(.PEHeader64)), Len(.SecHeader(0)) * (UBound(.SecHeader) + 1)
			Case Else
				MoveMemory .SecHeader(0), Offset + FN.MappedAddress + .DosHeader.lPointerToPEHeader + Len(.PEHeader64), Len(.SecHeader(0)) * (UBound(.SecHeader) + 1)
			End Select
			'ȡļ Bit λ
			.PEBitType = FILE_BIT_TYPE64
		Else
			GoTo ExitFunction
		End If
		'ȡ .NET ͷṹ
		If GetNETHeader(FN,File,Mode,Offset) = True Then .PELangType = NET_FILE_SIGNATURE
		'ȡСƫƵַڽڵ
		GetSectionID(.SecHeader,.MinSecID,.MaxSecID,False)
		'ȡؽϢ
		.HideSecHeader.lPointerToRawData = .SecHeader(.MaxSecID).lPointerToRawData + .SecHeader(.MaxSecID).lSizeOfRawData
		.HideSecHeader.lSizeOfRawData = GetFileLength(FN,Mode) - .HideSecHeader.lPointerToRawData
		.HideSecHeader.lVirtualAddress = .SecHeader(.MaxSecID).lVirtualAddress + .SecHeader(.MaxSecID).lVirtualSize
		.HideSecHeader.lVirtualSize = .HideSecHeader.lSizeOfRawData
		'ǳɹ
		GetHeader = True
		ExitFunction:
		If GetHeader = True Then Exit Function
		'ļΪһ
		.SecHeader(0).lSizeOfRawData = GetFileLength(FN,Mode)
		.SecHeader(0).lVirtualSize = .SecHeader(0).lVirtualSize
		'ؽϢʾļϢ
		.HideSecHeader.lPointerToRawData = .SecHeader(0).lSizeOfRawData
		.HideSecHeader.lVirtualAddress = .SecHeader(0).lSizeOfRawData
	End With
End Function


'ȡ .NET ͷṹ
Private Function GetNETHeader(FN As FILE_IMAGE,File As FILE_PROPERTIE,ByVal Mode As Long,Optional ByVal Offset As Long) As Boolean
	Dim i As Long,Length As Long,dwOffset As Long
	On Error GoTo ExitFunction
	With File
		'ת15Ŀ¼ַתƫƵַ
		dwOffset = RvaToOffset(File,.PEHeader.OptionalHeader.DataDirectory(14).lVirtualAddress)
		If dwOffset = 0 Then GoTo ExitFunction
		'ȡ CLR ṹ
		'GetTypeValue(FN,Offset + dwOffset,.CLRHeader,Mode)
		Select Case Mode
		Case Is < 0
			Get #FN.hFile, Offset + dwOffset + 1, .CLRHeader
		Case 0
			CopyMemory .CLRHeader, FN.ImageByte(Offset + dwOffset), Len(.CLRHeader)
		Case Else
			MoveMemory .CLRHeader, Offset + FN.MappedAddress + dwOffset, Len(.CLRHeader)
		End Select
		'ת CLR е MetaData ַתƫƵַ
		dwOffset = RvaToOffset(File,.CLRHeader.METADATA.lVirtualAddress)
		If dwOffset = 0 Then GoTo ExitFunction
	End With
	'ǷΪ .NET ļ
	With File.MetaDataHeader
		.lSignature = GetLong(FN,Offset + dwOffset,Mode)
		If .lSignature <> NET_FILE_SIGNATURE Then GoTo ExitFunction
		'ȡ MetaDataHeader.Version ֽڳ
		.lLength = GetLong(FN,Offset + dwOffset + 12,Mode)
		' 4 ֽڶ MetaDataHeader.Version ֽڳ
		If .lLength Mod 4 <> 0 Then .lLength = 4 * (.lLength \ 4 + 1)
		'ȡ METADATA ṹ
		.iMajorVersion = GetInteger(FN,Offset + dwOffset + 4,Mode)
		.iMinorVersion = GetInteger(FN,Offset + dwOffset + 6,Mode)
		.lExtraData = GetLong(FN,Offset + dwOffset + 8,Mode)
		.Version = GetBytes(FN,.lLength,Offset + dwOffset + 16,Mode)
		.fFlags = GetInteger(FN,Offset + dwOffset + 16 + .lLength,Mode)
		.iStreams = GetInteger(FN,Offset + dwOffset + 18 + .lLength,Mode)
	End With
	'ȡļͷṹ
	With File
		If .MetaDataHeader.iStreams > 0 Then
			ReDim File.StreamHeader(.MetaDataHeader.iStreams - 1) 'As IMAGE_STREAM_HEADER
			dwOffset = dwOffset + 20 + .MetaDataHeader.lLength
			For i = 0 To .MetaDataHeader.iStreams - 1
				'lOffset  Metadata Rootʵ RVA = .CLRHeader.MetaData.lVirtualAddress + .StreamHeader(i).lOffset
				.StreamHeader(i).RWA = dwOffset + 0
				.StreamHeader(i).lOffset = GetLong(FN,Offset + dwOffset + 0,Mode)
				.StreamHeader(i).lSize = GetLong(FN,Offset + dwOffset + 4,Mode)
				'ȡ .StreamHeader.rcName ֽڳ
				dwOffset = dwOffset + 8
				Length = getNullByteLong(FN,Offset + dwOffset,Offset + dwOffset + 16,Mode) - dwOffset + 1
				' 4 ֽڶ .StreamHeader.rcName ֽڳ
				If Length Mod 4 <> 0 Then Length = 4 * (Length \ 4 + 1)
				.StreamHeader(i).rcName = GetBytes(FN,Length,Offset + dwOffset,Mode)
				If UCase$(Replace$(StrConv$(.StreamHeader(i).rcName,vbUnicode),vbNullChar,"")) = "#US" Then
					.USStreamID = i
				End If
				dwOffset = dwOffset + Length
			Next i
		End If
	End With
	'ǳɹ
	GetNETHeader = True
	ExitFunction:
End Function


'ȡ (ļ)
Private Function GetImportTableByAPI(ByVal strFilePath As String,File As FILE_PROPERTIE,pImportInfo As IMPORT_INFO) As Boolean
	Dim FN As FILE_IMAGE,strTmp As String,i As Integer,j As Integer,lngTunk As Long
	Dim bytBuffer(129) As Byte,hAddr As Long,dwReads As Long,RvaAddrLength As Long

	With File
		'Ƿṹ
		If .PEHeader.OptionalHeader.DataDirectory(1).lVirtualAddress = 0 Then
			Exit Function
		End If

		'ʼ
		If .PEHeader.OptionalHeader.iMagic <> IMAGE_NT_OPTIONAL_HDR64_MAGIC Then
			RvaAddrLength = 4
		Else
			RvaAddrLength = 8
		End If
		Dim p32IMPTunk As IMAGE_THUNK_DATA32
		Dim p64IMPTunk As IMAGE_THUNK_DATA64

		'ļ
		FN.hFile = CreateFile(strFilePath, GENERIC_READ, FILE_SHARE_READ, 0&, OPEN_EXISTING, 0&, 0&)
		If FN.hFile <= 0 Then
			DisplayError "CreateFile",GetLastError()
			Exit Function
		End If

		'ȡ
		j = 0
		Do While 1
			'ȡIMAGE_THUNK_DATA32ṹļеʵַ
			hAddr = RvaToOffset(File, .PEHeader.OptionalHeader.DataDirectory(1).lVirtualAddress + j * Len(PEImport))
			SetFilePointer FN.hFile, hAddr, 0&, 0
			ReadFile FN.hFile, PEImport, Len(PEImport), dwReads, 0&
			If PEImport.FirstThunk = 0 And PEImport.OriginalFirstThunk = 0 Then Exit Do

			'ȡģ
			hAddr = RvaToOffset(File, PEImport.pName)
			SetFilePointer FN.hFile, hAddr, 0&, 0
			ReadFile FN.hFile, bytBuffer(0), 130, dwReads, 0&
			strTmp = StrConv$(bytBuffer, vbUnicode)
			strTmp = Mid$(strTmp, 1, InStr(strTmp & vbNullChar, vbNullChar) - 1)
			PSL.Output " DLL ģΪ" & strTmp
			ReDim Preserve pImportInfo.pDetailInfo(j) 'As IMPORT_DETAIL_INFO
			pImportInfo.pDetailInfo(j).strDllName = strTmp

			'
			i = 0
			Do While 1
				If PEImport.OriginalFirstThunk <> 0 Then
					Dim pIMPTunk As IMAGE_THUNK_DATA
					hAddr = RvaToOffset(File, PEImport.OriginalFirstThunk + i * RvaAddrLength)
					If hAddr = 0 Then Exit Do
					SetFilePointer FN.hFile, hAddr, 0&, 0
					ReadFile FN.hFile, pIMPTunk, Len(pIMPTunk), dwReads, 0&
					If pIMPTunk.AddressOfData = 0 Then Exit Do
					hAddr = RvaToOffset(File, pIMPTunk.AddressOfData)
				Else
					hAddr = RvaToOffset(File, PEImport.FirstThunk + i * RvaAddrLength)
					If hAddr = 0 Then Exit Do

					SetFilePointer FN.hFile, hAddr, 0&, 0
					If RvaAddrLength = 4 Then
						ReadFile FN.hFile, p32IMPTunk, Len(p32IMPTunk), dwReads, 0&
						If p32IMPTunk.pForwarderString = 0 Then Exit Do
						hAddr = RvaToOffset(File, p32IMPTunk.pForwarderString)
						'PSL.Output  hAddr & "- 1"
					Else
						ReadFile FN.hFile, p64IMPTunk, Len(p64IMPTunk), dwReads, 0&
						If p64IMPTunk.pForwarderString = 0 Then
							SetFilePointer FN.hFile, hAddr, 0&, 0
							ReadFile FN.hFile, p32IMPTunk, Len(p32IMPTunk), dwReads, 0&
							If p32IMPTunk.pForwarderString = 0 Then Exit Do
							hAddr = RvaToOffset(File, p32IMPTunk.pForwarderString)
						Else
							hAddr = RvaToOffset(File, p64IMPTunk.pForwarderString)
						End If
						'PSL.Output  hAddr & "- 1"
					End If
				End If

				SetFilePointer FN.hFile, hAddr, 0&, 0
				ReDim Preserve pImportInfo.pDetailInfo(j).strFuns(i) 'As String
				If hAddr <= 0 Then
					'PSL.Output "       ----Ϊ"
					pImportInfo.pDetailInfo(j).strFuns(i) = ""
				Else
					ReadFile FN.hFile, pIMPTable, Len(pIMPTable), dwReads, 0&
					strTmp = StrConv$(pIMPTable.pName, vbUnicode)
					strTmp = Mid$(strTmp, 1, InStr(strTmp & vbNullChar, vbNullChar) - 1)
					PSL.Output "       ----Ϊ" & strTmp
					pImportInfo.pDetailInfo(j).strFuns(i) = strTmp
				End If
				strTmp = ""
				i = i + 1
			Loop
			j = j + 1
		Loop
		GetImportTableByAPI = True
		'رļ
		UnMapFile(FN)
	End With
End Function
 

'ȡ (ļӳ)
Private Function GetImportTableByMap(ByVal strFilePath As String,File As FILE_PROPERTIE, pImportInfo As IMPORT_INFO) As Boolean
	Dim strTmp As String,i As Integer,j As Integer,lngTunk As Long
	Dim bytBuffer(129) As Byte,hAddr As Long,dwReads As Long,RvaAddrLength As Long
	Dim FN As FILE_IMAGE,Length As Long

	With File
		'Ƿṹ
		If .PEHeader.OptionalHeader.DataDirectory(1).lVirtualAddress = 0 Then
			Exit Function
		End If

		'ʼ
		If .PEHeader.OptionalHeader.iMagic <> IMAGE_NT_OPTIONAL_HDR64_MAGIC Then
			RvaAddrLength = 4
		Else
			RvaAddrLength = 8
		End If
		Dim p32IMPTunk As IMAGE_THUNK_DATA32
		Dim p64IMPTunk As IMAGE_THUNK_DATA64

		'ļ
		MapFile(strFilePath, FN, 0,0)
		If FN.MappedAddress <= 0 Then Exit Function

		'ȡ
		j = 0
		Do While 1
			'ȡIMAGE_THUNK_DATA32ṹļеʵַ
			Length = .PEHeader.OptionalHeader.DataDirectory(1).lVirtualAddress + j * Len(PEImport)
			hAddr = ImageRvaToVa(FN.MappedAddress + .DosHeader.lPointerToPEHeader, FN.MappedAddress, Length, 0&)
			MoveMemory PEImport, hAddr, Len(PEImport)
			If PEImport.FirstThunk = 0 And PEImport.OriginalFirstThunk = 0 Then Exit Do

			'ȡģ
			hAddr = ImageRvaToVa(FN.MappedAddress + .DosHeader.lPointerToPEHeader, FN.MappedAddress, PEImport.pName, 0&)
			MoveMemory bytBuffer(0), hAddr, 130
			strTmp = StrConv$(bytBuffer, vbUnicode)
			strTmp = Mid$(strTmp, 1, InStr(strTmp & vbNullChar, vbNullChar) - 1)
			PSL.Output " DLL ģΪ" & strTmp
			ReDim Preserve pImportInfo.pDetailInfo(j) 'As IMPORT_DETAIL_INFO
			pImportInfo.pDetailInfo(j).strDllName = strTmp

			'
			i = 0
			Do While 1
				If PEImport.OriginalFirstThunk <> 0 Then
					Dim pIMPTunk As IMAGE_THUNK_DATA
					hAddr = ImageRvaToVa(FN.MappedAddress + .DosHeader.lPointerToPEHeader, FN.MappedAddress, _
							PEImport.OriginalFirstThunk + i * RvaAddrLength, 0&)
					If hAddr = 0 Then Exit Do
					MoveMemory pIMPTunk, hAddr, Len(pIMPTunk)
					If pIMPTunk.AddressOfData = 0 Then Exit Do
					hAddr = ImageRvaToVa(FN.MappedAddress + .DosHeader.lPointerToPEHeader, FN.MappedAddress, _
							pIMPTunk.AddressOfData, 0&)
				Else
					hAddr = ImageRvaToVa(FN.MappedAddress + .DosHeader.lPointerToPEHeader, FN.MappedAddress, _
							PEImport.FirstThunk + i * RvaAddrLength, 0&)
					If hAddr = 0 Then Exit Do

					If RvaAddrLength = 4 Then
						MoveMemory p32IMPTunk, hAddr, Len(p32IMPTunk)
						If p32IMPTunk.pForwarderString = 0 Then Exit Do
						hAddr = ImageRvaToVa(FN.MappedAddress + .DosHeader.lPointerToPEHeader, FN.MappedAddress, _
								p32IMPTunk.pForwarderString, 0&)
						'PSL.Output  hAddr & "- 1"
					Else
						MoveMemory p64IMPTunk, hAddr, Len(p64IMPTunk)
						If p64IMPTunk.pForwarderString = 0 Then
							MoveMemory p32IMPTunk, hAddr, Len(p32IMPTunk)
							If p32IMPTunk.pForwarderString = 0 Then Exit Do
							hAddr = ImageRvaToVa(FN.MappedAddress + .DosHeader.lPointerToPEHeader, FN.MappedAddress, _
									p32IMPTunk.pForwarderString, 0&)
						Else
							hAddr = ImageRvaToVa(FN.MappedAddress + .DosHeader.lPointerToPEHeader, FN.MappedAddress, _
									p64IMPTunk.pForwarderString, 0&)
						End If
						'PSL.Output  hAddr & "- 1"
					End If
				End If

				ReDim Preserve pImportInfo.pDetailInfo(j).strFuns(i) 'As String
				If hAddr <= 0 Then
					'PSL.Output "       ----Ϊ"
					pImportInfo.pDetailInfo(j).strFuns(i) = ""
				Else
					MoveMemory pIMPTable, hAddr, Len(pIMPTable)
					strTmp = StrConv$(pIMPTable.pName, vbUnicode)
					strTmp = Mid$(strTmp, 1, InStr(strTmp & vbNullChar, vbNullChar) - 1)
					PSL.Output "       ----Ϊ" & strTmp
					pImportInfo.pDetailInfo(j).strFuns(i) = strTmp
				End If
				strTmp = ""
				i = i + 1
			Loop
			j = j + 1
		Loop
		GetImportTableByMap = True
		'رļ
		UnMapFile(FN)
	End With
End Function


'ȡ (ļ)
Private Function GetExportTableByAPI(ByVal strFilePath As String,File As FILE_PROPERTIE,pExportInfo As EXPORT_INFO) As Boolean
	Dim FN As FILE_IMAGE,strTmp As String,i As Integer,bytBuffer(129) As Byte
    Dim hAddr As Long,dwReads As Long,mdwVAddr As Long, mdwPAddr As Long

	With File
		'Ƿṹ
		If .PEHeader.OptionalHeader.DataDirectory(0).lVirtualAddress = 0 Then
			Exit Function
		End If

		'ȡڼRAVʵļַ
		For i = 0 To .PEHeader.FileHeader.iNumberOfSections - 1
			If .SecHeader(i).lPointerToRawData <> 0 And .SecHeader(i).lVirtualAddress <> 0 Then
				mdwVAddr = .SecHeader(i).lVirtualAddress
				mdwPAddr = .SecHeader(i).lPointerToRawData
				Exit For
			End If
		Next i

		'һΪ0˳
		If mdwVAddr = 0 Or mdwPAddr = 0 Then Exit Function

		'ļ
		FN.hFile = CreateFile(strFilePath, GENERIC_READ, FILE_SHARE_READ, 0&, OPEN_EXISTING, 0&, 0&)
		If FN.hFile <= 0 Then
			DisplayError "CreateFile",GetLastError()
			Exit Function
		End If

		'ȡļַ
		hAddr = RvaToOffset(File, .PEHeader.OptionalHeader.DataDirectory(0).lVirtualAddress)
		SetFilePointer FN.hFile, hAddr, 0&, 0

		'ȡ
		ReadFile FN.hFile, PEExport, Len(PEExport), dwReads, 0&
		If PEExport.NumberOfFunctions = 0 Then
			UnMapFile(FN)
			Exit Function
		End If

		'ȡģļַ
		hAddr = RvaToOffset(File, PEExport.pName)
		SetFilePointer FN.hFile, hAddr, 0&, 0

		'ȡģ
		ReadFile FN.hFile, bytBuffer(0), 130, dwReads, 0&
		strTmp = StrConv$(bytBuffer, vbUnicode)
		strTmp = Mid$(strTmp, 1, InStr(strTmp & vbNullChar, vbNullChar) - 1)
		PSL.Output " DLL ģΪ" & strTmp
		pExportInfo.strDllName = strTmp
		ReDim pExportInfo.strFuns(PEExport.NumberOfFunctions - 1) 'As String

		'Ϣ
		For i = 0 To PEExport.NumberOfFunctions - 1
			hAddr = RvaToOffset(File, PEExport.AddressOfNames + i * 4)
			SetFilePointer FN.hFile, hAddr, 0&, 0
			ReadFile FN.hFile, hAddr, 4, dwReads, 0&
			hAddr = RvaToOffset(File, hAddr)
			SetFilePointer FN.hFile, hAddr, 0&, 0
			If hAddr <> 0 Then
				ReadFile FN.hFile, bytBuffer(0), 130, dwReads, 0&
				strTmp = StrConv$(bytBuffer, vbUnicode)
				strTmp = Mid$(strTmp, 1, InStr(strTmp & vbNullChar, vbNullChar) - 1)
				PSL.Output "       ----Ϊ" & strTmp
				pExportInfo.strFuns(i) = strTmp
			Else
				pExportInfo.strFuns(i) = ""
			End If
			strTmp = ""
		Next i
		GetExportTableByAPI = True
		'رļ
		UnMapFile(FN)
	End With
End Function


'ȡ (ļӳ)
Private Function GetExportTableByMap(ByVal strFilePath As String,File As FILE_PROPERTIE,pExportInfo As EXPORT_INFO) As Boolean
	Dim strTmp As String,i As Integer,bytBuffer(129) As Byte
    Dim hAddr As Long,dwReads As Long,mdwVAddr As Long, mdwPAddr As Long
    Dim FN As FILE_IMAGE

	With File
		'Ƿṹ
		If .PEHeader.OptionalHeader.DataDirectory(0).lVirtualAddress = 0 Then
			Exit Function
		End If

		'ȡڼRAVʵļַ
		For i = 0 To .PEHeader.FileHeader.iNumberOfSections - 1
			If .SecHeader(i).lPointerToRawData <> 0 And .SecHeader(i).lVirtualAddress <> 0 Then
				mdwVAddr = .SecHeader(i).lVirtualAddress
				mdwPAddr = .SecHeader(i).lPointerToRawData
				Exit For
			End If
		Next i

		'һΪ0˳
		If mdwVAddr = 0 Or mdwPAddr = 0 Then Exit Function

		'ļ
		MapFile(strFilePath, FN, 0, 0)
		If FN.MappedAddress <= 0 Then Exit Function

		'ȡļַ
		hAddr = ImageRvaToVa(FN.MappedAddress + .DosHeader.lPointerToPEHeader, FN.MappedAddress, _
				.PEHeader.OptionalHeader.DataDirectory(0).lVirtualAddress, 0&)

		'ȡ
		MoveMemory PEExport, hAddr, Len(PEExport)
		If PEExport.NumberOfFunctions = 0 Then
			UnMapFile(FN)
			Exit Function
		End If

		'ȡģļַ
		hAddr = ImageRvaToVa(FN.MappedAddress + .DosHeader.lPointerToPEHeader, FN.MappedAddress, PEExport.pName, 0&)

		'ȡģ
		MoveMemory bytBuffer(0), hAddr, 130
		strTmp = StrConv$(bytBuffer, vbUnicode)
		strTmp = Mid$(strTmp, 1, InStr(strTmp & vbNullChar, vbNullChar) - 1)
		PSL.Output " DLL ģΪ" & strTmp
		pExportInfo.strDllName = strTmp
		ReDim pExportInfo.strFuns(PEExport.NumberOfFunctions - 1) 'As String

		'Ϣ
		For i = 0 To PEExport.NumberOfFunctions - 1
			hAddr = ImageRvaToVa(FN.MappedAddress + .DosHeader.lPointerToPEHeader, FN.MappedAddress, PEExport.AddressOfNames + i * 4, 0&)
            MoveMemory hAddr, hAddr, LenB(CStr(hAddr))
            hAddr = ImageRvaToVa(FN.MappedAddress + .DosHeader.lPointerToPEHeader, FN.MappedAddress, hAddr, 0&)
			If hAddr <> 0 Then
				MoveMemory bytBuffer(0), hAddr, 130
				strTmp = StrConv$(bytBuffer, vbUnicode)
				strTmp = Mid$(strTmp, 1, InStr(strTmp & vbNullChar, vbNullChar) - 1)
				PSL.Output "       ----Ϊ" & strTmp
				pExportInfo.strFuns(i) = strTmp
			Else
				pExportInfo.strFuns(i) = ""
			End If
			strTmp = ""
		Next i
		GetExportTableByMap = True
		'رļ
		UnMapFile(FN)
	End With
End Function


'ת32λ PEHeader ṹΪݵ PEHeader ṹ
Private Function CovertPEHeader32(PEHeader As IMAGE_NT_HEADERS,PE32Header As IMAGE_NT_HEADERS32) As Boolean
	Dim i As Integer
	On Error GoTo ErrHandle
	PEHeader.FileHeader.iNumberOfSections = PE32Header.FileHeader.iNumberOfSections
	With PEHeader.OptionalHeader
		'******************
		'׼
		'******************
		.iMagic = PE32Header.OptionalHeader.iMagic
		.bMajorLinkerVersion = PE32Header.OptionalHeader.bMajorLinkerVersion
		.bMinorLinkerVersion = PE32Header.OptionalHeader.bMinorLinkerVersion
		.lSizeOfCode = PE32Header.OptionalHeader.lSizeOfCode
		.lSizeOfInitializedData = PE32Header.OptionalHeader.lSizeOfInitializedData
		.lSizeOfUninitializedData = PE32Header.OptionalHeader.lSizeOfUninitializedData
		.lAddressOfEntryPoint = PE32Header.OptionalHeader.lAddressOfEntryPoint
		.lBaseOfCode = PE32Header.OptionalHeader.lBaseOfCode
		.lBaseOfData = PE32Header.OptionalHeader.lBaseOfData
		'******************
		'NT 
		'******************
		.dImageBase = PE32Header.OptionalHeader.lImageBase
		.lSectionAlignment = PE32Header.OptionalHeader.lSectionAlignment
		.lFileAlignment = PE32Header.OptionalHeader.lFileAlignment
		.iMajorOperatingSystemVersion = PE32Header.OptionalHeader.iMajorOperatingSystemVersion
		.iMinorOperatingSystemVersion = PE32Header.OptionalHeader.iMinorOperatingSystemVersion
		.iMajorImageVersion = PE32Header.OptionalHeader.iMajorImageVersion
		.iMinorImageVersion = PE32Header.OptionalHeader.iMinorImageVersion
		.iMajorSubsystemVersion = PE32Header.OptionalHeader.iMajorSubsystemVersion
		.iMinorSubsystemVersion = PE32Header.OptionalHeader.iMinorSubsystemVersion
		.lWin32VersionValue = PE32Header.OptionalHeader.lWin32VersionValue
		.lSizeOfImage = PE32Header.OptionalHeader.lSizeOfImage
		.lSizeOfHeaders = PE32Header.OptionalHeader.lSizeOfHeaders
		.lCheckSum = PE32Header.OptionalHeader.lCheckSum
		.iSubsystem = PE32Header.OptionalHeader.iSubsystem
		.iDllCharacteristics = PE32Header.OptionalHeader.iDllCharacteristics
		.dSizeOfStackReserve = PE32Header.OptionalHeader.lSizeOfStackReserve
		.dSizeOfStackCommit = PE32Header.OptionalHeader.lSizeOfStackCommit
		.dSizeOfHeapReserve = PE32Header.OptionalHeader.lSizeOfHeapReserve
		.dSizeOfHeapCommit = PE32Header.OptionalHeader.lSizeOfHeapCommit
		.lLoaderFlags = PE32Header.OptionalHeader.lLoaderFlags
		.lNumberOfRvaAndSizes = PE32Header.OptionalHeader.lNumberOfRvaAndSizes
		For i = 0 To UBound(.DataDirectory)
			.DataDirectory(i) = PE32Header.OptionalHeader.DataDirectory(i)
		Next i
	End With
	CovertPEHeader32 = True
	ErrHandle:
End Function


'ת64λ PEHeader ṹΪݵ PEHeader ṹ
Private Function CovertPEHeader64(PEHeader As IMAGE_NT_HEADERS,PE64Header As IMAGE_NT_HEADERS64) As Boolean
	Dim i As Integer
	On Error GoTo ErrHandle
	PEHeader.FileHeader.iNumberOfSections = PE64Header.FileHeader.iNumberOfSections
	With PEHeader.OptionalHeader
		'******************
		'׼
		'******************
		.iMagic = PE64Header.OptionalHeader.iMagic
		.bMajorLinkerVersion = PE64Header.OptionalHeader.bMajorLinkerVersion
		.bMinorLinkerVersion = PE64Header.OptionalHeader.bMinorLinkerVersion
		.lSizeOfCode = PE64Header.OptionalHeader.lSizeOfCode
		.lSizeOfInitializedData = PE64Header.OptionalHeader.lSizeOfInitializedData
		.lSizeOfUninitializedData = PE64Header.OptionalHeader.lSizeOfUninitializedData
		.lAddressOfEntryPoint = PE64Header.OptionalHeader.lAddressOfEntryPoint
		.lBaseOfCode = PE64Header.OptionalHeader.lBaseOfCode
		'.lBaseOfData = PE64Header.OptionalHeader.lBaseOfData
		'******************
		'NT 
		'******************
		.dImageBase = PE64Header.OptionalHeader.dImageBase
		.lSectionAlignment = PE64Header.OptionalHeader.lSectionAlignment
		.lFileAlignment = PE64Header.OptionalHeader.lFileAlignment
		.iMajorOperatingSystemVersion = PE64Header.OptionalHeader.iMajorOperatingSystemVersion
		.iMinorOperatingSystemVersion = PE64Header.OptionalHeader.iMinorOperatingSystemVersion
		.iMajorImageVersion = PE64Header.OptionalHeader.iMajorImageVersion
		.iMinorImageVersion = PE64Header.OptionalHeader.iMinorImageVersion
		.iMajorSubsystemVersion = PE64Header.OptionalHeader.iMajorSubsystemVersion
		.iMinorSubsystemVersion = PE64Header.OptionalHeader.iMinorSubsystemVersion
		.lWin32VersionValue = PE64Header.OptionalHeader.lWin32VersionValue
		.lSizeOfImage = PE64Header.OptionalHeader.lSizeOfImage
		.lSizeOfHeaders = PE64Header.OptionalHeader.lSizeOfHeaders
		.lCheckSum = PE64Header.OptionalHeader.lCheckSum
		.iSubsystem = PE64Header.OptionalHeader.iSubsystem
		.iDllCharacteristics = PE64Header.OptionalHeader.iDllCharacteristics
		.dSizeOfStackReserve = PE64Header.OptionalHeader.dSizeOfStackReserve
		.dSizeOfStackCommit = PE64Header.OptionalHeader.dSizeOfStackCommit
		.dSizeOfHeapReserve = PE64Header.OptionalHeader.dSizeOfHeapReserve
		.dSizeOfHeapCommit = PE64Header.OptionalHeader.dSizeOfHeapCommit
		.lLoaderFlags = PE64Header.OptionalHeader.lLoaderFlags
		.lNumberOfRvaAndSizes = PE64Header.OptionalHeader.lNumberOfRvaAndSizes
		For i = 0 To UBound(.DataDirectory)
			.DataDirectory(i) = PE64Header.OptionalHeader.DataDirectory(i)
		Next i
	End With
	CovertPEHeader64 = True
	ErrHandle:
End Function


'ַתƫƵַ
Private Function RvaToOffset(File As FILE_PROPERTIE,ByVal dwRvaAddr As Long) As Long
	Dim i As Integer
	On Error GoTo ErrHandle
	RvaToOffset = -1
	For i = 0 To UBound(File.SecHeader)
		With File.SecHeader(i)
			If dwRvaAddr >= .lVirtualAddress And dwRvaAddr < .lVirtualAddress + .lVirtualSize Then
				RvaToOffset = dwRvaAddr + .lPointerToRawData - .lVirtualAddress
				Exit Function
			End If
		End With
	Next i
	If RvaToOffset = -1 Then
		If dwRvaAddr > -1 And dwRvaAddr < File.SecHeader(File.MinSecID).lVirtualAddress Then
			RvaToOffset = dwRvaAddr
			Exit Function
		End If
	End If
	ErrHandle:
	RvaToOffset = 0
End Function


'ƫƵַתַ
Private Function OffsetToRva(File As FILE_PROPERTIE,ByVal dwOffset As Long) As Long
	Dim i As Integer
	On Error GoTo ErrHandle
	OffsetToRva = -1
	For i = 0 To UBound(File.SecHeader)
		With File.SecHeader(i)
			If dwOffset >= .lPointerToRawData And dwOffset < .lPointerToRawData + .lSizeOfRawData Then
				OffsetToRva = dwOffset + .lVirtualAddress - .lPointerToRawData
				Exit Function
			End If
		End With
	Next i
	If OffsetToRva = -1 Then
		If dwOffset > -1 And dwOffset < File.SecHeader(File.MinSecID).lPointerToRawData Then
			OffsetToRva = dwOffset
			Exit Function
		End If
	End If
	ErrHandle:
	OffsetToRva = 0
End Function


'ӳļ
'MapSize = 0 ļʼʱĴСӳ䣬ָСӳ
'ReadOnly = 0 ֻʽдʽ
'SizeOfFile = 0 ȡļʼʱĴС򲻻ȡ
'IsPE = 0 һļӳ䣬 PE ļӳ(ÿڶ)
Public Function MapFile(ByVal strFilePath As String,LoadedImage As FILE_IMAGE,ByVal MapSize As Long, _
		ByVal ReadOnly As Long,Optional ByVal SizeOfFile As Long,Optional ByVal IsPE As Long) As Boolean
	With LoadedImage
		If UnMapFile(LoadedImage,SizeOfFile) = False Then Exit Function
		.ModuleName = strFilePath
		.hFile = CreateFile(strFilePath, _
				GENERIC_READ Or GENERIC_WRITE, _
				FILE_SHARE_READ Or FILE_SHARE_WRITE, _
				0&, _
				OPEN_EXISTING, _
				FILE_ATTRIBUTE_NORMAL Or FILE_ATTRIBUTE_ARCHIVE Or _
				FILE_ATTRIBUTE_READONLY Or FILE_ATTRIBUTE_HIDDEN Or _
				FILE_ATTRIBUTE_SYSTEM, _
				0&)
		If .hFile = 0 Then Exit Function
		If SizeOfFile = 0 Then .SizeOfFile = GetFileSize(.hFile, 0&)
		If IsPE = 0 Then
			.hMap = CreateFileMapping(.hFile, 0&, PAGE_READWRITE, 0, MapSize, vbNullChar)
		Else
			.hMap = CreateFileMapping(.hFile, 0&, PAGE_EXECUTE_READWRITE Or SEC_IMAGE, 0, MapSize, vbNullChar)
		End If
		If .hMap = 0 Then
			DisplayError "CreateFileMapping",GetLastError()
			If CloseHandle(.hFile) = 0 Then
				DisplayError "CloseHandle",GetLastError()
			End If
			Exit Function
		End If
		If ReadOnly = 0 Then
			.MappedAddress = MapViewOfFile(.hMap, FILE_MAP_READ, 0, 0, MapSize)
		Else
			.MappedAddress = MapViewOfFile(.hMap, FILE_MAP_WRITE, 0, 0, MapSize)
		End If
		If .MappedAddress = 0 Then
			DisplayError "MapViewOfFile",GetLastError()
			If CloseHandle(.hMap) = 0 Then
				DisplayError "CloseHandle",GetLastError()
			End If
			If CloseHandle(.hFile) = 0 Then
				DisplayError "CloseHandle",GetLastError()
			End If
			Exit Function
    	End If
    	If MapSize = 0 Then
    		.SizeOfImage = GetFileSize(.hFile, 0&)
    	Else
    		.SizeOfImage = MapSize
    	End If
    	MapFile = True
    End With
End Function


'رӳļ
'SizeOfFile = 0 ļʵʴС棬ָС
Public Function UnMapFile(LoadedImage As FILE_IMAGE,Optional ByVal SizeOfFile As Long) As Boolean
	With LoadedImage
		If .MappedAddress > 0 Then
			If UnmapViewOfFile(.MappedAddress) = 0 Then
				DisplayError "UnmapViewOfFile",GetLastError()
				Exit Function
			Else
				.MappedAddress = 0
			End If
		End If
		If .hMap > 0 Then
 			If CloseHandle(.hMap) = 0 Then
 				DisplayError "CloseHandle",GetLastError()
 				Exit Function
 			Else
 				.hMap = 0
 			End If
 		End If
 		If .hFile > 0 Then
 			If SizeOfFile > 0 Then
 				SetFilePointer(.hFile, SizeOfFile, 0&, 0)
 				SetEndOfFile(.hFile)
 				'WriteFile(.hFile,Mode, SizeOfFile, 0&, 0&)
 			End If
 			If CloseHandle(.hFile) = 0 Then
 				DisplayError "CloseHandle",GetLastError()
 				Exit Function
 			Else
 				.hFile = 0
 			End If
 		End If
 		If .MappedAddress + .hMap + .hFile = 0 Then
 			.ModuleName = ""
 			.SizeOfImage = 0
 			If SizeOfFile = 0 Then .SizeOfFile = 0
 			Erase LoadedImage.ImageByte
 			UnMapFile = True
 		End If
 	End With
End Function


'ȡϢ
Private Sub DisplayError(ByVal lpSource As String,ByVal dwError As Long)
    Dim GetLastDllErrMsg As String
    GetLastDllErrMsg = String$(256, 32)
    FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM Or _
    			FORMAT_MESSAGE_IGNORE_INSERTS, _
    			lpSource, dwError, 0&, _
    			GetLastDllErrMsg,Len(GetLastDllErrMsg),0&)
    Err.Raise(dwError,lpSource,Trim(GetLastDllErrMsg))
End Sub


'޸ļĴʱ䡢ʱ޸ʱ
Public Function SetFileCreatedDate(ByVal strFilePath As String,ByVal CreatedDate As Date) As Boolean
	Dim lhFile As Long,udtFileTime As FILETIME
	Dim udtLocalTime As FILETIME,udtSystemTime As SYSTEMTIME

	'תʱΪ SYSTEMTIME
	udtSystemTime.wYear = Year(CreatedDate)
	udtSystemTime.wMonth = Month(CreatedDate)
	udtSystemTime.wDay = Day(CreatedDate)
	udtSystemTime.wDayOfWeek = Weekday(CreatedDate)
	udtSystemTime.wHour = Hour(CreatedDate)
	udtSystemTime.wMinute = Minute(CreatedDate)
	udtSystemTime.wSecond = Second(CreatedDate)
	udtSystemTime.wMilliseconds = 0

	'תϵͳʱΪʱ
	If SystemTimeToFileTime(udtSystemTime, udtLocalTime) = 0 Then
		DisplayError "SystemTimeToFileTime",GetLastError()
		Exit Function
	End If

	'תʱΪ GMT ʱ
	If LocalFileTimeToFileTime(udtLocalTime, udtFileTime) = 0 Then
		DisplayError "LocalFileTimeToFileTime",GetLastError()
		Exit Function
	End If

	'ļȡļ
	lhFile = CreateFile(strFilePath, GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0&, 0&)
	If lhFile = 0 Then
		DisplayError "CreateFile",GetLastError()
		Exit Function
	End If

	'ļںʱ
	If SetFileTime(lhFile, udtFileTime, udtFileTime, udtFileTime) = 0 Then
		DisplayError "SetFileTime",GetLastError()
		If CloseHandle(lhFile) = 0 Then
			DisplayError "CloseHandle",GetLastError()
		End If
		Exit Function
	End If

	'رļǳɹ
	If CloseHandle(lhFile) = 0 Then
		DisplayError "CloseHandle",GetLastError()
		Exit Function
	End If
	SetFileCreatedDate = True
End Function


'Ƚ϶ļļڿʼַʹСǷһ£ͬ 0
Public Function CompSecHeader(srcFile As FILE_PROPERTIE,trgFile As FILE_PROPERTIE) As Long
	Dim i As Integer,j As Integer
	i = UBound(srcFile.SecHeader)
	j = UBound(trgFile.SecHeader)
	j = IIf(i > j,j,i)
	For i = 0 To j
		If srcFile.SecHeader(i).lPointerToRawData < srcFile.PEHeader.OptionalHeader.DataDirectory(2).lVirtualAddress Then
			If srcFile.SecHeader(i).lPointerToRawData <> trgFile.SecHeader(i).lPointerToRawData Then
				CompSecHeader = 1
				Exit For
			ElseIf srcFile.SecHeader(i).lSizeOfRawData <> trgFile.SecHeader(i).lSizeOfRawData Then
				CompSecHeader = 1
				Exit For
			End If
			If srcFile.SecHeader(i).lVirtualAddress <> trgFile.SecHeader(i).lVirtualAddress Then
				CompSecHeader = 2
				Exit For
			ElseIf srcFile.SecHeader(i).lVirtualSize <> trgFile.SecHeader(i).lVirtualSize Then
				CompSecHeader = 2
				Exit For
			End If
		End If
	Next i
End Function


'תĿ¼ṹַΪƫƵַ
Public Sub CovertDataDirectoryAddress(File As FILE_PROPERTIE)
	Dim i As Integer
	With File.PEHeader.OptionalHeader
		For i = 0 To 15
			.DataDirectory(i).lVirtualAddress = RvaToOffset(File,.DataDirectory(i).lVirtualAddress)
		Next i
	End With
End Sub


'ת.NET ͷṹַΪַ
Public Sub CovertNETHeadersAddress(File As FILE_PROPERTIE)
	Dim i As Integer
	If File.PELangType <> NET_FILE_SIGNATURE Then Exit Sub
	With File.CLRHeader
		.METADATA.lVirtualAddress = RvaToOffset(File,.METADATA.lVirtualAddress)
		.Resources.lVirtualAddress = RvaToOffset(File,.Resources.lVirtualAddress)
		.StrongNameSignature.lVirtualAddress = RvaToOffset(File,.StrongNameSignature.lVirtualAddress)
		.CodeManagerTable.lVirtualAddress = RvaToOffset(File,.CodeManagerTable.lVirtualAddress)
		.VTableFixups.lVirtualAddress = RvaToOffset(File,.VTableFixups.lVirtualAddress)
		.ExportAddressTableJumps.lVirtualAddress = RvaToOffset(File,.ExportAddressTableJumps.lVirtualAddress)
		.ManagedNativeHeader.lVirtualAddress = RvaToOffset(File,.ManagedNativeHeader.lVirtualAddress)
	End With
	With File
		If .MetaDataHeader.iStreams > 0 Then
			For i = 0 To .MetaDataHeader.iStreams - 1
				.StreamHeader(i).lOffset = .CLRHeader.MetaData.lVirtualAddress + .StreamHeader(i).lOffset
			Next i
		End If
	End With
End Sub


'ȡļ
'Mode = 0 ƫƵַ(ؽ)
'Mode = 1 ƫƵַ(ؽ)
'Mode = 2 ַ(ؽ)
'Mode = 3 ַ(ؽ)
'ļšMinValMaxVal ֵ
Public Function SkipSection(File As FILE_PROPERTIE,ByVal Offset As Long,MinVal As Long,MaxVal As Long,Optional ByVal Mode As Long) As Long
	Dim i As Integer
	SkipSection = -1
	MinVal = 0: MaxVal = 0
	If Mode < 2 Then
		For i = 0 To UBound(File.SecHeader)
			With File.SecHeader(i)
				If Offset >= .lPointerToRawData And Offset < .lPointerToRawData + .lSizeOfRawData Then
					SkipSection = i
					MinVal = .lPointerToRawData
					MaxVal = MinVal + .lSizeOfRawData - 1
					Exit For
				End If
			End With
		Next i
		If Mode = 1 And SkipSection = -1 Then
			With File.HideSecHeader
				If .lSizeOfRawData > 0 Then
					If Offset > .lPointerToRawData And Offset < .lPointerToRawData + .lSizeOfRawData Then
						SkipSection = UBound(File.SecHeader) + 1
						MinVal = .lPointerToRawData
						MaxVal = MinVal + .lSizeOfRawData - 1
					End If
				End If
			End With
		End If
		If SkipSection = -1 Then
			If File.PEBitType > 0 And Offset > -1 Then
				If Offset < File.SecHeader(File.MinSecID).lPointerToRawData Then
					SkipSection = -2	'ļͷ
				ElseIf Offset < File.FileSize Then
					SkipSection = -3	' PE ļ
				End If
			End If
		End If
	Else
		For i = 0 To UBound(File.SecHeader)
			With File.SecHeader(i)
				If Offset >= .lVirtualAddress And Offset < .lVirtualAddress + .lVirtualSize Then
					SkipSection = i
					MinVal = .lVirtualAddress
					MaxVal = MinVal + .lVirtualSize - 1
					Exit For
				End If
			End With
		Next i
		If Mode = 3 And SkipSection = -1 Then
			With File.HideSecHeader
				If .lVirtualSize > 0 Then
					If Offset >= .lVirtualAddress And Offset < .lVirtualAddress + .lVirtualSize Then
						SkipSection = UBound(File.SecHeader) + 1
						MinVal = .lVirtualAddress
						MaxVal = MinVal + .lVirtualSize - 1
					End If
				End If
			End With
		End If
		If SkipSection = -1 Then
			If File.PEBitType > 0 And Offset > -1 Then
				If Offset < File.SecHeader(File.MinSecID).lVirtualAddress Then
					SkipSection = -2	'ļͷ
				ElseIf Offset < File.FileSize Then
					SkipSection = -3	' PE ļ
				End If
			End If
		End If
	End If
End Function


'ȡĿ¼żַ (ĵַתΪƫƵַ)
'Mode = 0 ʱ RVA Ŀ¼
'Mode = 1 ʱRVA = RVA Ŀ¼ַ + 1SkipVal =  RVA Ŀ¼Сַ
'Mode > 1 ʱRVA = RVA Ŀ¼Сַ - 1SkipVal =  RVA СĿ¼ַ
Public Function SkipDataDirectory(File As FILE_PROPERTIE,RVA As Long,Optional SkipVal As Long,Optional ByVal Mode As Long) As Long
	Dim i As Integer,endPos As Long
	SkipDataDirectory = -1
	For i = 0 To 15
		With File.PEHeader.OptionalHeader.DataDirectory(i)
			If .lVirtualAddress > 0 And .lSize > 0 Then
				endPos = .lVirtualAddress + .lSize - 1		'Ŀ¼ַ
				If Mode = 0 Then
					If RVA >= .lVirtualAddress And RVA <= endPos Then
						SkipDataDirectory = i
						Exit For
					End If
				ElseIf Mode = 1 Then
					If SkipDataDirectory < 0 Then
						If RVA >= .lVirtualAddress And RVA <= endPos Then
							SkipDataDirectory = i
							RVA = endPos + 1
							If SkipVal < endPos Then SkipVal = endPos
						End If
					End If
					If .lVirtualAddress > RVA Then
						If RVA > SkipVal Then
							SkipVal = .lVirtualAddress
						ElseIf .lVirtualAddress < SkipVal Then
							SkipVal = .lVirtualAddress
						End If
					End If
				Else
					If SkipDataDirectory < 0 Then
						If RVA >= .lVirtualAddress And RVA <= endPos Then
							SkipDataDirectory = i
							RVA = .lVirtualAddress - 1
							If SkipVal > .lVirtualAddress Then SkipVal = .lVirtualAddress
						End If
					End If
					If endPos < RVA Then
						If RVA < SkipVal Then
							SkipVal = endPos
						ElseIf endPos > SkipVal Then
							SkipVal = endPos
						End If
					End If
				End If
			End If
		End With
	Next i
End Function


'ȡļͷżַ (ĵַתΪƫƵַ)
'Mode = 0 ʱ RVA Ŀ¼
'Mode = 1 ʱRVA = RVA Ŀ¼ַ + 1SkipVal =  RVA Ŀ¼Сַ
'Mode > 1 ʱRVA = RVA Ŀ¼Сַ - 1SkipVal =  RVA СĿ¼ַ
'fType = 0 ʱ .NET US 
Public Function SkipHeader(File As FILE_PROPERTIE,RVA As Long,Optional SkipVal As Long,Optional ByVal Mode As Long,Optional ByVal fType As Long) As Long
	Dim i As Integer,endPos As Long
	SkipHeader = -1
	i = 15 + IIf(File.PELangType = NET_FILE_SIGNATURE,7 + File.MetaDataHeader.iStreams,0)
	ReDim List(i) As IMAGE_DATA_DIRECTORY
	With File.PEHeader.OptionalHeader
		For i = 0 To 15
			List(i).lVirtualAddress = .DataDirectory(i).lVirtualAddress
			List(i).lSize = .DataDirectory(i).lSize
		Next i
	End With
	If File.PELangType = NET_FILE_SIGNATURE Then
		With File.CLRHeader
			List(16).lVirtualAddress = .METADATA.lVirtualAddress
			List(17).lVirtualAddress = .Resources.lVirtualAddress
			List(18).lVirtualAddress = .StrongNameSignature.lVirtualAddress
			List(19).lVirtualAddress = .CodeManagerTable.lVirtualAddress
			List(20).lVirtualAddress = .VTableFixups.lVirtualAddress
			List(21).lVirtualAddress = .ExportAddressTableJumps.lVirtualAddress
			List(22).lVirtualAddress = .ManagedNativeHeader.lVirtualAddress
			List(16).lSize = .METADATA.lSize
			List(17).lSize = .Resources.lSize
			List(18).lSize = .StrongNameSignature.lSize
			List(19).lSize = .CodeManagerTable.lSize
			List(20).lSize = .VTableFixups.lSize
			List(21).lSize = .ExportAddressTableJumps.lSize
			List(22).lSize = .ManagedNativeHeader.lSize
		End With
	End If
	If File.MetaDataHeader.iStreams > 0 Then
		With File
			For i = 0 To .MetaDataHeader.iStreams - 1
				List(23 + i).lVirtualAddress = .StreamHeader(i).lOffset
				List(23 + i).lSize = .StreamHeader(i).lSize
				If i = .USStreamID And fType > 0 Then
					fType = 0
					endPos = .StreamHeader(i).lOffset + .StreamHeader(i).lSize - 1
					If RVA >= .StreamHeader(i).lOffset And RVA <= endPos Then
						fType = RVA
					ElseIf Mode = 1 And RVA < endPos Then
						fType = .StreamHeader(i).lOffset
					ElseIf Mode > 1 And RVA > .StreamHeader(i).lOffset Then
						fType = .StreamHeader(i).lOffset
					End If
				End If
			Next i
		End With
	Else
		fType = 0
	End If
	For i = 0 To UBound(List)
		With List(i)
			If .lVirtualAddress > 0 And .lSize > 0 Then
				endPos = .lVirtualAddress + .lSize - 1		'ַ
				If Mode = 0 Then
					If SkipHeader < 0 Then
						If RVA >= .lVirtualAddress And RVA <= endPos Then
							SkipHeader = i
						End If
					Else
						If fType = 0 Then Exit Function
						If .lVirtualAddress >= List(SkipHeader).lVirtualAddress And _
							endPos < List(SkipHeader).lVirtualAddress + List(SkipHeader).lSize Then
							If .lVirtualAddress <= fType And endPos >= fType Then
								SkipHeader = -1
								Exit Function
							End If
						End If
					End If
				ElseIf Mode = 1 Then
					If .lVirtualAddress > RVA Then
						If RVA > SkipVal Then
							SkipVal = .lVirtualAddress
						ElseIf .lVirtualAddress < SkipVal Then
							SkipVal = .lVirtualAddress
						End If
					ElseIf RVA <= endPos Then
						SkipHeader = i
						RVA = endPos + 1
						If SkipVal < endPos Then SkipVal = endPos
					ElseIf SkipHeader > -1 And fType > 0 Then
						If .lVirtualAddress >= List(SkipHeader).lVirtualAddress And _
							endPos < List(SkipHeader).lVirtualAddress + List(SkipHeader).lSize Then
							If .lVirtualAddress <= fType And endPos >= fType Then
								SkipHeader = -1
								RVA = fType
								SkipVal = endPos
								Exit Function
							End If
						End If
					End If
				Else
					If endPos < RVA Then
						If RVA < SkipVal Then
							SkipVal = endPos
						ElseIf endPos > SkipVal Then
							SkipVal = endPos
						End If
					ElseIf RVA >= .lVirtualAddress Then
						SkipHeader = i
						RVA = .lVirtualAddress - 1
						If SkipVal > .lVirtualAddress Then SkipVal = .lVirtualAddress
					ElseIf SkipHeader > -1 And fType > 0 Then
						If .lVirtualAddress >= List(SkipHeader).lVirtualAddress And _
							endPos < List(SkipHeader).lVirtualAddress + List(SkipHeader).lSize Then
							If .lVirtualAddress <= fType And endPos >= fType Then
								SkipHeader = -1
								RVA = fType - 1
								SkipVal = .lVirtualAddress
								Exit Function
							End If
						End If
					End If
				End If
			End If
		End With
	Next i
End Function


'ȡļб
Public Function getSectionNames(File As FILE_PROPERTIE,Optional ByVal SecName As String) As String()
	Dim i As Integer,Dic As Object
	If File.PEBitType = 0 Then
		ReDim Templist(0) As String
		Templist(0) = SecName
		getSectionNames = Templist
		Exit Function
	End If
	Set Dic = CreateObject("Scripting.Dictionary")
	With File
		If .HideSecHeader.lSizeOfRawData > 0 Then
			ReDim Templist(UBound(.SecHeader) + 1) As String
		Else
			ReDim Templist(UBound(.SecHeader)) As String
		End If
		For i = 0 To UBound(.SecHeader)
			Templist(i) = Replace$(StrConv$(.SecHeader(i).sName,vbUnicode),vbNullChar,"")
			If Trim$(Templist(i)) = "" Then
					Templist(i) = "Untitled_" & i
			ElseIf Dic.Exists(Templist(i)) Then
				Templist(i) = Templist(i) & "_" & i
			Else
				Dic.Add(Templist(i),"")
			End If
		Next i
		If .HideSecHeader.lSizeOfRawData > 0 Then Templist(i) = SecName
	End With
	getSectionNames = Templist
	Set Dic = Nothing
End Function


'Сβڱ
'Mode = False ƫƵַ򣬷ַ
Public Sub SortSectionByAddress(SecHeader() As IMAGE_SECTION_HEADER,ByVal Mode As Boolean)
	Dim i As Long,r As Long,l As Long,TmpX As Long,TmpA As IMAGE_SECTION_HEADER
	r = LBound(SecHeader): l = UBound(SecHeader)
	If Mode = False Then
		Do While r > l
			For i = l To r - 1
				If SecHeader(i).lPointerToRawData > SecHeader(i + 1).lPointerToRawData Then
					TmpA = SecHeader(i)
					SecHeader(i) = SecHeader(i + 1)
					SecHeader(i + 1) = TmpA
					TmpX = i
				End If
			Next i
			r = TmpX
			For i = r To l + 1 Step -1
				If SecHeader(i).lPointerToRawData < SecHeader(i - 1).lPointerToRawData Then
					TmpA = SecHeader(i)
					SecHeader(i) = SecHeader(i - 1)
					SecHeader(i - 1) = TmpA
					TmpX = i
				End If
			Next i
			l = TmpX
		Loop
	Else
		Do While r > l
			For i = l To r - 1
				If SecHeader(i).lVirtualAddress > SecHeader(i + 1).lVirtualAddress Then
					TmpA = SecHeader(i)
					SecHeader(i) = SecHeader(i + 1)
					SecHeader(i + 1) = TmpA
					TmpX = i
				End If
			Next i
			r = TmpX
			For i = r To l + 1 Step -1
				If SecHeader(i).lVirtualAddress < SecHeader(i - 1).lVirtualAddress Then
					TmpA = SecHeader(i)
					SecHeader(i) = SecHeader(i - 1)
					SecHeader(i - 1) = TmpA
					TmpX = i
				End If
			Next i
			l = TmpX
		Loop
	End If
End Sub


'鲢ڱƫƵַ
Private Sub CheckSection(SecHeader() As IMAGE_SECTION_HEADER)
	Dim i As Integer,k As Long
	For i = LBound(SecHeader) + 1 To UBound(SecHeader)
		If SecHeader(i).lSizeOfRawData = 0 Then
			k = SecHeader(i - 1).lPointerToRawData + SecHeader(i - 1).lSizeOfRawData
			If SecHeader(i).lPointerToRawData < k Then
				SecHeader(i).lPointerToRawData = k
			End If
		ElseIf SecHeader(i).lPointerToRawData = 0 Then
			k = SecHeader(i - 1).lPointerToRawData + SecHeader(i - 1).lSizeOfRawData
			If SecHeader(i).lPointerToRawData < k Then
				SecHeader(i).lPointerToRawData = k
			End If
		End If
	Next i
End Sub


'ȡڱСȴСĵַڽ
'MinID = 0  MaxID = 0 ȡڱСַڽ
'MinID = -1 ȡ MaxID Сĵַڽ
'MaxID = -1 ȡ MinID ڴĵַڽ
'Mode = False ȽƫƵַȽַ
Public Function GetSectionID(SecHeader() As IMAGE_SECTION_HEADER,MinID As Integer,MaxID As Integer,ByVal Mode As Boolean) As Long
	Dim i As Long,MinVal As Long,MaxVal As Long
	If Mode = False Then
		If MinID = 0 And MaxID = 0 Then
			For i = LBound(SecHeader) To UBound(SecHeader)
				If SecHeader(i).lPointerToRawData > 0 Then
					If MinVal = 0 Then
						MinVal = SecHeader(i).lPointerToRawData
					ElseIf SecHeader(i).lPointerToRawData <= MinVal Then
						MinVal = SecHeader(i).lPointerToRawData
						MinID = i
					End If
					If SecHeader(i).lPointerToRawData >= MaxVal Then
						MaxVal = SecHeader(i).lPointerToRawData
						MaxID = i
					End If
				End If
			Next i
		ElseIf MinID < 0 Then
			MaxVal = SecHeader(MaxID).lPointerToRawData
			For i = LBound(SecHeader) To UBound(SecHeader)
				If SecHeader(i).lSizeOfRawData > 0 Then
					If SecHeader(i).lPointerToRawData < MaxVal Then
						If MinVal = 0 Then
							MinVal = SecHeader(i).lPointerToRawData
							MinID = i
						ElseIf SecHeader(i).lPointerToRawData > MinVal Then
							MinVal = SecHeader(i).lPointerToRawData
							MinID = i
						End If
					End If
				End If
			Next i
			GetSectionID = IIf(MinID < 0,MaxID,MinID)
		ElseIf MaxID < 0 Then
			MinVal = SecHeader(MinID).lPointerToRawData
			For i = LBound(SecHeader) To UBound(SecHeader)
				If SecHeader(i).lSizeOfRawData > 0 Then
					If SecHeader(i).lPointerToRawData > MinVal Then
						If MaxVal = 0 Then
							MaxVal = SecHeader(i).lPointerToRawData
							MaxID = i
						ElseIf SecHeader(i).lPointerToRawData < MaxVal Then
							MaxVal = SecHeader(i).lPointerToRawData
							MaxID = i
						End If
					End If
				End If
			Next i
			GetSectionID = IIf(MaxID < 0,MinID,MaxID)
		End If
	Else
		If MinID = 0 And MaxID = 0 Then
			For i = LBound(SecHeader) To UBound(SecHeader)
				If SecHeader(i).lVirtualAddress > 0 Then
					If MinVal = 0 Then
						MinVal = SecHeader(i).lVirtualAddress
					ElseIf SecHeader(i).lVirtualAddress <= MinVal Then
						MinVal = SecHeader(i).lVirtualAddress
						MinID = i
					End If
					If SecHeader(i).lVirtualAddress >= MaxVal Then
						MaxVal = SecHeader(i).lVirtualAddress
						MaxID = i
					End If
				End If
			Next i
		ElseIf MinID < 0 Then
			MaxVal = SecHeader(MaxID).lVirtualAddress
			For i = LBound(SecHeader) To UBound(SecHeader)
				If SecHeader(i).lVirtualSize > 0 Then
					If SecHeader(i).lVirtualAddress < MaxVal Then
						If MinVal = 0 Then
							MinVal = SecHeader(i).lVirtualAddress
							MinID = i
						ElseIf SecHeader(i).lVirtualAddress > MinVal Then
							MinVal = SecHeader(i).lVirtualAddress
							MinID = i
						End If
					End If
				End If
			Next i
			GetSectionID = IIf(MinID < 0,MaxID,MinID)
		ElseIf MaxID < 0 Then
			MinVal = SecHeader(MinID).lVirtualAddress
			For i = LBound(SecHeader) To UBound(SecHeader)
				If SecHeader(i).lVirtualSize > 0 Then
					If SecHeader(i).lVirtualAddress > MinVal Then
						If MaxVal = 0 Then
							MaxVal = SecHeader(i).lVirtualAddress
							MaxID = i
						ElseIf SecHeader(i).lVirtualAddress < MaxVal Then
							MaxVal = SecHeader(i).lVirtualAddress
							MaxID = i
						End If
					End If
				End If
			Next i
			GetSectionID = IIf(MaxID < 0,MinID,MaxID)
		End If
	End If
End Function


'ļ
'ImageSize = 0 ļĳʼС򿪣ָС
'ReadOnly = 0 ֻʽ򿪣дʽ
'ImageByte = 0 ȡֻֽʼ(淽ʽȡֽ) ImageByte ָСȡ
'Mode < 0 ֱӷʽMode = 0 淽ʽMode > 0 ӳ䷽ʽ
'IsPE = 0 һļӳ䣬 PE ļӳ(ÿڶ)
'LoadFile = -2 ʧܣʵʴ򿪷ʽ
'LoadedImage ļȡ
Public Function LoadFile(ByVal strFilePath As String,LoadedImage As FILE_IMAGE,ByVal ImageSize As Long,ByVal ReadOnly As Long, _
		ByVal ImageByte As Long,ByVal Mode As Long,Optional ByVal IsPE As Long,Optional ByVal WaitTime As Double = 0.5) As Long
	Dim i As Long
	'Դļ
	If IsOpen(strFilePath,WaitTime) = True Then
		LoadFile = -2
		Exit Function
	End If
	'ļ
	On Error GoTo ErrorHandle
	LoadedImage.ModuleName = strFilePath
	If Mode < 0 Then
		LoadedImage.hFile = FreeFile
		If ReadOnly = 0 Then
			Open strFilePath For Binary Access Read Lock Write As #LoadedImage.hFile
		Else
			Open strFilePath For Binary Access Read Write Lock Write As #LoadedImage.hFile
		End If
		LoadedImage.SizeOfFile = LOF(LoadedImage.hFile)
		If ImageByte > 0 Then
			LoadedImage.SizeOfImage = ImageByte
			LoadedImage.ImageByte = GetBytes(LoadedImage,ImageByte,0,-1)
		Else
			LoadedImage.SizeOfImage = LoadedImage.SizeOfFile
			ReDim LoadedImage.ImageByte(0) 'As Byte
		End If
	Else
		If Mode > 0 Then
			If MapFile(strFilePath,LoadedImage,ImageSize,ReadOnly,0,IsPE) = True Then
				If ImageByte > 0 Then
					LoadedImage.ImageByte = getBytesByMap(LoadedImage.MappedAddress,LoadedImage.SizeOfFile)
					If ImageByte <> LoadedImage.SizeOfFile Then
						ReDim Preserve LoadedImage.ImageByte(ImageByte - 1) 'As Byte
					End If
				Else
					ReDim LoadedImage.ImageByte(0) 'As Byte
				End If
			Else
				UnMapFile(LoadedImage,0)
				Mode = 0
			End If
		End If
		If Mode = 0 Then
			LoadedImage.hFile = FreeFile
			Open strFilePath For Binary Access Read Lock Write As #LoadedImage.hFile
			LoadedImage.SizeOfFile = LOF(LoadedImage.hFile)
			If ImageByte > 0 Then
				LoadedImage.SizeOfImage = ImageByte
				LoadedImage.ImageByte = GetBytes(LoadedImage,ImageByte,0,-1)
			Else
				LoadedImage.SizeOfImage = LoadedImage.SizeOfFile
				LoadedImage.ImageByte = GetBytes(LoadedImage,LoadedImage.SizeOfFile,0,-1)
			End If
			Close #LoadedImage.hFile
		End If
	End If
	LoadFile = Mode
	Exit Function
	ErrorHandle:
	UnLoadFile(LoadedImage,0,Mode)
	LoadFile = -2
	Err.Source = IIf(ReadOnly = 0,"NotOpenFile","NotWriteFile")
	Err.Description = Err.Description & JoinStr & strFilePath
	Call sysErrorMassage(Err,3)
End Function


'жļ
'SizeOfFile = 0 д룬ָСд룬ڻӳ䷽ʽʱЧ
Public Function UnLoadFile(LoadedImage As FILE_IMAGE,ByVal SizeOfFile As Long,ByVal Mode As Long) As Boolean
	On Error GoTo ErrorHandle
	If Mode < 0 Then
		Close #LoadedImage.hFile
		LoadedImage.ModuleName = ""
		LoadedImage.hFile = 0
		LoadedImage.hMap = 0
		LoadedImage.MappedAddress = 0
		LoadedImage.SizeOfFile = 0
		LoadedImage.SizeOfImage = 0
		Erase LoadedImage.ImageByte
		UnLoadFile = True
	ElseIf Mode = 0 Then
		If SizeOfFile > 0 Then
			LoadedImage.hFile = FreeFile
			Open LoadedImage.ModuleName For Binary Access Write Lock Write As #LoadedImage.hFile
			ReDim Preserve LoadedImage.ImageByte(LoadedImage.SizeOfFile - 1) 'As Byte
			Put #LoadedImage.hFile,1,LoadedImage.ImageByte
			Close #LoadedImage.hFile
		End If
		LoadedImage.ModuleName = ""
		LoadedImage.hFile = 0
		LoadedImage.hMap = 0
		LoadedImage.MappedAddress = 0
		LoadedImage.SizeOfFile = 0
		LoadedImage.SizeOfImage = 0
		Erase LoadedImage.ImageByte
		UnLoadFile = True
	ElseIf UnMapFile(LoadedImage,SizeOfFile) = True Then
		UnLoadFile = True
	End If
	ErrorHandle:
End Function


'ȡ Blob ѹ賤
' CorSigCompressLength = ǩ
Public Function CorSigCompressLength(ByVal Length As Long) As Long
	Dim i As Integer
	If Length > &H3FFF Then
		CorSigCompressLength = 4
	ElseIf Length > &H7F Then
		CorSigCompressLength = 2
	Else
		CorSigCompressLength = 1
	End If
End Function


'Blob ѹ
' CorSigCompressByte = ѹֽ飬Length = ֽڳ
Public Function CorSigCompressByte(ByVal Length As Long) As Byte()
	Dim i As Integer,Bytes() As Byte,Temp() As Byte
	If Length > &H3FFF Then
		Bytes = Val2Bytes((&HC0000000 Or Length),4)
		Length = 4
	ElseIf Length > &H7F Then
		Bytes = Val2Bytes((&H8000 Or Length),2)
		Length = 2
	Else
		Bytes = Val2Bytes(Length,1)
		Length = 1
	End If
	'Big Endian ת LITTLE Endian ֽ
	Temp = Bytes
	For i = 0 To Length - 1
		Bytes(i) = Temp(Length - 1 - i)
	Next i
	CorSigCompressByte = Bytes
End Function


'Blob ѹ
' CorSigCompressData = ǩȣLength = ֽڳ
Public Function CorSigCompressData(ByVal Length As Long,Bytes() As Byte) As Integer
	Dim i As Integer,Temp() As Byte
	If Length > &H3FFF Then
		CorSigCompressData = 4
		Bytes = Val2Bytes((&HC0000000 Or Length),4)
	ElseIf Length > &H7F Then
		CorSigCompressData = 2
		Bytes = Val2Bytes((&H8000 Or Length),2)
	Else
		CorSigCompressData = 1
		Bytes = Val2Bytes(Length,1)
	End If
	'Big Endian ת LITTLE Endian ֽ
	Temp = Bytes
	For i = 0 To CorSigCompressData - 1
		Bytes(i) = Temp(CorSigCompressData - 1 - i)
	Next i
End Function


'Blob Ƚѹ
' CorSigUncompressData = ѹȣLength = ȱʶֽڳȣǷ > &H7F ַʶ
'ÿݿͷ1ݿ飬ͨλ㣬ݿʵʳ
'һֽλΪ0ݿ鳤Ϊ1ֽ
'һֽλΪ10ݿ鳤Ϊ2ֽ
'һֽλΪ110ݿ鳤Ϊ4ֽ
Public Function CorSigUncompressData(FN As Variant,ByVal Index As Long,Length As Long,ByVal Mode As Long) As Integer
	Dim Bytes() As Byte
	Length = 0
	Bytes = GetBytes(FN,4,Index,Mode)
	If (Bytes(0) And &H80) = 0 Then
		CorSigUncompressData = 1
		Length = Bytes(0)
	ElseIf (Bytes(0) And &HC0) = &H80 Then
		CorSigUncompressData = 2
		Length = SHL((Bytes(0) And &H3F),8) Or Bytes(1)
    ElseIf (Bytes(0) And &HE0) = &HC0 Then
        CorSigUncompressData = 4
        Length = SHL((Bytes(0) And &H1F),24) Or SHL(CLng(Bytes(1)),16) Or SHL(CLng(Bytes(2)),8) Or Bytes(3)
    End If
    Exit Function

    If Bytes(0) = 0 Then
		CorSigUncompressData = 1
		Length = 0
	ElseIf ((Bytes(0) And &HC0) = &HC0) And ((Bytes(0) And &H20) = 0) Then
		CorSigUncompressData = 4
		Length = SHL((Bytes(0) And &H1F),24) Or SHL(CLng(Bytes(1)),16) Or SHL(CLng(Bytes(2)),8) Or Bytes(3)
	ElseIf ((Bytes(0) And &H80) = &H80) And ((Bytes(0) And &H40) = 0) Then
		CorSigUncompressData = 2
		Length = SHL((Bytes(0) And &H3F),8) Or Bytes(1)
	Else
		CorSigUncompressData = 1
		Length = Bytes(0) And &H7F
	End If
End Function
