'' Reference Search for Passolo
'' (c) 2015 by wanfu (Last modified on 2015.12.01)

'' Command Line Format: Command FilePath,Address
'' Command: Name of this Macros file
'' FilePath: Full path of PE file
'' Address: Offset of Dec or Hex, if Hex, use like "0xFFFF" format

Option Explicit

Private Type REFERENCE_PROPERTIE
	sCode			As String	'ô
	lAddress		As Long		'õַб
	inSecID			As Integer	'ִڽڵ
	StrType			As Integer	'ôִ
End Type

Private Type STRING_SUB_PROPERTIE
	lStartAddress	As Long		'ִĿʼַ
	inSectionID		As Integer	'ִڽڵ
	lReferenceNum	As Long		'ô
	GetRefState		As Integer	'ȡִб״̬0 = δȡ1 = ѻȡ
	Reference()		As REFERENCE_PROPERTIE
End Type

Private Type PROGRESS_MSG
	Total			As Long				'ܴ
	Passed			As Long				'Ѵ
	Massage			As String			'Ϣ
End Type

Private Const FILE_BIT_TYPE32 = 224 + 24
Private Const FILE_BIT_TYPE64 = 240 + 24

'дԻƽ̨
Private Enum PELangType
	DELPHI_FILE_SIGNATURE = &H50
	NET_FILE_SIGNATURE = &H424A5342
End Enum

'ڴӳļ
Private Enum FileMaping
	PAGE_READONLY = &H02
	PAGE_READWRITE = &H04
	PAGE_WRITECOPY = &H08
	PAGE_EXECUTE = &H10
	PAGE_EXECUTE_READ = &H20
	PAGE_EXECUTE_READWRITE = &H40
	PAGE_EXECUTE_WRITECOPY = &H80
	SEC_COMMIT = &H8000000
	SEC_IMAGE = &H1000000
	SEC_NOCACHE = &H10000000
	SEC_RESERVE = &H4000000
	SEC_IMAGE_NO_EXECUTE = &H11000000
	SEC_LARGE_PAGES = &H80000000
	SEC_WRITECOMBINE = &H40000000
	GENERIC_READ = &H80000000
	GENERIC_WRITE = &H40000000
	OPEN_EXISTING = 3
	OPEN_ALWAYS = 4
	FILE_MAP_COPY = &H01
	FILE_MAP_WRITE = &H02
	FILE_MAP_READ = &H04
	FILE_MAP_ALL_ACCESS = &H02 Or &H04
	FILE_MAP_EXECUTE = &H20
	FILE_SHARE_READ = &H01
	FILE_SHARE_WRITE = &H02
	FILE_ATTRIBUTE_NORMAL = &H80
	FILE_ATTRIBUTE_ARCHIVE = &H20
	FILE_ATTRIBUTE_READONLY = &H01
	FILE_ATTRIBUTE_HIDDEN = &H02
	FILE_ATTRIBUTE_SYSTEM = &H04
End Enum

'Ϣ
Private Enum FormatMSG
	FORMAT_MESSAGE_FROM_SYSTEM = &H1000
	FORMAT_MESSAGE_IGNORE_INSERTS = &H200
End Enum

'PEļṹ(Visual Basic)ִһ
'ǩ
Private Enum ImageSignatureTypes
	IMAGE_DOS_SIGNATURE = &H5A4D			'// MZ
	IMAGE_OS2_SIGNATURE = &H454E			'// NE
	IMAGE_OS2_SIGNATURE_LE = &H454C			'// LE
	IMAGE_VXD_SIGNATURE = &H454C			'// LE
	IMAGE_NT_SIGNATURE = &H4550				'// PE00
End Enum

'ж32λ64λPEļ
Private Enum ImageOptionalHeaderMagicType
	IMAGE_NT_OPTIONAL_HDR32_MAGIC = &H10B			'32λPEļ
	IMAGE_NT_OPTIONAL_HDR64_MAGIC = &H20B			'64λPEļ
End Enum

'======================================================================================
'ṹ: IMAGE_DOS_HEADER
'ṹС: 64ֽ
'ṹ˵: DOSӳͷ(EXEͷ)
'======================================================================================
Private Type IMAGE_DOS_HEADER
	iSignature					As Integer		'&H0    ǩ("MZ",&H5A4D)
	iLastPageBytes				As Integer		'&H2    ļҳеֽ
	iPages						As Integer		'&H4    ļҳ
	iRelocateItems				As Integer		'&H6    ضλԪظ
	iHeaderSize					As Integer		'&H8    ͷС
	iMinAlloc					As Integer		'&HA    СӶ
	iMaxAlloc					As Integer		'&HC    󸽼Ӷ
	iInitialSS					As Integer		'&HE    ʼSSֵ
	iInitialSP					As Integer		'&H10   ʼSPֵ
	iCheckSum					As Integer		'&H12   У
	iInitialIP					As Integer		'&H14   ʼIPֵ
	iInitialCS					As Integer		'&H16   ʼCSֵ(ƫ)
	iRelocateTable				As Integer		'&H18   ضļַ
	iOverlay					As Integer		'&H1A   Ǻ
	iReserved(3)				As Integer		'&H22   
	iOEMID						As Integer		'&H24   OEMʶ
	iOEMInformation				As Integer		'&H26   OEMϢ
	iReserved2(9)				As Integer		'&H28   2
	lPointerToPEHeader			As Long			'&H3C   PEͷλ
End Type

'======================================================================================
'ṹ: IMAGE_FILE_HEADER
'ṹС: 20ֽ
'ṹ˵: ӳļͷ
'======================================================================================
Private Type IMAGE_FILE_HEADER
	iMachine					As Integer		'&H4    ִиóĻƽ̨
	iNumberOfSections			As Integer		'&H6    ļнڵĸ
	lTimeDateStamp				As Long			'&H8    ļʱ(ʱ)
	lPointerToSymbolTable		As Long			'&HC    COFFűƫ
	lNumberOfSymbols			As Long			'&H10   Ŀ
	iSizeOfOptionalHeader		As Integer		'&H14   ѡͷС
	iCharacteristics			As Integer		'&H16   ־
End Type

'======================================================================================
'ṹ: IMAGE_DATA_DIRECTORY
'ṹС: ÿĿ¼8ֽڣ16Ŀ¼120ֽ
'ṹ˵: Ŀ¼
'0 = Ŀ¼
'1 = Ŀ¼
'2 = ԴĿ¼
'3 = 쳣Ŀ¼
'4 = ȫĿ¼
'5 = ַضλ
'6 = Ŀ¼
'7 = ȨĿ¼
'8 = ֵ(GP RVA)
'9 = ̱߳ش洢
'10 = Ŀ¼
'11 = 󶨵Ŀ¼
'12 = ַ
'13 = ӳټص
'14 = COM п־(.NET  RVA = CLR ַSize = CLR header ĴС̶Ϊ48ֽ)
'15 = Ŀ¼
'======================================================================================
Private Type IMAGE_DATA_DIRECTORY
	lVirtualAddress			As Long			'ʼRVAַ
	lSize					As Long			'lVirtualAddressָݽṹֽ
End Type

'======================================================================================
'ṹ: .NET CLR 2.0 ͷṹ
'ṹС: 72ֽ
'ṹ˵: CLR ͷ
'======================================================================================
Private Type IMAGE_CLR20_HEADER
	'Header versioning
	cb						As Long					'CLRͷĴСbyteΪλ
	MajorRuntimeVersion		As Integer				'иóС.NET汾汾
	MinorRuntimeVersion		As Integer				'иó.NET汾ĸ汾

	'Symbol table And startup information
	METADATA				As IMAGE_DATA_DIRECTORY	'ԪݵRVASize
	Flags					As Long					'ֶΣIL.corflagsʽã
													'Ҳڱʱ/FLAGSѡãõȼϸ
	EntryPointToken			As Long					'ڷԪIDҲtokenEXEļУ
													'DLLļдΪ0.NET 2.0УǱڴRVAֵ
	'Binding information
	Resources				As IMAGE_DATA_DIRECTORY	'йԴRVASize
	StrongNameSignature		As IMAGE_DATA_DIRECTORY	'ǿݵRVASizeǿƵںܣ

	'Regular fixup And binding information
	CodeManagerTable		As IMAGE_DATA_DIRECTORY	'CodeManagerTableRVASizeδʹãΪ0
    VTableFixups			As IMAGE_DATA_DIRECTORY	'v-tableRVASizeҪʹv-tableC++Խضλ
    ExportAddressTableJumps	As IMAGE_DATA_DIRECTORY	'C++תַRVASizeΪ0

    'Precompiled image info (internal use only - Set To zero)
    ManagedNativeHeader		As IMAGE_DATA_DIRECTORY	'ngenɱģиΪ0Ϊ0
End Type

'Ŀ¼ CLR Header Flags
'======================================================================================
Private Enum CLR_HEADER_FLAGES
	COMIMAGE_FLAGS_ILONLY = &H1				'CLRɴIL
	COMIMAGE_FLAGS_32BITREQUIRED = &H2		'CLRӳֻ32λϵͳִ
	COMIMAGE_FLAGS_IL_LIBRARY = &H4			'CLRӳΪILڵ
	COMIMAGE_FLAGS_STRONGNAMESIGNED = &H8	'ļܵǿǩı
	COMIMAGE_FLAGS_NATIVE_ENTRYPOINT =&H8	'˳ڷΪй
	COMIMAGE_FLAGS_TRACKDEBUGDATA = &H10000	'LoaderJITҪ׷ٵϢȱʡ0
End Enum

'======================================================================================
'ṹ: .NET MetaData ͷṹ
'ṹС: ̶
'ṹ˵: MetaData ͷ
'======================================================================================
Private Type IMAGE_METADATA_HEADER
	lSignature		As Long   		'Magic signature For physical metadata, currently 0x424A5342(BSJB Ϊ.Net ļı־)
	iMajorVersion	As Integer		'Major version (1 for the first release of the common language runtime)
	iMinorVersion	As Integer		'Minor Version (1 For the first release of the common language runtime)
	lExtraData		As Long			'Reserved, always 0
	lLength			As Long			'Length of Version String In bytes
	Version()		As Byte			'汾ַ, UTF8 룬4ֽڶ
	fFlags			As Integer		'Reserved, always 0
	iStreams		As Integer		'Number of streams
	'StreamHeader()	As IMAGE_STREAM_HEADER
End Type

'======================================================================================
'ṹ: .NET Stream ͷṹ
'ṹС: 72ֽ
'ṹ˵: Stream ͷ
'
'#Strings: UTF8ʽַѣԪݵƣԱȣ
'          ײһ0Ϊַַ0ʾβCLRЩƵ󳤶1024
'#Blob:    ݶѣ洢еķַϢ糣ֵsignaturePublicKeyȡ
'          ÿݵĳɸݵǰ13λ0ʾȣֽڣ10ʾ2ֽڣ110ʾ4ֽڡ
'#GUID:    洢еȫΨһʶGlobal Unique Identifier
'#US:      UnicodeʽŵILʹõûַUser Stringldstrõַ
'#~:       ԪݱҪеԪϢԱʽڴˡÿ.Net 򶼱
'#-:       #~δѹΪδŻ洢
'======================================================================================
Private Type IMAGE_STREAM_HEADER
    lOffset			As Long			' Metadata Root ڴƫ
    lSize			As Long			'ֽڴС4 ı
    rcName()		As Byte			'Կֹֽ ASCII ַ飬4ֽڶ
    RWA				As Long			'ƫƵַ (ʵûֵֻΪ˷㶨λλ)
End Type

'#Blob
'#Blobһݶѣезַʽݶѷ棬
'糣ֵPublic KeyֵSignatureȵȡ
'ÿݿͷһ鳤ݣΪ˽Լ洢ռ䣬CLRʹ˱Ƚ鷳ı뷽
'ʼһֽλΪ0ݿ鳤Ϊһֽڣ
'ʼһֽλΪ10ݿ鳤Ϊֽڣ
'ʼһֽλΪ110ݿ鳤Ϊĸֽڣ
'α־λͨλ㼴ɼݿʵʳֵݴ˻ݡ

'#US
'һBlobѣûԶַ
'˶ûеַЩַUTF-16ıʽ棬ŶһβΪ01ֽڣ
'ַָǷд0x007FĴַ
'βֽڱӵϵûַɵַϵĴת
'ȤǣûַᱻԪݱõʾرILַʹldstrָ
'⣬ΪһʵϵblobѣUSѲԴ洢UnicodeַԴ洢ƶʹЩȤʵֳΪܡ

'======================================================================================
'ṹ: .NET #~ Stream ṹ
'ṹС: 24ֽ
'ṹ˵: #~ Streamǿǩص
'======================================================================================
'Private Type TClrTableStreamHeader
'	Reserved		As Long			'Ϊ0
'	MajorVersion	As Byte			'Ԫݱ汾ţ.Net汾һ
'	MinorVersion	As Byte			'Ԫݱĸ汾ţһΪ0
'	HeapSizes		As Byte			'heaps жλʱĴСΪ0ʾ16λֵ
									'ݳ16λݱʾΧʹ32λֵ
									'01h strings ѣ02h GUID ѣ04h blob 
									'#-пΪ20h80hǰߴаEdit-and-Continueĵ޸ĵݣ
									'߱ʾԪиʶΪɾ
'	Rid				As Byte			'Ԫݱм¼ֵʱ.Net㣬ļͨΪ1
'	MaskValid		As Double		'8ֽڳȵ룬ÿλһΪ1ʾñЧΪ0ʾ޸ñ
'	Sorted			As Double		'8ֽڳȵ룬ÿλһΪ1ʾñ򣬷֮Ϊ0
'End Type

'MaskValid (¼ Ԫݱ ˵)
'0(0x0) ModuleDef					ǰģ
'1(0x1) TypeRef						TypeΪÿõͱһ¼
'2(0x2) TypeDef						Type壬ÿTypeTypeDefбһ¼
'3(0x3) FieldPtr					ֶָ룬ֶʱмұ
'4(0x4) FieldDef					ֶζ
'5(0x5) MethodPtr					ָ룬ķʱмұ
'6(0x6) MethodDef					
'7(0x7) ParamPtr					ָ룬Ĳʱмұ
'8(0x8) ParamDef					Ĳ
'9(0x9) InterfaceImpl				ЩʵЩӿ
'10(0xa) MemberRef					óԱóԱǷֶλԡ
'11(0xb) Constant					ֶκԵĳֵ
'12(0xc) CustomAttribute			ԵĶ
'13(0xd) FieldMarshal				йܴ뽻ʱֶεĴݷʽ
'14(0xe) DeclSecurity				ࡢͳ򼯵İȫ
'15(0xf) ClassLayout				ʱĲϢ
'16(0x10) FieldLayout				ֶεƫƻ
'17(0x11) StandAloneSig				δκõǩ
'18(0x12) EventMap					¼б
'19(0x13) EventPtr					¼ָ룬¼ʱмұ
'20(0x14) Event						¼
'21(0x15) PropertyMap				б
'22(0x16) PropertyPtr				ָ룬ʱмұ
'23(0x17) Property					
'24(0x18) MethodSemantics			¼뷽Ĺ
'25(0x19) MethodImpl				ʵ
'26(0x1a) ModuleRef					ⲿģ
'27(0x1b) TypeSpec					TypeDefTypeRef˵
'28(0x1c) ImplMap					ʹõзйܴķ
'29(0x1d) FieldRVA					ֶαչRVAһֶεԭʼֵλ
'30(0x1e) ENCLog					Edit-And-ContinueģʽЩԪݱ޸Ĺ
'31(0x1f) ENCMap					Edit-And-Continueģʽеӳ
'32(0x20) Assembly					򼯶
'33(0x21) AssemblyProcessor			δʹ
'34(0x22) AssemblyOS				δʹ
'35(0x23) AssemblyRef				õĳ
'36(0x24) AssemblyRefProcessor		δʹ
'37(0x25) AssemblyRefOS				δʹ
'38(0x26) File						ⲿļ
'39(0x27) ExportedType				ͬһ򼯵ͬģ飬Щ
'40(0x28) ManifestResource			ԴϢ
'41(0x29) NestedClass				ǶͶ
'42(0x2a) GenericParam				˷Ͷ߷ͷʹõķͲ
'43(0x2b) MethodSpec				ͷʵ
'44(0x2c) GenericParamConstraint	ÿͲԼ

'======================================================================================
'ṹ: .NET #~ Assembly Table ṹ
'ṹС: 72ֽ
'ṹ˵: #~ Assembly Table
'======================================================================================
'Private Type IMAGE_ASSEMBLY_TABLE
'	HashAlgId 		As Long			'Ըóhash㷨һΪ0x8004ʾCALG_SHA/CALG_SHA1CALG_*Ϊǰ׺㷨wincrypt.hļУ
'	MajorVersion	As Integer		'Assembly汾
'	MinorVersion	As Integer		'Assemblyĸ汾
'	BuildNumber		As Integer		'Assemblyı
'	RevisionNumber	As Integer		'Assembly޶
'	Flags			As Long			'ԣҪAssemblyзʽһǿƱʶ
'	PublicKey()		As Byte			'2-4ֽڣǿƣʾǿ#Blobеƫƣ֮Ϊ0
'	Name()			As Byte			'2-4ֽڣָ#StringsеƫƣʾAssemblyƣ·չ
'	Locale()		As Byte			'2-4ֽڣָ#StringsеƫƣʾAssemblyĵԣen-US,fr-CA
'End Type

'======================================================================================
'ṹ: .NET #~ MethodDef Table ṹ
'ṹС: 72ֽ
'ṹ˵: #~ MethodDef Table
'======================================================================================
'Private Type IMAGE_METHODDEF_TABLE
'	RVA				As Long			'÷RVAͷIL롢쳣壩
'	ImplFlags		As Integer		'޶˷ִзʽabstractP/Invokeȣ
'	Flags			As Integer		'޶˷ĵԺһЩʣPublicPrivatevirtualȣ
'	Name()			As Byte			'2-4ֽڣָ#Stringsƫƣʾ÷
' 	Signature()		As Byte			'2-4ֽڣָ#BlobƫƣSignature˷ĵ÷ʽ緵ֵͣCalling Conventionȣ
' 	ParamList		As Integer		'ָParamָ˷Ĳ
'End Type

'======================================================================================
'ṹ: IMAGE_OPTIONAL_HEADER32
'ṹС: 224ֽ
'ṹ˵: ѡӳͷ
'======================================================================================
Private Type IMAGE_OPTIONAL_HEADER32
	'******************
	'׼
	'******************
	iMagic							As Integer		'&H18   32λPE&H10B64λPE&H20B
	bMajorLinkerVersion				As Byte			'&H1A   汾
	bMinorLinkerVersion				As Byte			'&H1B   ΰ汾
	lSizeOfCode						As Long			'&H1C   ִд볤
	lSizeOfInitializedData			As Long			'&H20   ʼݳ(ݽ)
	lSizeOfUninitializedData		As Long			'&H24   δʼݳ(bss)
	lAddressOfEntryPoint			As Long			'&H28   RVAַ,⿪ʼִ
	lBaseOfCode						As Long			'&H2C   ִдʼλ
	lBaseOfData						As Long			'&H30   ʼʼλ
	'******************
	'NT 
	'******************
	lImageBase						As Long			'&H34   ѡRVAַ(32λ)
	lSectionAlignment				As Long			'&H38   غڴеĶ뷽ʽ
	lFileAlignment					As Long			'&H3C   ļеĶ뷽ʽ
	iMajorOperatingSystemVersion	As Integer		'&H40   ϵͳ汾
	iMinorOperatingSystemVersion	As Integer		'&H42   ϵͳΰ汾
	iMajorImageVersion				As Integer		'&H44   ִļ汾
	iMinorImageVersion				As Integer		'&H46   ִļΰ汾
	iMajorSubsystemVersion			As Integer		'&H48   ϵͳ汾
	iMinorSubsystemVersion			As Integer		'&H50   ϵͳΰ汾
	lWin32VersionValue				As Long			'&H52   Win32汾,һΪ0
	lSizeOfImage					As Long			'&H56   ռڴС(С)
	lSizeOfHeaders					As Long			'&H5A   ͷС(С)
	lCheckSum						As Long			'&H5E   У
	iSubsystem						As Integer		'&H62   ִļϵͳ
	iDllCharacteristics				As Integer		'&H64   ʱDllMain,һΪ0
	lSizeOfStackReserve				As Long			'&H66   ʼ߳ʱջС
	lSizeOfStackCommit				As Long			'&H6A   ʼ߳ʱύջС
	lSizeOfHeapReserve				As Long			'&H6E   ̳ʼʱջС
	lSizeOfHeapCommit				As Long			'&H72   ̳ʼʱύջС
	lLoaderFlags					As Long			'&H76   װر־,
	lNumberOfRvaAndSizes			As Long			'&H7A   Ŀ¼,һΪ16
	DataDirectory(15) 				As IMAGE_DATA_DIRECTORY			'DataDirectory(14)
End Type

'======================================================================================
'ṹ: IMAGE_OPTIONAL_HEADER64
'ṹС: 240ֽ
'ṹ˵: ѡӳͷ
'======================================================================================
Private Type IMAGE_OPTIONAL_HEADER64
	'******************
	'׼
	'******************
	iMagic							As Integer		'&H18   32λPE&H10B64λPE&H20B
	bMajorLinkerVersion				As Byte			'&H1A   汾
	bMinorLinkerVersion				As Byte			'&H1B   ΰ汾
	lSizeOfCode						As Long			'&H1C   ִд볤
	lSizeOfInitializedData			As Long			'&H20   ʼݳ(ݽ)
	lSizeOfUninitializedData		As Long			'&H24   δʼݳ(bss)
	lAddressOfEntryPoint			As Long			'&H28   RVAַ,⿪ʼִ
	lBaseOfCode						As Long			'&H2C   ִдʼλ
	'lBaseOfData					As Long			'&H30   ʼʼλ
	'******************
	'NT 
	'******************
	dImageBase						As Double		'&H34   ѡRVAַ(64λ)
	lSectionAlignment				As Long			'&H38   غڴеĶ뷽ʽ
	lFileAlignment					As Long			'&H3C   ļеĶ뷽ʽ
	iMajorOperatingSystemVersion	As Integer		'&H40   ϵͳ汾
	iMinorOperatingSystemVersion	As Integer		'&H42   ϵͳΰ汾
	iMajorImageVersion				As Integer		'&H44   ִļ汾
	iMinorImageVersion				As Integer		'&H46   ִļΰ汾
	iMajorSubsystemVersion			As Integer		'&H48   ϵͳ汾
	iMinorSubsystemVersion			As Integer		'&H50   ϵͳΰ汾
	lWin32VersionValue				As Long			'&H52   Win32汾,һΪ0
	lSizeOfImage					As Long			'&H56   ռڴС(С)
	lSizeOfHeaders					As Long			'&H5A   ͷС(С)
	lCheckSum						As Long			'&H5E   У
	iSubsystem						As Integer		'&H62   ִļϵͳ
	iDllCharacteristics				As Integer		'&H64   ʱDllMain,һΪ0
	dSizeOfStackReserve				As Double		'&H66   ʼ߳ʱջС(64λ)
	dSizeOfStackCommit				As Double		'&H6A   ʼ߳ʱύջС(64λ)
	dSizeOfHeapReserve				As Double		'&H6E   ̳ʼʱջС(64λ)
	dSizeOfHeapCommit				As Double		'&H72   ̳ʼʱύջС(64λ)
	lLoaderFlags					As Long			'&H76   װر־,
	lNumberOfRvaAndSizes			As Long			'&H7A   Ŀ¼,һΪ16
	DataDirectory(15) 				As IMAGE_DATA_DIRECTORY
End Type


'======================================================================================
'ṹ: IMAGE_OPTIONAL_HEADER
'ṹС: 244ֽ
'ṹ˵: ѡӳͷڼ32λ64λPEΪ޷ض
'======================================================================================
Private Type IMAGE_OPTIONAL_HEADER
	'******************
	'׼
	'******************
	iMagic							As Integer		'&H18   32λPE&H10B64λPE&H20B
	bMajorLinkerVersion				As Byte			'&H1A   汾
	bMinorLinkerVersion				As Byte			'&H1B   ΰ汾
	lSizeOfCode						As Long			'&H1C   ִд볤
	lSizeOfInitializedData			As Long			'&H20   ʼݳ(ݽ)
	lSizeOfUninitializedData		As Long			'&H24   δʼݳ(bss)
	lAddressOfEntryPoint			As Long			'&H28   RVAַ,⿪ʼִ
	lBaseOfCode						As Long			'&H2C   ִдʼλ
	lBaseOfData						As Long			'&H30   ʼʼλ
	'******************
	'NT 
	'******************
	dImageBase						As Double		'&H34   ѡRVAַ(64λ)
	lSectionAlignment				As Long			'&H38   غڴеĶ뷽ʽ
	lFileAlignment					As Long			'&H3C   ļеĶ뷽ʽ
	iMajorOperatingSystemVersion	As Integer		'&H40   ϵͳ汾
	iMinorOperatingSystemVersion	As Integer		'&H42   ϵͳΰ汾
	iMajorImageVersion				As Integer		'&H44   ִļ汾
	iMinorImageVersion				As Integer		'&H46   ִļΰ汾
	iMajorSubsystemVersion			As Integer		'&H48   ϵͳ汾
	iMinorSubsystemVersion			As Integer		'&H50   ϵͳΰ汾
	lWin32VersionValue				As Long			'&H52   Win32汾,һΪ0
	lSizeOfImage					As Long			'&H56   ռڴС(С)
	lSizeOfHeaders					As Long			'&H5A   ͷС(С)
	lCheckSum						As Long			'&H5E   У
	iSubsystem						As Integer		'&H62   ִļϵͳ
	iDllCharacteristics				As Integer		'&H64   ʱDllMain,һΪ0
	dSizeOfStackReserve				As Double		'&H66   ʼ߳ʱջС(64λ)
	dSizeOfStackCommit				As Double		'&H6A   ʼ߳ʱύջС(64λ)
	dSizeOfHeapReserve				As Double		'&H6E   ̳ʼʱջС(64λ)
	dSizeOfHeapCommit				As Double		'&H72   ̳ʼʱύջС(64λ)
	lLoaderFlags					As Long			'&H76   װر־,
	lNumberOfRvaAndSizes			As Long			'&H7A   Ŀ¼,һΪ16
	DataDirectory(15) 				As IMAGE_DATA_DIRECTORY
End Type

'======================================================================================
'ṹ: IMAGE_NT_HEADERS
'ṹС: 248ֽ
'ṹ˵: NTӳͷ
'======================================================================================
Private Type IMAGE_NT_HEADERS32
	lSignature					As Long						'PEļͷ־("PE00",&H4550),4ֽ
	FileHeader					As IMAGE_FILE_HEADER		'PEļֲϢ,20ֽ
	OptionalHeader				As IMAGE_OPTIONAL_HEADER32	'PEļ߼ֲϢ,224ֽ
End Type

'======================================================================================
'ṹ: IMAGE_NT_HEADERS64
'ṹС: 264ֽ
'ṹ˵: NTӳͷ
'======================================================================================
Private Type IMAGE_NT_HEADERS64
	lSignature					As Long						'PEļͷ־("PE00",&H4550),4ֽ
	FileHeader					As IMAGE_FILE_HEADER		'PEļֲϢ,20ֽ
	OptionalHeader				As IMAGE_OPTIONAL_HEADER64	'PEļ߼ֲϢ,240ֽ
End Type

'======================================================================================
'ṹ: IMAGE_NT_HEADERS
'ṹС: 268ֽ
'ṹ˵: NTӳͷڼ32λ64λPEΪ޷ض
'======================================================================================
Private Type IMAGE_NT_HEADERS
	lSignature					As Long						'PEļͷ־("PE00",&H4550),4ֽ
	FileHeader					As IMAGE_FILE_HEADER		'PEļֲϢ,20ֽ
	OptionalHeader				As IMAGE_OPTIONAL_HEADER	'PEļ߼ֲϢ,244ֽ
End Type

'======================================================================================
'ṹ: IMAGE_SECTION_HEADER
'ṹС: 40ֽ
'ṹ˵: ӳͷ
'======================================================================================
Private Type IMAGE_SECTION_HEADER
	sName(7)					As Byte			'&H0    (8ַֽ)
	'lPhysicalAddress			As Long			'&H8    OBJļбʾڵַ
	lVirtualSize				As Long			'&H8    EXEļбʾڵʵֽ
	lVirtualAddress				As Long			'&HC    ڵRVA
	lSizeOfRawData				As Long			'&H10   ھļĳߴ
	lPointerToRawData			As Long			'&H14   ԭʼļеλ
	lPointerToRelocations		As Long			'&H18   OBJļбʾضλϢƫ,EXEļ
	lPointerToLineNumbers		As Long			'&H1C   кƫ
	iNumberOfRelocations		As Integer		'&H20   ضλĿ
	iNumberOfLineNumbers		As Integer		'&H22   кűекĿ
	lCharacteristics			As Long			'&H24   
End Type

'ļ
Private Type FILE_PROPERTIE
	CompanyName					As String		'˾
	FileDescription				As String		'ļ
	FileVersion					As String		'ļ汾
	InternalName				As String		'ڲ
	LegalCopyright				As String		'Ȩ
	OrigionalFileName			As String		'ԭʼļ
	ProductName					As String		'Ʒ
	ProductVersion				As String		'Ʒ汾
	LanguageID					As String		'ID
	FileSize					As Long			'ļС
	DateCreated					As Date			'ļ
	DateLastModified			As Date			'ļ޸
	CopePage					As Long			'ļҳ
	FileName					As String		'ļ (·)
	FilePath					As String		'ļ· (ļ)
	MinSecID 					As Integer		'Сƫƿʼַڽ
	MaxSecID 					As Integer		'ƫƿʼַڽ
	USStreamID 					As Integer		'.NET ַ
	PEBitType					As Long			'ļ(32λ=224+24,64λ=240+24ֽ)
	PELangType					As Long			'ļıд
	iNumberOfSubPE				As Integer		'Ƕ PE 
	DosHeader 					As IMAGE_DOS_HEADER
	PEHeader 					As IMAGE_NT_HEADERS
	PEHeader32 					As IMAGE_NT_HEADERS32
	PEHeader64 					As IMAGE_NT_HEADERS64
	SecHeader() 				As IMAGE_SECTION_HEADER
	HideSecHeader 				As IMAGE_SECTION_HEADER
	CLRHeader					As IMAGE_CLR20_HEADER
	MetaDataHeader				As IMAGE_METADATA_HEADER
	StreamHeader()				As IMAGE_STREAM_HEADER
End Type

'ڴӳ䷽ʽִ
Private Type SAFEARRAYBOUND
    cElements				As Long		'һάжٸԪ
    lLbound					As Long		'ʼֵ
End Type

'ڴӳ䷽ʽִ
Private Type SAFEARRAYID
    cDims					As Integer 	'ά
    fFeatures				As Integer	'
    cbElements				As Long		'ÿԪشС
    clocks					As Long		'鱻Ĵ
    pvData					As Long		'ݴλ
    rgsabound(0)			As SAFEARRAYBOUND
End Type

'ļʽĽṹ
Private Type FILE_IMAGE
	ModuleName				As String	'ļļ
	hFile					As Long		' Create ļӳ OpenFile ľ
	hMap					As Long		' CreateFileMapping ļӳľ
	MappedAddress			As Long		'ļӳ䵽ڴַ
	SizeOfImage				As Long		'ӳ Image ֽĴС
	SizeOfFile				As Long		'ʵļС
	ImageByte()				As Byte		'ļֽ
End Type

'ҳת
Private Declare Function MultiByteToWideChar Lib "kernel32.dll" ( _
	ByVal CodePage As Long, _
	ByVal dwFlags As Long, _
	ByRef lpMultiByteStr As Any, _
	ByVal cchMultiByte As Long, _
	ByVal lpWideCharStr As Long, _
	ByVal cchWideChar As Long) As Long

'ڴ渴ƺͱȽϺ
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
	ByRef Destination As Any, _
	ByRef Source As Any, _
	ByVal Length As Long)
Private Declare Sub MoveMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
	Dest As Any, _
	ByVal Source As Long, _
	ByVal Length As Long)
Private Declare Sub WriteMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
	ByVal Dest As Long, _
	ByRef Source As Any, _
	ByVal Length As Long)
Private Declare Function VarPtrArray Lib "msvbvm60.dll" Alias "VarPtr" (Ptr As Any) As Long

'ڶдļ
Private Declare Function CreateFile Lib "kernel32.dll" Alias "CreateFileA" ( _
	ByVal lpFileName As String, _
	ByVal dwDesiredAccess As Long, _
	ByVal dwShareMode As Long, _
	ByVal lpSecurityAttributes As Long, _
	ByVal dwCreationDisposition As Long, _
	ByVal dwFlagsAndAttributes As Long, _
	ByVal hTemplateFile As Long) As Long
Private Declare Function SetFilePointer Lib "kernel32.dll" ( _
	ByVal lngFile As Long, _
	ByVal lDistanceToMove As Long, _
	lpDistanceToMoveHigh As Long, _
	ByVal dwMoveMethod As Long) As Long
Private Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Long) As Long
Private Declare Function ReadFile Lib "kernel32.dll" ( _
	ByVal lngFile As Long, _
	lpBuffer As Any, _
	ByVal nNumberOfBytesToRead As Long, _
	lpNumberOfBytesRead As Long, _
	ByVal lpOverlapped As Long) As Long
Private Declare Function WriteFile Lib "kernel32.dll" ( _
	ByVal hFile As Long, _
	ByVal lpBuffer As Long, _
	ByVal nNumberOfBytesToWrite As Long, _
	lpNumberOfBytesWritten As Long, _
	ByVal lpOverlapped As Long) As Long
Private Declare Function GetFileSize Lib "kernel32.dll" ( _
	ByVal hFile As Long, _
	ByVal lpFileSizeHigh As Long) As Long
Private Declare Function SetEndOfFile Lib "kernel32.dll" (ByVal hFile As Long) As Long

'ļӳ亯
Private Declare Function CreateFileMapping Lib "kernel32.dll" Alias "CreateFileMappingA" ( _
	ByVal hFile As Long, _
	ByVal lpFileMappigAttributes As Long, _
	ByVal flProtect As Long, _
	ByVal dwMaximumSizeHigh As Long, _
	ByVal dwMaximumSizeLow As Long, _
	ByVal lpName As String) As Long
Private Declare Function MapViewOfFile Lib "kernel32.dll" ( _
	ByVal hFileMappingObject As Long, _
	ByVal dwDesiredAccess As Long, _
	ByVal dwFileOffsetHigh As Long, _
	ByVal dwFileOffsetLow As Long, _
	ByVal dwNumberOfBytesToMap As Long) As Long
Private Declare Function MapViewOfFileEx Lib "kernel32.dll" ( _
	ByVal hFileMappingObject As Long, _
	ByVal dwDesiredAccess As Long, _
	ByVal dwFileOffsetHigh As Long, _
	ByVal dwFileOffsetLow As Long, _
	ByVal dwNumberOfBytesToMap As Long, _
	lpBaseAddress As Any) As Long
Private Declare Function UnmapViewOfFile Lib "kernel32.dll" (ByVal lpBaseAddress As Long) As Long
Private Declare Function FlushViewOfFile Lib "kernel32.dll" ( _
	ByVal lpBaseAddress As Long, _
	ByVal dwNumberOfBytesToFlush As Long) As Long

'ʾϢ
Private Declare Function GetLastError Lib "kernel32.dll" () As Long
Private Declare Function FormatMessage Lib "kernel32.dll" Alias "FormatMessageA" ( _
	ByVal dwFlags As Long, _
	lpSource As Any, _
	ByVal dwMessageId As Long, _
	ByVal dwLanguageId As Long, _
	ByVal lpBuffer As String, _
	ByVal nSize As Long, _
	Arguments As Long) As Long

'ı
Private Declare Function SendMessageLNG Lib "user32.dll" Alias "SendMessageA" ( _
	ByVal hwnd As Long, _
	ByVal wMsg As Long, _
	ByVal wParam As Long, _
	ByVal lParam As Long) As Long

'ڷؿؼIDľ
Private Declare Function GetDlgItem Lib "user32.dll" ( _
	ByVal hDlg As Long, _
	ByVal nIDDlgItem As Long) As Long

'SendMessage API ֳ
Private Enum SendMsgValue
	WM_GETTEXT = &H0D				'ֽ,ַַ	ȡıؼı
	WM_GETTEXTLENGTH = &H0E			'0,0				ȡıؼıĳ(ֽ)
	WM_SETTEXT = &H0C				'0,ַַ		ôıؼı
End Enum

'ҳ
Private Enum KnownCodePage
	CP_UNICODELITTLE = 1200
	CP_UNICODEBIG = 1201
	CP_WESTEUROPE = 1252
	CP_ISOLATIN1 = 28591
End Enum

Private MsgList() As String,RegExp As Object
Private File As FILE_PROPERTIE,Data As STRING_SUB_PROPERTIE

Private Const Version = "2015.11.30"
Private Const Build = "151130"
Private Const TextJoinStr = vbCrLf
Private Const RefJoinStr = "|"
Private Const LoadMode = 0&
Private Const AppName = "Reference Search"


'
Sub Main()
	Dim TempList() As String
	' VBScript.RegExp Ƿ
	On Error Resume Next
	Set RegExp = CreateObject("VBScript.RegExp")
	If RegExp Is Nothing Then
		MsgBox(Err.Description & " - " & "VBScript.RegExp",vbInformation)
		Exit Sub
	End If
	RegExp.MultiLine = True
	On Error GoTo SysErrorMsg
	If GetMsgList(MsgList) = False Then GoTo SysErrorMsg
	Begin Dialog UserDialog 580,224,Replace$(Replace$(MsgList(12),"%v",Version),"%b",Build),.MainDlgFunc ' %GRID:10,7,1,1
		TextBox 0,0,0,21,.SuppValueBox
		TextBox 10,7,530,21,.FilePathBox
		PushButton 540,7,30,21,MsgList(13),.FilePathButton
		OptionGroup .ValTypeGroup
			OptionButton 10,35,60,21,MsgList(14),.DecButton
			OptionButton 80,35,60,21,MsgList(15),.HexButton
		CheckBox 80,35,60,21,"",.ValTypeCheckBox
		DropListBox 160,35,150,21,TempList(),.SecNameList
		Text 320,38,50,14,MsgList(16),.FileBitText
		DropListBox 370,35,110,21,TempList(),.FileBitList
		PushButton 490,35,80,21,MsgList(17),.AboutButton
		Text 10,66,50,14,MsgList(18),.RVAText
		TextBox 60,63,100,21,.RVABox
		Text 170,66,50,14,MsgList(19),.OffsetText
		TextBox 220,63,90,21,.OffsetBox
		Text 320,66,50,14,MsgList(20),.VACodeText
		DropListBox 370,63,110,21,TempList(),.VACodeList
		PushButton 490,63,80,21,MsgList(21),.SearchButton
		Text 10,98,450,14,Replace$(MsgList(22),"%s","0"),.ShowText
		TextBox 10,119,560,98,.ShowTextBox,1
		PushButton 490,91,80,21,MsgList(23),.CopyButton
		CancelButton 330,91,70,21,.CancelButton
	End Dialog
	Dim dlg As UserDialog
	If Dialog(dlg) = 0 Then Exit Sub
	Exit Sub
	SysErrorMsg:
	If Err.Source <> "ExitSub" Then Call sysErrorMassage(Err,0)
End Sub


'ز鿴Ի˽Ϣ
Private Function MainDlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim i As Long,Mode As Long,FN As FILE_IMAGE,Temp As String,TempList() As String
	Select Case Action%
	Case 1 ' Ի򴰿ڳʼ
		DlgText "SuppValueBox",CStr$(SuppValue)
		DlgVisible "SuppValueBox",False
		DlgVisible "CancelButton",False
		DlgVisible "ValTypeCheckBox",False
		DlgEnable "FilePathBox",False
		DlgEnable "CopyButton",False
		DlgValue "ValTypeCheckBox",DlgValue("ValTypeGroup")
		TempList = Split(MsgList(24),";")
		DlgListBoxArray "FileBitList",TempList()
		'תݲֵ
		If Command$ <> "" Then
			TempList = SplitArgument(Command$,",",2)
			Select Case UBound(TempList)
			Case 0
				File.FilePath = TempList(0)
				Data.lStartAddress = -1
			Case 1
				File.FilePath = TempList(0)
				If InStr(TempList(1),"0x") Then
					Data.lStartAddress = Val("&H" & TempList(1))
				Else
					Data.lStartAddress = StrToLong(TempList(1))
				End If
			End Select
			If Dir$(File.FilePath) = "" Then File.FilePath = ""
		End If
		DlgText "FilePathBox",File.FilePath
		If File.FilePath = "" Then
			Data.lStartAddress = -1
			DlgValue "FileBitList",0
			ReDim TempList(0) As String
			DlgListBoxArray "SecNameList",TempList()
			DlgValue "SecNameList",0
			DlgEnable "SearchButton",False
		Else
			File.FileSize = FileLen(File.FilePath)
			If GetHeaders(File.FilePath,File,LoadMode) = False Then
				DlgValue "FileBitList",1
				'ʾַ
				If Data.lStartAddress > -1 Then
					DlgText "OffsetBox",CStr$(Data.lStartAddress)
				End If
				'ȡļб
				TempList = getSectionNames(File,MsgList(25))
				i = UBound(TempList)
				ReDim Preserve TempList(i + 1) As String
				TempList(i + 1) = MsgList(27)
			Else
				'תĿ¼ṹַΪַ
				Call CovertDataDirectoryAddress(File)
				'ת.NET ͷṹַΪַ
				Call CovertNETHeadersAddress(File)
				If File.PEBitType = FILE_BIT_TYPE32 Then
					DlgValue "FileBitList",2
				Else
					DlgValue "FileBitList",3
				End If
				'ʾַ
				If Data.lStartAddress > -1 Then
					DlgText "OffsetBox",CStr$(Data.lStartAddress)
					DlgText "RVABox",CStr$(OffsetToRva(File,Data.lStartAddress))
				End If
				'ȡļб
				TempList = getSectionNames(File,MsgList(26))
				i = UBound(TempList)
				ReDim Preserve TempList(i + 3) As String
				TempList(i + 1) = MsgList(27)
				TempList(i + 2) = MsgList(28)
				TempList(i + 3) = MsgList(29)
			End If
			DlgListBoxArray "SecNameList",TempList()
			Data.inSectionID = SkipSection(File,Data.lStartAddress,0,0,1)
			If Data.inSectionID > -1 Then
				DlgValue "SecNameList",Data.inSectionID
			Else
				DlgValue "SecNameList",UBound(File.SecHeader) - Data.inSectionID + 1
				DlgEnable "SearchButton",False
			End If
		End If
	Case 2 ' ֵĻ߰°ťʱ
		MainDlgFunc = True ' ֹ°ťʱرնԻ򴰿
		Select Case DlgItem$
		Case "CancelButton"
			MainDlgFunc = False
		Case "AboutButton"
			MsgBox Replace$(Replace$(MsgList(31),"%v",Version),"%b",Build),vbOkOnly+vbInformation,MsgList(32)
		Case "FilePathButton"
			If PSL.SelectFile(Temp,True,MsgList(33),MsgList(34)) = False Then Exit Function
			If DlgText("FilePathBox") = Temp Then Exit Function
			If IsOpen(Temp,3,0) = True Then Exit Function
			DlgText "FilePathBox",Temp
			File.FilePath = Temp
			File.FileSize = FileLen(Temp)
			Data.lStartAddress = -1
			DlgText "OffsetBox",""
			DlgListBoxArray "VACodeList",TempList()
			DlgText "RVABox",""
			DlgText "ShowTextBox",""
			DlgText "ShowText",Replace$(MsgList(22),"%s","0")
			DlgEnable "CopyButton",False
			If GetHeaders(File.FilePath,File,LoadMode) = False Then
				DlgValue "FileBitList",1
				'ȡļб
				TempList = getSectionNames(File,MsgList(25))
				i = UBound(TempList)
				ReDim Preserve TempList(i + 1) As String
				TempList(i + 1) = MsgList(27)
			Else
				'תĿ¼ṹַΪַ
				Call CovertDataDirectoryAddress(File)
				'ת.NET ͷṹַΪַ
				Call CovertNETHeadersAddress(File)
				'ȡļ Bit λ
				If File.PEBitType = FILE_BIT_TYPE32 Then
					DlgValue "FileBitList",2
				Else
					DlgValue "FileBitList",3
				End If
				'ȡļб
				TempList = getSectionNames(File,MsgList(26))
				i = UBound(TempList)
				ReDim Preserve TempList(i + 3) As String
				TempList(i + 1) = MsgList(27)
				TempList(i + 2) = MsgList(28)
				TempList(i + 3) = MsgList(29)
			End If
			DlgListBoxArray "SecNameList",TempList()
			Data.inSectionID = SkipSection(File,Data.lStartAddress,0,0,1)
			If Data.inSectionID > -1 Then
				DlgValue "SecNameList",Data.inSectionID
				DlgEnable "SearchButton",True
			Else
				DlgValue "SecNameList",UBound(File.SecHeader) - Data.inSectionID + 1
				DlgEnable "SearchButton",False
			End If
		Case "ValTypeGroup"
			If DlgValue("ValTypeGroup") = DlgValue("ValTypeCheckBox") Then Exit Function
			DlgValue "ValTypeCheckBox",DlgValue("ValTypeGroup")
			If DlgValue("ValTypeGroup") = 0 Then
				If DlgText("OffsetBox") <> "" Then
					DlgText "OffsetBox",CStr$(Val("&H" & DlgText("OffsetBox")))
				End If
				If DlgText("RVABox") <> "" Then
					DlgText "RVABox",CStr$(Val("&H" & DlgText("RVABox")))
				End If
			Else
				If DlgText("OffsetBox") <> "" Then
					DlgText "OffsetBox",FormatHexStr(Hex$(StrToLong(DlgText("OffsetBox"))),2)
				End If
				If DlgText("RVABox") <> "" Then
					DlgText "RVABox",FormatHexStr(Hex$(StrToLong(DlgText("RVABox"))),2)
				End If
			End If
		Case "SecNameList"
			'ȡļб
			TempList = getSectionNames(File,IIf(File.PEBitType = 0,MsgList(25),MsgList(26)))
			i = UBound(TempList)
			If File.PEBitType = 0 Then
				ReDim Preserve TempList(i + 1) As String
				TempList(i + 1) = MsgList(27)
			Else
				ReDim Preserve TempList(i + 3) As String
				TempList(i + 1) = MsgList(27)
				TempList(i + 2) = MsgList(28)
				TempList(i + 3) = MsgList(29)
			End If
			DlgListBoxArray "SecNameList",TempList()
			Data.inSectionID = SkipSection(File,Data.lStartAddress,0,0,1)
			If Data.inSectionID > -1 Then
				DlgValue "SecNameList",Data.inSectionID
				DlgEnable "SearchButton",True
			Else
				DlgValue "SecNameList",UBound(File.SecHeader) - Data.inSectionID + 1
				DlgEnable "SearchButton",False
			End If
		Case "FileBitList"
			If File.PEBitType = FILE_BIT_TYPE32 Then
				DlgValue "FileBitList",2
			ElseIf File.PEBitType = FILE_BIT_TYPE64 Then
				DlgValue "FileBitList",3
			ElseIf DlgText("FilePathBox") = "" Then
				DlgValue "FileBitList",0
			Else
				DlgValue "FileBitList",1
			End If
		Case "SearchButton"
			If DlgText("FilePathBox") = "" Then Exit Function
			DlgListBoxArray "VACodeList",TempList()
			DlgText "ShowTextBox",""
			DlgText "ShowText",Replace$(MsgList(22),"%s","0")
			DlgEnable "CopyButton",False
			If DlgText("OffsetBox") = "" Or File.PEBitType = 0 Then Exit Function
			If Data.inSectionID < 0 Then Exit Function
			Mode = LoadFile(File.FilePath,FN,0,0,0,LoadMode)
			If Mode < -1 Then
				UnLoadFile(FN,0,Mode)
				Exit Function
			End If
			DlgEnable "SearchButton",False
			'PSL.OutputWnd(0).Clear
			'PSL.Output MsgList(35)
			DlgText "ShowText",MsgList(35)
			Call getVARefList(File,FN,Data,"",0,Mode,GetDlgItem(CLng(DlgText("SuppValueBox")),DlgControlId("ShowText")))
			UnLoadFile(FN,0,Mode)
			If Data.lReferenceNum > 0 Then
				TempList = RefList2StrList(Data,1)
			Else
				ReDim TempList(0) As String
				TempList(0) = MsgList(30)
			End If
			DlgListBoxArray "VACodeList",TempList()
			DlgValue "VACodeList",0
			DlgText "ShowTextBox",Reference2Str(File,Data)
			DlgText "ShowText",Replace$(MsgList(22),"%s",CStr$(Data.lReferenceNum))
			DlgEnable "SearchButton",True
			DlgEnable "CopyButton",IIf(DlgText("ShowTextBox") = "",False,True)
		Case "CopyButton"
			Clipboard Replace$(Replace$(Replace$(Replace$(MsgList(36),"%p",File.FilePath), _
					"%o",DlgText("OffsetBox")),"%r",DlgText("RVABox")),"%s",DlgText("ShowTextBox"))
		End Select
	Case 3 ' ıϿıʱ
		Select Case DlgItem$
		Case "OffsetBox"
			If DlgText("FilePathBox") = "" Then Exit Function
			If DlgText("OffsetBox") = "" Then
				Data.lStartAddress = -1
				Data.inSectionID = SkipSection(File,Data.lStartAddress,0,0,1)
				DlgText "RVABox",""
				If Data.inSectionID > -1 Then
					DlgValue "SecNameList",Data.inSectionID
					DlgEnable "SearchButton",True
				Else
					DlgValue "SecNameList",UBound(File.SecHeader) - Data.inSectionID + 1
					DlgEnable "SearchButton",False
				End If
				DlgListBoxArray "VACodeList",TempList()
				DlgText "ShowTextBox",""
				DlgText "ShowText",Replace$(MsgList(22),"%s","0")
				DlgEnable "CopyButton",False
				DlgEnable "SearchButton",False
				Exit Function
			End If
			DlgText "OffsetBox",Replace$(DlgText("OffsetBox")," ","")
			If DlgValue("ValTypeGroup") = 0 Then
				If CheckDecStr(DlgText("OffsetBox"),0) = False Then
					MsgBox(MsgList(40),vbOkOnly+vbInformation,MsgList(0))
					DlgText "OffsetBox",CStr$(Data.lStartAddress)
					Exit Function
				ElseIf StrToLong(DlgText("OffsetBox")) >= File.FileSize Then
					MsgBox(MsgList(41),vbOkOnly+vbInformation,MsgList(0))
					DlgText "OffsetBox",CStr$(Data.lStartAddress)
					Exit Function
				Else
					i = Data.lStartAddress
					Data.lStartAddress = StrToLong(DlgText("OffsetBox"))
					DlgText "RVABox",CStr$(OffsetToRva(File,Data.lStartAddress))
					If i = Data.lStartAddress Then Exit Function
				End If
			Else
				If CheckHexStr(DlgText("OffsetBox"),0) = False Then
					MsgBox(MsgList(40),vbOkOnly+vbInformation,MsgList(0))
					DlgText "OffsetBox",FormatHexStr(Hex$(Data.lStartAddress),2)
					Exit Function
				ElseIf Val("&H" & DlgText("OffsetBox")) >= File.FileSize Then
					MsgBox(MsgList(41),vbOkOnly+vbInformation,MsgList(0))
					DlgText "OffsetBox",FormatHexStr(Hex$(Data.lStartAddress),2)
					Exit Function
				Else
					i = Data.lStartAddress
					Data.lStartAddress = Val("&H" & DlgText("OffsetBox"))
					DlgText "RVABox",FormatHexStr(Hex$(OffsetToRva(File,Data.lStartAddress)),2)
					If i = Data.lStartAddress Then Exit Function
				End If
			End If
			Data.inSectionID = SkipSection(File,Data.lStartAddress,0,0,1)
			If Data.inSectionID > -1 Then
				DlgValue "SecNameList",Data.inSectionID
				DlgEnable "SearchButton",True
			Else
				DlgValue "SecNameList",UBound(File.SecHeader) - Data.inSectionID + 1
				DlgEnable "SearchButton",False
			End If
			DlgListBoxArray "VACodeList",TempList()
			DlgText "ShowTextBox",""
			DlgText "ShowText",Replace$(MsgList(22),"%s","0")
			DlgEnable "CopyButton",False
		Case "RVABox"
			If DlgText("FilePathBox") = "" Then Exit Function
			If DlgText("RVABox") = "" Then
				Data.lStartAddress = -1
				Data.inSectionID = SkipSection(File,Data.lStartAddress,0,0,1)
				DlgText "OffsetBox",""
				If Data.inSectionID > -1 Then
					DlgValue "SecNameList",Data.inSectionID
					DlgEnable "SearchButton",True
				Else
					DlgValue "SecNameList",UBound(File.SecHeader) - Data.inSectionID + 1
					DlgEnable "SearchButton",False
				End If
				DlgListBoxArray "VACodeList",TempList()
				DlgText "ShowTextBox",""
				DlgText "ShowText",Replace$(MsgList(22),"%s","0")
				DlgEnable "CopyButton",False
				DlgEnable "SearchButton",False
				Exit Function
			End If
			DlgText "RVABox",Replace$(DlgText("RVABox")," ","")
			If DlgValue("ValTypeGroup") = 0 Then
				If CheckDecStr(DlgText("RVABox"),0) = False Then
					MsgBox(MsgList(40),vbOkOnly+vbInformation,MsgList(0))
					DlgText "RVABox",CStr$(Data.lStartAddress)
					Exit Function
				ElseIf StrToLong(DlgText("RVABox")) >= File.FileSize Then
					MsgBox(MsgList(41),vbOkOnly+vbInformation,MsgList(0))
					DlgText "RVABox",CStr$(Data.lStartAddress)
					Exit Function
				Else
					i = Data.lStartAddress
					Data.lStartAddress = RvaToOffset(File,StrToLong(DlgText("RVABox")))
					DlgText "OffsetBox",CStr$(Data.lStartAddress)
					If i = Data.lStartAddress Then Exit Function
				End If
			Else
				If CheckHexStr(DlgText("RVABox"),0) = False Then
					MsgBox(MsgList(40),vbOkOnly+vbInformation,MsgList(0))
					DlgText "RVABox",FormatHexStr(Hex$(Data.lStartAddress),2)
					Exit Function
				ElseIf Val("&H" & DlgText("RVABox")) >= File.FileSize Then
					MsgBox(MsgList(41),vbOkOnly+vbInformation,MsgList(0))
					DlgText "RVABox",FormatHexStr(Hex$(Data.lStartAddress),2)
					Exit Function
				Else
					i = Data.lStartAddress
					Data.lStartAddress = RvaToOffset(File,Val("&H" & DlgText("RVABox")))
					DlgText "OffsetBox",FormatHexStr(Hex$(Data.lStartAddress),2)
					If i = Data.lStartAddress Then Exit Function
				End If
			End If
			Data.inSectionID = SkipSection(File,Data.lStartAddress,0,0,1)
			If Data.inSectionID > -1 Then
				DlgValue "SecNameList",Data.inSectionID
				DlgEnable "SearchButton",True
			Else
				DlgValue "SecNameList",UBound(File.SecHeader) - Data.inSectionID + 1
				DlgEnable "SearchButton",False
			End If
			DlgListBoxArray "VACodeList",TempList()
			DlgText "ShowTextBox",""
			DlgText "ShowText",Replace$(MsgList(22),"%s","0")
			DlgEnable "CopyButton",False
		End Select
	Case 6 ' ܼ
		Select Case SuppValue
		Case 1
			MsgBox Replace$(Replace$(MsgList(31),"%v",Version),"%b",Build),vbOkOnly+vbInformation,MsgList(32)
		Case 2
			Clipboard Replace$(Replace$(Replace$(Replace$(MsgList(36),"%p",File.FilePath), _
					"%o",DlgText("OffsetBox")),"%r",DlgText("RVABox")),"%s",DlgText("ShowTextBox"))
		End Select
	End Select
End Function


'ʮִǷҪ
Private Function CheckDecStr(ByVal textStr As String,ByVal Length As Integer) As Boolean
	If textStr = "" Then Exit Function
	If Length <> 0 Then
		If (Len(textStr) Mod Length) <> 0 Then Exit Function
	End If
	If CheckStr(textStr,"[0-9]",0,1) = False Then Exit Function
	CheckDecStr = True
End Function


'ʮִǷҪ
Private Function CheckHexStr(ByVal textStr As String,ByVal Length As Integer) As Boolean
	If textStr = "" Then Exit Function
	If Length <> 0 Then
		If (Len(textStr) Mod Length) <> 0 Then Exit Function
	End If
	If CheckStr(textStr,"[0-9A-Fa-f]",0,1) = False Then Exit Function
	CheckHexStr = True
End Function


'ִǷַָ(ıͨȽ)
'Mode = 0 ִǷַָҳַָλ
'Mode = 1 ִǷַָֻ
'Mode = 2 ִǷַָ
'Mode = 3 ִǷֻСдַָ
'Mode = 4 ִǷַͬStrNum Ϊַ
'StrRange  ִ鷶Χ ( [Min - Max|Min - Max] ʾΧ)
Public Function CheckStr(ByVal textStr As String,ByVal StrRange As String,Optional ByVal StrNum As Long,Optional ByVal Mode As Long) As Long
	Dim i As Long,Temp As String
	If StrRange = "" Then Exit Function
	If Trim$(textStr) = "" Then Exit Function
	Select Case Mode
	Case 0
		StrRange = Replace$(StrRange,"]|[","")
		If (textStr Like "*" & StrRange & "*") = False Then Exit Function
		For i = 1 To Len(textStr)
			If (Mid$(textStr,i,1) Like StrRange) = True Then
				CheckStr = i
				Exit For
			End If
		Next i
	Case 1
		If (textStr Like "*[!" & Replace$(Replace$(StrRange,"]|[",""),"[","") & "*") = False Then
			CheckStr = True
		End If
	Case 2
		If (textStr Like "*[" & Replace$(Replace$(StrRange,"]|[",""),"[","") & "*") = True Then
			CheckStr = True
		End If
	Case 3
		If InStr(textStr," ") Then Exit Function
		If Len(textStr) < 2 Then Exit Function
		If LCase$(textStr) = textStr Then Exit Function
		If UCase$(textStr) = textStr Then Exit Function
		If (textStr Like "*[!" & Replace$(Replace$(StrRange,"]|[",""),"[","") & "*") = True Then Exit Function
		If (Mid$(textStr,2) Like "*" & Split(StrRange,"|")(0) & "*") = True Then
			If (Mid$(textStr,2) Like "*" & Split(StrRange,"|")(1) & "*") = True Then
				CheckStr = True
			End If
		End If
	Case 4
		If StrNum < 2 Then Exit Function
		If Len(textStr) < StrNum Then Exit Function
		If InStr(textStr," ") Then Exit Function
		If IsNumeric(textStr) = True Then Exit Function
		If IsDate(textStr) = True Then Exit Function
		If (textStr Like "*" & Replace$(StrRange,"]|[","") & "*") = False Then Exit Function
		For i = 1 To Len(textStr)
			Temp = Mid$(textStr,i,1)
			If IsNumeric(Temp) = False Then
				If Temp <> "." Then
					If InStr(textStr,String$(StrNum,Temp)) Then
						CheckStr = True
						Exit For
					End If
				End If
			End If
		Next i
	End Select
End Function


'ݷõַбȡԴб(ִ)
'Mode = False '޸õַб򣬻ȡõַʹб
Private Sub getRefList(strData As STRING_SUB_PROPERTIE,RefAddList() As String,RefVAList() As String,ByVal Mode As Boolean)
	Dim i As Long,n As Long,Dic As Object
	With strData
		If .lReferenceNum = 0 Then
			ReDim RefList(0) As REFERENCE_PROPERTIE
			ReDim AddList(0) As String,VAList(0) As String
		Else
			n = UBound(RefAddList)
			ReDim RefList(n) As REFERENCE_PROPERTIE
			ReDim AddList(n) As String,VAList(n) As String
			Set Dic = CreateObject("Scripting.Dictionary")
			For i = 0 To .lReferenceNum - 1
				If Not Dic.Exists(.Reference(i).lAddress) Then
					Dic.Add(CStr(.Reference(i).lAddress),i)
				End If
			Next i
			n = 0
			For i = 0 To UBound(RefAddList)
				If Dic.Exists(RefAddList(i)) Then
					RefList(n) = .Reference(Dic.Item(RefAddList(i)))
					AddList(n) = CStr(RefList(n).lAddress)
					VAList(n) = RefList(n).sCode
					n = n + 1
				End If
			Next i
			Set Dic = Nothing
			If n > 0 Then
				ReDim Preserve RefList(n - 1) As REFERENCE_PROPERTIE
				ReDim Preserve AddList(n - 1) As String,VAList(n - 1) As String
			Else
				ReDim RefList(0) As REFERENCE_PROPERTIE
				ReDim AddList(0) As String,VAList(0) As String
			End If
		End If
		If Mode = False Then
			RefAddList = AddList
			RefVAList = VAList
		Else
			.Reference = RefList
			.lReferenceNum = n
			.GetRefState = IIf(n = 0,0,1)
		End If
	End With
End Sub


'õַбתַ(ִ)
'Mode = 0 'õַбתַ
'Mode = 1 'ôбתַ
'Mode > 1 'õִַбתַ
Private Function RefList2StrList(strData As STRING_SUB_PROPERTIE,ByVal Mode As Integer) As String()
	Dim i As Long
	With strData
		If .lReferenceNum = 0 Then
			ReDim TempList(0) As String
		Else
			ReDim TempList(.lReferenceNum - 1) As String
			If Mode = 0 Then
				For i = 0 To .lReferenceNum - 1
					TempList(i) = CStr(.Reference(i).lAddress)
				Next i
			Else
				For i = 0 To .lReferenceNum - 1
					TempList(i) = .Reference(i).sCode
				Next i
			End If
		End If
		RefList2StrList = TempList
	End With
End Function


'յֽλãؿյֽڿʼλ
'Offset > 0 ʱ Offset λú
Private Function getNullByteLong(FN As FILE_IMAGE,ByVal offset As Long,ByVal Max As Long,ByVal Mode As Long) As Long
	getNullByteLong = offset
	If offset + 1 > Max Then Exit Function
  	Do
		getNullByteLong = GetByte(FN,offset,Mode)
		offset = offset + 1
	Loop Until getNullByteLong = 0 Or offset > Max
	getNullByteLong = offset - 1
End Function


'תַΪ Long ֵ
Private Function StrToLong(ByVal mStr As String,Optional ByVal DefaultValue As Long) As Long
	On Error GoTo errHandle
	StrToLong = CLng(mStr)
	Exit Function
	errHandle:
	StrToLong = DefaultValue
End Function


'ȡ4ֵֽ (32 λֵ,4ֽ, -2,147,483,648  2,147,483,647)
Public Function GetLong(Source As Variant,Optional ByVal offset As Long = -1,Optional ByVal Mode As Long = -1) As Long
	On Error GoTo errHandle
	If offset + 4 > Source.SizeOfImage Then GoTo errHandle
	Select Case Mode
	Case Is < 0
		If offset < 0 Then
			Get #Source.hFile, , GetLong
		Else
			Get #Source.hFile, offset + 1, GetLong
		End If
	Case 0
		If offset < 0 Then GoTo errHandle
		CopyMemory GetLong, Source.ImageByte(offset), 4
	Case Else
		If offset < 0 Then GoTo errHandle
		MoveMemory GetLong, Source.MappedAddress + offset, 4
	End Select
	errHandle:
End Function


'ȡ2ֵֽ (16 λֵ, 2ֽ, -32,768  32,767)
Public Function GetInteger(Source As Variant,Optional ByVal offset As Long = -1,Optional ByVal Mode As Long = -1) As Integer
	On Error GoTo errHandle
	If offset + 2 > Source.SizeOfImage Then GoTo errHandle
	Select Case Mode
	Case Is < 0
		If offset < 0 Then
			Get #Source.hFile, , GetInteger
		Else
			Get #Source.hFile, offset + 1, GetInteger
		End If
	Case 0
		If offset < 0 Then GoTo errHandle
		CopyMemory GetInteger, Source.ImageByte(offset), 2
	Case Else
		If offset < 0 Then GoTo errHandle
		MoveMemory GetInteger, Source.MappedAddress + offset, 2
	End Select
	errHandle:
End Function


'ַָȡһֽ(8 λֵ, 1ֽ)
Public Function GetByte(Source As Variant,Optional ByVal offset As Long = -1,Optional ByVal Mode As Long = -1) As Byte
	On Error GoTo errHandle
	If offset + 1 > Source.SizeOfImage Then GoTo errHandle
	Select Case Mode
	Case Is < 0
		If offset < 0 Then
			Get #Source.hFile, , GetByte
		Else
			Get #Source.hFile, offset + 1, GetByte
		End If
	Case 0
		If offset < 0 Then GoTo errHandle
		GetByte = Source.ImageByte(offset)
	Case Else
		If offset < 0 Then GoTo errHandle
		MoveMemory GetByte, Source.MappedAddress + offset, 1
	End Select
	errHandle:
End Function


'ȡڵֽ
Public Function GetBytes(Source As Variant,ByVal Length As Long,Optional ByVal offset As Long = -1,Optional ByVal Mode As Long = -1) As Byte()
	On Error GoTo errHandle
	If offset + Length > Source.SizeOfImage Then GoTo errHandle
	ReDim Bytes(Length - 1) As Byte
	Select Case Mode
	Case Is < 0
		If offset < 0 Then
			Get #Source.hFile, , Bytes
		Else
			Get #Source.hFile, offset + 1, Bytes
		End If
	Case 0
		If offset < 0 Then GoTo errHandle
		CopyMemory Bytes(0), Source.ImageByte(offset), Length
	Case Else
		If offset < 0 Then GoTo errHandle
		MoveMemory Bytes(0), Source.MappedAddress + offset, Length
	End Select
	GetBytes = Bytes
	Exit Function
	errHandle:
	ReDim Bytes(0) As Byte
	GetBytes = Bytes
End Function


'ȡֽ(ڴӳ䷽ʽ)
Private Function getBytesByMap(ByVal Source As Long,ByVal Length As Long) As Byte()
	Dim ppSA As Long, pSA As Long
	Dim tagNewSA As SAFEARRAYID, tagOldSA As SAFEARRAYID
	ReDim Bytes(0) As Byte							'ʼ
	ppSA = VarPtrArray(Bytes)						'ָSAFEARRAYָָ
	MoveMemory pSA, ppSA, 4							'ָSAFEARRAYָ
	MoveMemory tagOldSA, pSA, Len(tagOldSA)			'ԭSAFEARRAYԱϢ
	CopyMemory tagNewSA, tagOldSA, Len(tagNewSA)	'SAFEARRAYԱϢ
	tagNewSA.rgsabound(0).cElements = Length		'޸Ԫظ
	tagNewSA.pvData = Source						'޸ݵַ
	WriteMemory pSA, tagNewSA, Len(tagNewSA)		'ӳݵַ
    getBytesByMap = Bytes
    WriteMemory pSA, tagOldSA, Len(tagOldSA)		'ָSAFEARRAYṹԱϢ
End Function


'ȡԶֵ
Public Function GetTypeValue(Source As FILE_IMAGE,ByVal offset As Long,Target As Variant,Optional ByVal Mode As Long = -1) As Boolean
	On Error GoTo errHandle
	If offset < 0 Then GoTo errHandle
	If offset +  Len(Target) > Source.SizeOfImage Then GoTo errHandle
	Select Case Mode
	Case Is < 0
		Get #Source.hFile, offset + 1, Target
	Case 0
		CopyMemory Target, Source.ImageByte(offset), Len(Target)
	Case Else
		MoveMemory Target, Source.MappedAddress + offset, Len(Target)
	End Select
	GetTypeValue = True
	errHandle:
End Function


'ȡԶ
Public Function GetTypeArray(Source As FILE_IMAGE,ByVal Offset As Long,Target As Variant,Optional ByVal Mode As Long = -1) As Boolean
	On Error GoTo errHandle
	If offset < 0 Then GoTo errHandle
	If offset + Len(Target(0)) * (UBound(Target) + 1) > Source.SizeOfImage Then GoTo errHandle
	Select Case Mode
	Case Is < 0
		Get #Source.hFile, offset + 1, Target
	Case 0
		CopyMemory Target(0), Source.ImageByte(offset), Len(Target(0)) * (UBound(Target) + 1)
	Case Else
		MoveMemory Target(0), Source.MappedAddress + offset, Len(Target(0)) * (UBound(Target) + 1)
	End Select
	GetTypeArray = True
	errHandle:
End Function


'ȡֽڳ
Private Function GetFileLength(Source As FILE_IMAGE,Optional ByVal Mode As Long = -1) As Long
	Select Case Mode
	Case Is < 0
		GetFileLength = LOF(Source.hFile)
	Case 0
		GetFileLength = Source.SizeOfFile	'UBound(Source.ImageByte) + 1
	Case Else
		GetFileLength = Source.SizeOfFile	'GetFileSize(Source.hFile, 0&)
	End Select
End Function


'ļǷѱ򿪻ռ
Private Function IsOpen(ByVal strFilePath As String,Optional ByVal Continue As Long = 3,Optional ByVal WaitTime As Double = 0.5) As Boolean
	Dim i As Long,FN As Variant
	'Դļ
	On Error Resume Next
	FN = FreeFile
	Do
		Open strFilePath For Binary Access Read Lock Write As #FN
		If Err.Number = 0 Or i > 10 Then Exit Do
		Wait WaitTime
		Err.Clear
		i = i + 1
	Loop
	Close #FN
	If Err.Number = 0 Then Exit Function
	ErrorHandle:
	IsOpen = True
	Err.Source = "NotOpenFile"
	Err.Description = Err.Description & TextJoinStr & strFilePath
	Call sysErrorMassage(Err,Continue)
End Function


'ȡļļݽṹϢ
Public Function GetHeaders(ByVal strFilePath As String,File As FILE_PROPERTIE,ByVal Mode As Long) As Boolean
	Dim i As Long,FN As FILE_IMAGE,TempList() As String,Temp As String
	On Error GoTo ExitFunction
	'ļ
	Mode = LoadFile(strFilePath,FN,0,0,0,Mode)
	If Mode < -1 Then Exit Function
	'ȡļͷ
	GetHeaders = GetHeader(FN,File,Mode)
	If GetHeaders = False Then GoTo ExitFunction
	'ȡļͷ
	With File.HideSecHeader
		If .lSizeOfRawData = 0 Then GoTo ExitFunction
		Temp = ByteToString(GetBytes(FN,.lSizeOfRawData,.lPointerToRawData,Mode),CP_ISOLATIN1)
		TempList = GetVAListRegExp(Temp,"MZ[\x00-\xFF]{64,384}?PE\x00",.lPointerToRawData)
		If CheckArray(TempList) = False Then GoTo ExitFunction
		Dim SubFile As FILE_PROPERTIE
		File.iNumberOfSubPE = UBound(TempList) + 1
		For i = 0 To File.iNumberOfSubPE - 1
			If GetHeader(FN,SubFile,Mode,CLng(TempList(i))) = True Then
				'޸ļؽڴС
				.lSizeOfRawData = CLng(TempList(i)) - .lPointerToRawData
				Exit For
			End If
		Next i
		ExitFunction:
	End With
	'رļ
	On Error Resume Next
	UnLoadFile(FN,0,Mode)
End Function


'ȡļݽṹϢ
Private Function GetHeader(FN As FILE_IMAGE,File As FILE_PROPERTIE,ByVal Mode As Long,Optional ByVal Offset As Long) As Boolean
	Dim DosHeader As IMAGE_DOS_HEADER,PEHeader As IMAGE_NT_HEADERS
	Dim PEHeader32 As IMAGE_NT_HEADERS32,PEHeader64 As IMAGE_NT_HEADERS64
	Dim CLRHeader As IMAGE_CLR20_HEADER,MetaDataHeader As IMAGE_METADATA_HEADER
	On Error GoTo ExitFunction
	With File
		'ʼ
		.PEBitType = 0
		.PELangType = 0
		.MinSecID = 0
		.MaxSecID = 0
		.HideSecHeader.lPointerToRawData = 0
		.HideSecHeader.lSizeOfRawData = 0
		.HideSecHeader.lVirtualAddress = 0
		.HideSecHeader.lVirtualSize = 0
		.iNumberOfSubPE = 0
		.DosHeader = DosHeader
		.PEHeader = PEHeader
		.PEHeader32 = PEHeader32
		.PEHeader64 = PEHeader64
		.CLRHeader = CLRHeader
		.MetaDataHeader = MetaDataHeader
		.USStreamID = -1
		ReDim File.SecHeader(0) 'As IMAGE_SECTION_HEADER
		ReDim File.StreamHeader(0) 'As IMAGE_STREAM_HEADER
		'ȡ PE IMAGE_DOS_HEADERS ṹ
		'GetTypeValue(FN,Offset,.DosHeader,Mode)
		Select Case Mode
		Case Is < 0
			Get #FN.hFile, Offset + 1, .DosHeader
		Case 0
			CopyMemory .DosHeader, FN.ImageByte(Offset), Len(.DosHeader)
		Case Else
			MoveMemory .DosHeader, Offset + FN.MappedAddress, Len(.DosHeader)
		End Select
		If .DosHeader.iSignature <> IMAGE_DOS_SIGNATURE Then GoTo ExitFunction
		'Ǳ
		.PELangType = .DosHeader.iLastPageBytes
		'32λȡ PE IMAGE_NT_HEADERS ṹ
		'GetTypeValue(FN,Offset + .DosHeader.lPointerToPEHeader,.PEHeader32,Mode)
		Select Case Mode
		Case Is < 0
			Get #FN.hFile, Offset + .DosHeader.lPointerToPEHeader + 1, .PEHeader32
		Case 0
			CopyMemory .PEHeader32, FN.ImageByte(Offset + .DosHeader.lPointerToPEHeader), Len(.PEHeader32)
		Case Else
			MoveMemory .PEHeader32, Offset + FN.MappedAddress + .DosHeader.lPointerToPEHeader, Len(.PEHeader32)
		End Select
		If .PEHeader32.lSignature <> IMAGE_NT_SIGNATURE Then GoTo ExitFunction
		'жǷΪ32λPEļ
		If .PEHeader32.OptionalHeader.iMagic = IMAGE_NT_OPTIONAL_HDR32_MAGIC Then
			'ת32λ PE IMAGE_NT_HEADERS ṹݵPE IMAGE_NT_HEADERS ṹ
			If CovertPEHeader32(.PEHeader,.PEHeader32) = False Then GoTo ExitFunction
			'Ƿļڽṹ
			If .PEHeader.FileHeader.iNumberOfSections = 0 Then GoTo ExitFunction
			'ȡļڽṹ
			ReDim File.SecHeader(.PEHeader.FileHeader.iNumberOfSections - 1) 'As IMAGE_SECTION_HEADER
			'GetTypeArray(FN,Offset + .DosHeader.lPointerToPEHeader + Len(.PEHeader32),.SecHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, Offset + .DosHeader.lPointerToPEHeader + Len(.PEHeader32) + 1, .SecHeader
			Case 0
				CopyMemory .SecHeader(0), FN.ImageByte(Offset + .DosHeader.lPointerToPEHeader + Len(.PEHeader32)), Len(.SecHeader(0)) * (UBound(.SecHeader) + 1)
			Case Else
				MoveMemory .SecHeader(0), Offset + FN.MappedAddress + .DosHeader.lPointerToPEHeader + Len(.PEHeader32), Len(.SecHeader(0)) * (UBound(.SecHeader) + 1)
			End Select
			'ȡļ Bit λ
			.PEBitType = FILE_BIT_TYPE32
		ElseIf .PEHeader32.OptionalHeader.iMagic = IMAGE_NT_OPTIONAL_HDR64_MAGIC Then
			'64λȡ PE IMAGE_NT_HEADERS ṹ
			'GetTypeValue(FN,Offset + .DosHeader.lPointerToPEHeader,.PEHeader64,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, Offset + .DosHeader.lPointerToPEHeader + 1, .PEHeader64
			Case 0
				CopyMemory .PEHeader64, FN.ImageByte(Offset + .DosHeader.lPointerToPEHeader), Len(.PEHeader64)
			Case Else
				MoveMemory .PEHeader64, Offset + FN.MappedAddress + .DosHeader.lPointerToPEHeader, Len(.PEHeader64)
			End Select
			'ת64λ PE IMAGE_NT_HEADERS ṹݵPE IMAGE_NT_HEADERS ṹ
			If CovertPEHeader64(.PEHeader,.PEHeader64) = False Then GoTo ExitFunction
			'Ƿļڽṹ
			If .PEHeader.FileHeader.iNumberOfSections = 0 Then GoTo ExitFunction
			'ȡļڽṹ
			ReDim File.SecHeader(.PEHeader.FileHeader.iNumberOfSections - 1) 'As IMAGE_SECTION_HEADER
			'GetTypeArray(FN,Offset + .DosHeader.lPointerToPEHeader + Len(.PEHeader64),.SecHeader,Mode)
			Select Case Mode
			Case Is < 0
				Get #FN.hFile, Offset + .DosHeader.lPointerToPEHeader + Len(.PEHeader64) + 1, .SecHeader
			Case 0
				CopyMemory .SecHeader(0), FN.ImageByte(Offset + .DosHeader.lPointerToPEHeader + Len(.PEHeader64)), Len(.SecHeader(0)) * (UBound(.SecHeader) + 1)
			Case Else
				MoveMemory .SecHeader(0), Offset + FN.MappedAddress + .DosHeader.lPointerToPEHeader + Len(.PEHeader64), Len(.SecHeader(0)) * (UBound(.SecHeader) + 1)
			End Select
			'ȡļ Bit λ
			.PEBitType = FILE_BIT_TYPE64
		Else
			GoTo ExitFunction
		End If
		'ȡ .NET ͷṹ
		If GetNETHeader(FN,File,Mode,Offset) = True Then .PELangType = NET_FILE_SIGNATURE
		'ȡСƫƵַڽڵ
		GetSectionID(.SecHeader,.MinSecID,.MaxSecID,False)
		'ȡؽϢ
		.HideSecHeader.lPointerToRawData = .SecHeader(.MaxSecID).lPointerToRawData + .SecHeader(.MaxSecID).lSizeOfRawData
		.HideSecHeader.lSizeOfRawData = GetFileLength(FN,Mode) - .HideSecHeader.lPointerToRawData
		.HideSecHeader.lVirtualAddress = .SecHeader(.MaxSecID).lVirtualAddress + .SecHeader(.MaxSecID).lVirtualSize
		.HideSecHeader.lVirtualSize = .HideSecHeader.lSizeOfRawData
		'ǳɹ
		GetHeader = True
		ExitFunction:
		If GetHeader = True Then Exit Function
		'ļΪһ
		.SecHeader(0).lSizeOfRawData = GetFileLength(FN,Mode)
		.SecHeader(0).lVirtualSize = .SecHeader(0).lVirtualSize
		'ؽϢʾļϢ
		.HideSecHeader.lPointerToRawData = .SecHeader(0).lSizeOfRawData
		.HideSecHeader.lVirtualAddress = .SecHeader(0).lSizeOfRawData
	End With
End Function


'ȡ .NET ͷṹ
Private Function GetNETHeader(FN As FILE_IMAGE,File As FILE_PROPERTIE,ByVal Mode As Long,Optional ByVal Offset As Long) As Boolean
	Dim i As Long,Length As Long,dwOffset As Long
	On Error GoTo ExitFunction
	With File
		'ת15Ŀ¼ַתƫƵַ
		dwOffset = RvaToOffset(File,.PEHeader.OptionalHeader.DataDirectory(14).lVirtualAddress)
		If dwOffset = 0 Then GoTo ExitFunction
		'ȡ CLR ṹ
		'GetTypeValue(FN,Offset + dwOffset,.CLRHeader,Mode)
		Select Case Mode
		Case Is < 0
			Get #FN.hFile, Offset + dwOffset + 1, .CLRHeader
		Case 0
			CopyMemory .CLRHeader, FN.ImageByte(Offset + dwOffset), Len(.CLRHeader)
		Case Else
			MoveMemory .CLRHeader, Offset + FN.MappedAddress + dwOffset, Len(.CLRHeader)
		End Select
		'ת CLR е MetaData ַתƫƵַ
		dwOffset = RvaToOffset(File,.CLRHeader.METADATA.lVirtualAddress)
		If dwOffset = 0 Then GoTo ExitFunction
	End With
	'ǷΪ .NET ļ
	With File.MetaDataHeader
		.lSignature = GetLong(FN,Offset + dwOffset,Mode)
		If .lSignature <> NET_FILE_SIGNATURE Then GoTo ExitFunction
		'ȡ MetaDataHeader.Version ֽڳ
		.lLength = GetLong(FN,Offset + dwOffset + 12,Mode)
		' 4 ֽڶ MetaDataHeader.Version ֽڳ
		If .lLength Mod 4 <> 0 Then .lLength = 4 * (.lLength \ 4 + 1)
		'ȡ METADATA ṹ
		.iMajorVersion = GetInteger(FN,Offset + dwOffset + 4,Mode)
		.iMinorVersion = GetInteger(FN,Offset + dwOffset + 6,Mode)
		.lExtraData = GetLong(FN,Offset + dwOffset + 8,Mode)
		.Version = GetBytes(FN,.lLength,Offset + dwOffset + 16,Mode)
		.fFlags = GetInteger(FN,Offset + dwOffset + 16 + .lLength,Mode)
		.iStreams = GetInteger(FN,Offset + dwOffset + 18 + .lLength,Mode)
	End With
	'ȡļͷṹ
	With File
		If .MetaDataHeader.iStreams > 0 Then
			ReDim File.StreamHeader(.MetaDataHeader.iStreams - 1) 'As IMAGE_STREAM_HEADER
			dwOffset = dwOffset + 20 + .MetaDataHeader.lLength
			For i = 0 To .MetaDataHeader.iStreams - 1
				'lOffset  Metadata Rootʵ RVA = .CLRHeader.MetaData.lVirtualAddress + .StreamHeader(i).lOffset
				.StreamHeader(i).RWA = dwOffset + 0
				.StreamHeader(i).lOffset = GetLong(FN,Offset + dwOffset + 0,Mode)
				.StreamHeader(i).lSize = GetLong(FN,Offset + dwOffset + 4,Mode)
				'ȡ .StreamHeader.rcName ֽڳ
				dwOffset = dwOffset + 8
				Length = getNullByteLong(FN,Offset + dwOffset,Offset + dwOffset + 16,Mode) - dwOffset + 1
				' 4 ֽڶ .StreamHeader.rcName ֽڳ
				If Length Mod 4 <> 0 Then Length = 4 * (Length \ 4 + 1)
				.StreamHeader(i).rcName = GetBytes(FN,Length,Offset + dwOffset,Mode)
				If UCase$(Replace$(StrConv$(.StreamHeader(i).rcName,vbUnicode),vbNullChar,"")) = "#US" Then
					.USStreamID = i
				End If
				dwOffset = dwOffset + Length
			Next i
		End If
	End With
	'ǳɹ
	GetNETHeader = True
	ExitFunction:
End Function


'ת32λ PEHeader ṹΪݵ PEHeader ṹ
Private Function CovertPEHeader32(PEHeader As IMAGE_NT_HEADERS,PE32Header As IMAGE_NT_HEADERS32) As Boolean
	Dim i As Integer
	On Error GoTo ErrHandle
	PEHeader.FileHeader.iNumberOfSections = PE32Header.FileHeader.iNumberOfSections
	With PEHeader.OptionalHeader
		'******************
		'׼
		'******************
		.iMagic = PE32Header.OptionalHeader.iMagic
		.bMajorLinkerVersion = PE32Header.OptionalHeader.bMajorLinkerVersion
		.bMinorLinkerVersion = PE32Header.OptionalHeader.bMinorLinkerVersion
		.lSizeOfCode = PE32Header.OptionalHeader.lSizeOfCode
		.lSizeOfInitializedData = PE32Header.OptionalHeader.lSizeOfInitializedData
		.lSizeOfUninitializedData = PE32Header.OptionalHeader.lSizeOfUninitializedData
		.lAddressOfEntryPoint = PE32Header.OptionalHeader.lAddressOfEntryPoint
		.lBaseOfCode = PE32Header.OptionalHeader.lBaseOfCode
		.lBaseOfData = PE32Header.OptionalHeader.lBaseOfData
		'******************
		'NT 
		'******************
		.dImageBase = PE32Header.OptionalHeader.lImageBase
		.lSectionAlignment = PE32Header.OptionalHeader.lSectionAlignment
		.lFileAlignment = PE32Header.OptionalHeader.lFileAlignment
		.iMajorOperatingSystemVersion = PE32Header.OptionalHeader.iMajorOperatingSystemVersion
		.iMinorOperatingSystemVersion = PE32Header.OptionalHeader.iMinorOperatingSystemVersion
		.iMajorImageVersion = PE32Header.OptionalHeader.iMajorImageVersion
		.iMinorImageVersion = PE32Header.OptionalHeader.iMinorImageVersion
		.iMajorSubsystemVersion = PE32Header.OptionalHeader.iMajorSubsystemVersion
		.iMinorSubsystemVersion = PE32Header.OptionalHeader.iMinorSubsystemVersion
		.lWin32VersionValue = PE32Header.OptionalHeader.lWin32VersionValue
		.lSizeOfImage = PE32Header.OptionalHeader.lSizeOfImage
		.lSizeOfHeaders = PE32Header.OptionalHeader.lSizeOfHeaders
		.lCheckSum = PE32Header.OptionalHeader.lCheckSum
		.iSubsystem = PE32Header.OptionalHeader.iSubsystem
		.iDllCharacteristics = PE32Header.OptionalHeader.iDllCharacteristics
		.dSizeOfStackReserve = PE32Header.OptionalHeader.lSizeOfStackReserve
		.dSizeOfStackCommit = PE32Header.OptionalHeader.lSizeOfStackCommit
		.dSizeOfHeapReserve = PE32Header.OptionalHeader.lSizeOfHeapReserve
		.dSizeOfHeapCommit = PE32Header.OptionalHeader.lSizeOfHeapCommit
		.lLoaderFlags = PE32Header.OptionalHeader.lLoaderFlags
		.lNumberOfRvaAndSizes = PE32Header.OptionalHeader.lNumberOfRvaAndSizes
		For i = 0 To UBound(.DataDirectory)
			.DataDirectory(i) = PE32Header.OptionalHeader.DataDirectory(i)
		Next i
	End With
	CovertPEHeader32 = True
	ErrHandle:
End Function


'ת64λ PEHeader ṹΪݵ PEHeader ṹ
Private Function CovertPEHeader64(PEHeader As IMAGE_NT_HEADERS,PE64Header As IMAGE_NT_HEADERS64) As Boolean
	Dim i As Integer
	On Error GoTo ErrHandle
	PEHeader.FileHeader.iNumberOfSections = PE64Header.FileHeader.iNumberOfSections
	With PEHeader.OptionalHeader
		'******************
		'׼
		'******************
		.iMagic = PE64Header.OptionalHeader.iMagic
		.bMajorLinkerVersion = PE64Header.OptionalHeader.bMajorLinkerVersion
		.bMinorLinkerVersion = PE64Header.OptionalHeader.bMinorLinkerVersion
		.lSizeOfCode = PE64Header.OptionalHeader.lSizeOfCode
		.lSizeOfInitializedData = PE64Header.OptionalHeader.lSizeOfInitializedData
		.lSizeOfUninitializedData = PE64Header.OptionalHeader.lSizeOfUninitializedData
		.lAddressOfEntryPoint = PE64Header.OptionalHeader.lAddressOfEntryPoint
		.lBaseOfCode = PE64Header.OptionalHeader.lBaseOfCode
		'.lBaseOfData = PE64Header.OptionalHeader.lBaseOfData
		'******************
		'NT 
		'******************
		.dImageBase = PE64Header.OptionalHeader.dImageBase
		.lSectionAlignment = PE64Header.OptionalHeader.lSectionAlignment
		.lFileAlignment = PE64Header.OptionalHeader.lFileAlignment
		.iMajorOperatingSystemVersion = PE64Header.OptionalHeader.iMajorOperatingSystemVersion
		.iMinorOperatingSystemVersion = PE64Header.OptionalHeader.iMinorOperatingSystemVersion
		.iMajorImageVersion = PE64Header.OptionalHeader.iMajorImageVersion
		.iMinorImageVersion = PE64Header.OptionalHeader.iMinorImageVersion
		.iMajorSubsystemVersion = PE64Header.OptionalHeader.iMajorSubsystemVersion
		.iMinorSubsystemVersion = PE64Header.OptionalHeader.iMinorSubsystemVersion
		.lWin32VersionValue = PE64Header.OptionalHeader.lWin32VersionValue
		.lSizeOfImage = PE64Header.OptionalHeader.lSizeOfImage
		.lSizeOfHeaders = PE64Header.OptionalHeader.lSizeOfHeaders
		.lCheckSum = PE64Header.OptionalHeader.lCheckSum
		.iSubsystem = PE64Header.OptionalHeader.iSubsystem
		.iDllCharacteristics = PE64Header.OptionalHeader.iDllCharacteristics
		.dSizeOfStackReserve = PE64Header.OptionalHeader.dSizeOfStackReserve
		.dSizeOfStackCommit = PE64Header.OptionalHeader.dSizeOfStackCommit
		.dSizeOfHeapReserve = PE64Header.OptionalHeader.dSizeOfHeapReserve
		.dSizeOfHeapCommit = PE64Header.OptionalHeader.dSizeOfHeapCommit
		.lLoaderFlags = PE64Header.OptionalHeader.lLoaderFlags
		.lNumberOfRvaAndSizes = PE64Header.OptionalHeader.lNumberOfRvaAndSizes
		For i = 0 To UBound(.DataDirectory)
			.DataDirectory(i) = PE64Header.OptionalHeader.DataDirectory(i)
		Next i
	End With
	CovertPEHeader64 = True
	ErrHandle:
End Function


'ַתƫƵַ
Private Function RvaToOffset(File As FILE_PROPERTIE,ByVal dwRvaAddr As Long) As Long
	Dim i As Integer
	On Error GoTo ErrHandle
	RvaToOffset = -1
	For i = 0 To UBound(File.SecHeader)
		With File.SecHeader(i)
			If dwRvaAddr >= .lVirtualAddress And dwRvaAddr < .lVirtualAddress + .lVirtualSize Then
				RvaToOffset = dwRvaAddr + .lPointerToRawData - .lVirtualAddress
				Exit Function
			End If
		End With
	Next i
	If RvaToOffset = -1 Then
		If dwRvaAddr > -1 And dwRvaAddr < File.SecHeader(File.MinSecID).lVirtualAddress Then
			RvaToOffset = dwRvaAddr
			Exit Function
		End If
	End If
	ErrHandle:
	RvaToOffset = 0
End Function


'ƫƵַתַ
Private Function OffsetToRva(File As FILE_PROPERTIE,ByVal dwOffset As Long) As Long
	Dim i As Integer
	On Error GoTo ErrHandle
	OffsetToRva = -1
	For i = 0 To UBound(File.SecHeader)
		With File.SecHeader(i)
			If dwOffset >= .lPointerToRawData And dwOffset < .lPointerToRawData + .lSizeOfRawData Then
				OffsetToRva = dwOffset + .lVirtualAddress - .lPointerToRawData
				Exit Function
			End If
		End With
	Next i
	If OffsetToRva = -1 Then
		If dwOffset > -1 And dwOffset < File.SecHeader(File.MinSecID).lPointerToRawData Then
			OffsetToRva = dwOffset
			Exit Function
		End If
	End If
	ErrHandle:
	OffsetToRva = 0
End Function


'ӳļ
'MapSize = 0 ļʼʱĴСӳ䣬ָСӳ
'ReadOnly = 0 ֻʽдʽ
'SizeOfFile = 0 ȡļʼʱĴС򲻻ȡ
'IsPE = 0 һļӳ䣬 PE ļӳ(ÿڶ)
Private Function MapFile(ByVal strFilePath As String,LoadedImage As FILE_IMAGE,ByVal MapSize As Long, _
		ByVal ReadOnly As Long,Optional ByVal SizeOfFile As Long,Optional ByVal IsPE As Long) As Boolean
	With LoadedImage
		If UnMapFile(LoadedImage,SizeOfFile) = False Then Exit Function
		.ModuleName = strFilePath
		.hFile = CreateFile(strFilePath, _
				GENERIC_READ Or GENERIC_WRITE, _
				FILE_SHARE_READ Or FILE_SHARE_WRITE, _
				0&, _
				OPEN_EXISTING, _
				FILE_ATTRIBUTE_NORMAL Or FILE_ATTRIBUTE_ARCHIVE Or _
				FILE_ATTRIBUTE_READONLY Or FILE_ATTRIBUTE_HIDDEN Or _
				FILE_ATTRIBUTE_SYSTEM, _
				0&)
		If .hFile = 0 Then Exit Function
		If SizeOfFile = 0 Then .SizeOfFile = GetFileSize(.hFile, 0&)
		If IsPE = 0 Then
			.hMap = CreateFileMapping(.hFile, 0&, PAGE_READWRITE, 0, MapSize, vbNullChar)
		Else
			.hMap = CreateFileMapping(.hFile, 0&, PAGE_EXECUTE_READWRITE Or SEC_IMAGE, 0, MapSize, vbNullChar)
		End If
		If .hMap = 0 Then
			DisplayError "CreateFileMapping",GetLastError()
			If CloseHandle(.hFile) = 0 Then
				DisplayError "CloseHandle",GetLastError()
			End If
			Exit Function
		End If
		If ReadOnly = 0 Then
			.MappedAddress = MapViewOfFile(.hMap, FILE_MAP_READ, 0, 0, MapSize)
		Else
			.MappedAddress = MapViewOfFile(.hMap, FILE_MAP_WRITE, 0, 0, MapSize)
		End If
		If .MappedAddress = 0 Then
			DisplayError "MapViewOfFile",GetLastError()
			If CloseHandle(.hMap) = 0 Then
				DisplayError "CloseHandle",GetLastError()
			End If
			If CloseHandle(.hFile) = 0 Then
				DisplayError "CloseHandle",GetLastError()
			End If
			Exit Function
    	End If
    	If MapSize = 0 Then
    		.SizeOfImage = GetFileSize(.hFile, 0&)
    	Else
    		.SizeOfImage = MapSize
    	End If
    	MapFile = True
    End With
End Function


'رӳļ
'SizeOfFile = 0 ļʵʴС棬ָС
Private Function UnMapFile(LoadedImage As FILE_IMAGE,Optional ByVal SizeOfFile As Long) As Boolean
	With LoadedImage
		If .MappedAddress > 0 Then
			If UnmapViewOfFile(.MappedAddress) = 0 Then
				DisplayError "UnmapViewOfFile",GetLastError()
				Exit Function
			Else
				.MappedAddress = 0
			End If
		End If
		If .hMap > 0 Then
 			If CloseHandle(.hMap) = 0 Then
 				DisplayError "CloseHandle",GetLastError()
 				Exit Function
 			Else
 				.hMap = 0
 			End If
 		End If
 		If .hFile > 0 Then
 			If SizeOfFile > 0 Then
 				SetFilePointer(.hFile, SizeOfFile, 0&, 0)
 				SetEndOfFile(.hFile)
 				'WriteFile(.hFile,Mode, SizeOfFile, 0&, 0&)
 			End If
 			If CloseHandle(.hFile) = 0 Then
 				DisplayError "CloseHandle",GetLastError()
 				Exit Function
 			Else
 				.hFile = 0
 			End If
 		End If
 		If .MappedAddress + .hMap + .hFile = 0 Then
 			.ModuleName = ""
 			.SizeOfImage = 0
 			If SizeOfFile = 0 Then .SizeOfFile = 0
 			Erase LoadedImage.ImageByte
 			UnMapFile = True
 		End If
 	End With
End Function


'ȡϢ
Private Sub DisplayError(ByVal lpSource As String,ByVal dwError As Long)
    Dim GetLastDllErrMsg As String
    GetLastDllErrMsg = String$(256, 32)
    FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM Or _
    			FORMAT_MESSAGE_IGNORE_INSERTS, _
    			lpSource, dwError, 0&, _
    			GetLastDllErrMsg,Len(GetLastDllErrMsg),0&)
    Err.Raise(dwError,lpSource,Trim(GetLastDllErrMsg))
End Sub


'תĿ¼ṹַΪƫƵַ
Private Sub CovertDataDirectoryAddress(File As FILE_PROPERTIE)
	Dim i As Integer
	With File.PEHeader.OptionalHeader
		For i = 0 To 15
			.DataDirectory(i).lVirtualAddress = RvaToOffset(File,.DataDirectory(i).lVirtualAddress)
		Next i
	End With
End Sub


'ת.NET ͷṹַΪַ
Private Sub CovertNETHeadersAddress(File As FILE_PROPERTIE)
	Dim i As Integer
	If File.PELangType <> NET_FILE_SIGNATURE Then Exit Sub
	With File.CLRHeader
		.METADATA.lVirtualAddress = RvaToOffset(File,.METADATA.lVirtualAddress)
		.Resources.lVirtualAddress = RvaToOffset(File,.Resources.lVirtualAddress)
		.StrongNameSignature.lVirtualAddress = RvaToOffset(File,.StrongNameSignature.lVirtualAddress)
		.CodeManagerTable.lVirtualAddress = RvaToOffset(File,.CodeManagerTable.lVirtualAddress)
		.VTableFixups.lVirtualAddress = RvaToOffset(File,.VTableFixups.lVirtualAddress)
		.ExportAddressTableJumps.lVirtualAddress = RvaToOffset(File,.ExportAddressTableJumps.lVirtualAddress)
		.ManagedNativeHeader.lVirtualAddress = RvaToOffset(File,.ManagedNativeHeader.lVirtualAddress)
	End With
	With File
		If .MetaDataHeader.iStreams > 0 Then
			For i = 0 To .MetaDataHeader.iStreams - 1
				.StreamHeader(i).lOffset = .CLRHeader.METADATA.lVirtualAddress + .StreamHeader(i).lOffset
			Next i
		End If
	End With
End Sub


'ȡļ
'Mode = 0 ƫƵַ(ؽ)
'Mode = 1 ƫƵַ(ؽ)
'Mode = 2 ַ(ؽ)
'Mode = 3 ַ(ؽ)
'ļšMinValMaxVal ֵ
Private Function SkipSection(File As FILE_PROPERTIE,ByVal Offset As Long,MinVal As Long,MaxVal As Long,Optional ByVal Mode As Long) As Long
	Dim i As Integer
	SkipSection = -1
	MinVal = 0: MaxVal = 0
	If Mode < 2 Then
		For i = 0 To UBound(File.SecHeader)
			With File.SecHeader(i)
				If Offset >= .lPointerToRawData And Offset < .lPointerToRawData + .lSizeOfRawData Then
					SkipSection = i
					MinVal = .lPointerToRawData
					MaxVal = MinVal + .lSizeOfRawData - 1
					Exit For
				End If
			End With
		Next i
		If Mode = 1 And SkipSection = -1 Then
			With File.HideSecHeader
				If .lSizeOfRawData > 0 Then
					If Offset > .lPointerToRawData And Offset < .lPointerToRawData + .lSizeOfRawData Then
						SkipSection = UBound(File.SecHeader) + 1
						MinVal = .lPointerToRawData
						MaxVal = MinVal + .lSizeOfRawData - 1
					End If
				End If
			End With
		End If
		If SkipSection = -1 Then
			If File.PEBitType > 0 And Offset > -1 Then
				If Offset < File.SecHeader(File.MinSecID).lPointerToRawData Then
					SkipSection = -2	'ļͷ
				ElseIf Offset < File.FileSize Then
					SkipSection = -3	' PE ļ
				End If
			End If
		End If
	Else
		For i = 0 To UBound(File.SecHeader)
			With File.SecHeader(i)
				If Offset >= .lVirtualAddress And Offset < .lVirtualAddress + .lVirtualSize Then
					SkipSection = i
					MinVal = .lVirtualAddress
					MaxVal = MinVal + .lVirtualSize - 1
					Exit For
				End If
			End With
		Next i
		If Mode = 3 And SkipSection = -1 Then
			With File.HideSecHeader
				If .lVirtualSize > 0 Then
					If Offset >= .lVirtualAddress And Offset < .lVirtualAddress + .lVirtualSize Then
						SkipSection = UBound(File.SecHeader) + 1
						MinVal = .lVirtualAddress
						MaxVal = MinVal + .lVirtualSize - 1
					End If
				End If
			End With
		End If
		If SkipSection = -1 Then
			If File.PEBitType > 0 And Offset > -1 Then
				If Offset < File.SecHeader(File.MinSecID).lVirtualAddress Then
					SkipSection = -2	'ļͷ
				ElseIf Offset < File.FileSize Then
					SkipSection = -3	' PE ļ
				End If
			End If
		End If
	End If
End Function


'ȡļͷżַ (ĵַתΪƫƵַ)
'Mode = 0 ʱ RVA Ŀ¼
'Mode = 1 ʱRVA = RVA Ŀ¼ַ + 1SkipVal =  RVA Ŀ¼Сַ
'Mode > 1 ʱRVA = RVA Ŀ¼Сַ - 1SkipVal =  RVA СĿ¼ַ
'fType = 0 ʱ .NET US 
Private Function SkipHeader(File As FILE_PROPERTIE,RVA As Long,Optional SkipVal As Long,Optional ByVal Mode As Long,Optional ByVal fType As Long) As Long
	Dim i As Integer,EndPos As Long
	SkipHeader = -1
	i = 15 + IIf(File.PELangType = NET_FILE_SIGNATURE,7 + File.MetaDataHeader.iStreams,0)
	ReDim List(i) As IMAGE_DATA_DIRECTORY
	With File.PEHeader.OptionalHeader
		For i = 0 To 15
			List(i).lVirtualAddress = .DataDirectory(i).lVirtualAddress
			List(i).lSize = .DataDirectory(i).lSize
		Next i
	End With
	If File.PELangType = NET_FILE_SIGNATURE Then
		With File.CLRHeader
			List(16).lVirtualAddress = .METADATA.lVirtualAddress
			List(17).lVirtualAddress = .Resources.lVirtualAddress
			List(18).lVirtualAddress = .StrongNameSignature.lVirtualAddress
			List(19).lVirtualAddress = .CodeManagerTable.lVirtualAddress
			List(20).lVirtualAddress = .VTableFixups.lVirtualAddress
			List(21).lVirtualAddress = .ExportAddressTableJumps.lVirtualAddress
			List(22).lVirtualAddress = .ManagedNativeHeader.lVirtualAddress
			List(16).lSize = .METADATA.lSize
			List(17).lSize = .Resources.lSize
			List(18).lSize = .StrongNameSignature.lSize
			List(19).lSize = .CodeManagerTable.lSize
			List(20).lSize = .VTableFixups.lSize
			List(21).lSize = .ExportAddressTableJumps.lSize
			List(22).lSize = .ManagedNativeHeader.lSize
		End With
	End If
	If File.MetaDataHeader.iStreams > 0 Then
		With File
			For i = 0 To .MetaDataHeader.iStreams - 1
				List(23 + i).lVirtualAddress = .StreamHeader(i).lOffset
				List(23 + i).lSize = .StreamHeader(i).lSize
				If i = .USStreamID And fType > 0 Then
					fType = 0
					EndPos = .StreamHeader(i).lOffset + .StreamHeader(i).lSize - 1
					If RVA >= .StreamHeader(i).lOffset And RVA <= EndPos Then
						fType = RVA
					ElseIf Mode = 1 And RVA < EndPos Then
						fType = .StreamHeader(i).lOffset
					ElseIf Mode > 1 And RVA > .StreamHeader(i).lOffset Then
						fType = .StreamHeader(i).lOffset
					End If
				End If
			Next i
		End With
	Else
		fType = 0
	End If
	For i = 0 To UBound(List)
		With List(i)
			If .lVirtualAddress > 0 And .lSize > 0 Then
				EndPos = .lVirtualAddress + .lSize - 1		'ַ
				If Mode = 0 Then
					If SkipHeader < 0 Then
						If RVA >= .lVirtualAddress And RVA <= EndPos Then
							SkipHeader = i
						End If
					Else
						If fType = 0 Then Exit Function
						If .lVirtualAddress >= List(SkipHeader).lVirtualAddress And _
							EndPos < List(SkipHeader).lVirtualAddress + List(SkipHeader).lSize Then
							If .lVirtualAddress <= fType And EndPos >= fType Then
								SkipHeader = -1
								Exit Function
							End If
						End If
					End If
				ElseIf Mode = 1 Then
					If .lVirtualAddress > RVA Then
						If RVA > SkipVal Then
							SkipVal = .lVirtualAddress
						ElseIf .lVirtualAddress < SkipVal Then
							SkipVal = .lVirtualAddress
						End If
					ElseIf RVA <= EndPos Then
						SkipHeader = i
						RVA = EndPos + 1
						If SkipVal < EndPos Then SkipVal = EndPos
					ElseIf SkipHeader > -1 And fType > 0 Then
						If .lVirtualAddress >= List(SkipHeader).lVirtualAddress And _
							EndPos < List(SkipHeader).lVirtualAddress + List(SkipHeader).lSize Then
							If .lVirtualAddress <= fType And EndPos >= fType Then
								SkipHeader = -1
								RVA = fType
								SkipVal = EndPos
								Exit Function
							End If
						End If
					End If
				Else
					If EndPos < RVA Then
						If RVA < SkipVal Then
							SkipVal = EndPos
						ElseIf EndPos > SkipVal Then
							SkipVal = EndPos
						End If
					ElseIf RVA >= .lVirtualAddress Then
						SkipHeader = i
						RVA = .lVirtualAddress - 1
						If SkipVal > .lVirtualAddress Then SkipVal = .lVirtualAddress
					ElseIf SkipHeader > -1 And fType > 0 Then
						If .lVirtualAddress >= List(SkipHeader).lVirtualAddress And _
							EndPos < List(SkipHeader).lVirtualAddress + List(SkipHeader).lSize Then
							If .lVirtualAddress <= fType And EndPos >= fType Then
								SkipHeader = -1
								RVA = fType - 1
								SkipVal = .lVirtualAddress
								Exit Function
							End If
						End If
					End If
				End If
			End If
		End With
	Next i
End Function


'ȡļб
Private Function getSectionNames(File As FILE_PROPERTIE,Optional ByVal SecName As String) As String()
	Dim i As Integer,Dic As Object
	If File.PEBitType = 0 Then
		ReDim TempList(0) As String
		TempList(0) = SecName
		getSectionNames = TempList
		Exit Function
	End If
	Set Dic = CreateObject("Scripting.Dictionary")
	With File
		If .HideSecHeader.lSizeOfRawData > 0 Then
			ReDim TempList(UBound(.SecHeader) + 1) As String
		Else
			ReDim TempList(UBound(.SecHeader)) As String
		End If
		For i = 0 To UBound(.SecHeader)
			TempList(i) = Replace$(StrConv$(.SecHeader(i).sName,vbUnicode),vbNullChar,"")
			If Trim$(TempList(i)) = "" Then
					TempList(i) = "Untitled_" & i
			ElseIf Dic.Exists(TempList(i)) Then
				TempList(i) = TempList(i) & "_" & i
			Else
				Dic.Add(TempList(i),"")
			End If
		Next i
		If .HideSecHeader.lSizeOfRawData > 0 Then TempList(i) = SecName
	End With
	getSectionNames = TempList
	Set Dic = Nothing
End Function


'ȡڱСȴСĵַڽ
'MinID = 0  MaxID = 0 ȡڱСַڽ
'MinID = -1 ȡ MaxID Сĵַڽ
'MaxID = -1 ȡ MinID ڴĵַڽ
'Mode = False ȽƫƵַȽַ
Private Function GetSectionID(SecHeader() As IMAGE_SECTION_HEADER,MinID As Integer,MaxID As Integer,ByVal Mode As Boolean) As Long
	Dim i As Long,MinVal As Long,MaxVal As Long
	If Mode = False Then
		If MinID = 0 And MaxID = 0 Then
			For i = LBound(SecHeader) To UBound(SecHeader)
				If SecHeader(i).lPointerToRawData > 0 Then
					If MinVal = 0 Then
						MinVal = SecHeader(i).lPointerToRawData
					ElseIf SecHeader(i).lPointerToRawData <= MinVal Then
						MinVal = SecHeader(i).lPointerToRawData
						MinID = i
					End If
					If SecHeader(i).lPointerToRawData >= MaxVal Then
						MaxVal = SecHeader(i).lPointerToRawData
						MaxID = i
					End If
				End If
			Next i
		ElseIf MinID < 0 Then
			MaxVal = SecHeader(MaxID).lPointerToRawData
			For i = LBound(SecHeader) To UBound(SecHeader)
				If SecHeader(i).lSizeOfRawData > 0 Then
					If SecHeader(i).lPointerToRawData < MaxVal Then
						If MinVal = 0 Then
							MinVal = SecHeader(i).lPointerToRawData
							MinID = i
						ElseIf SecHeader(i).lPointerToRawData > MinVal Then
							MinVal = SecHeader(i).lPointerToRawData
							MinID = i
						End If
					End If
				End If
			Next i
			GetSectionID = IIf(MinID < 0,MaxID,MinID)
		ElseIf MaxID < 0 Then
			MinVal = SecHeader(MinID).lPointerToRawData
			For i = LBound(SecHeader) To UBound(SecHeader)
				If SecHeader(i).lSizeOfRawData > 0 Then
					If SecHeader(i).lPointerToRawData > MinVal Then
						If MaxVal = 0 Then
							MaxVal = SecHeader(i).lPointerToRawData
							MaxID = i
						ElseIf SecHeader(i).lPointerToRawData < MaxVal Then
							MaxVal = SecHeader(i).lPointerToRawData
							MaxID = i
						End If
					End If
				End If
			Next i
			GetSectionID = IIf(MaxID < 0,MinID,MaxID)
		End If
	Else
		If MinID = 0 And MaxID = 0 Then
			For i = LBound(SecHeader) To UBound(SecHeader)
				If SecHeader(i).lVirtualAddress > 0 Then
					If MinVal = 0 Then
						MinVal = SecHeader(i).lVirtualAddress
					ElseIf SecHeader(i).lVirtualAddress <= MinVal Then
						MinVal = SecHeader(i).lVirtualAddress
						MinID = i
					End If
					If SecHeader(i).lVirtualAddress >= MaxVal Then
						MaxVal = SecHeader(i).lVirtualAddress
						MaxID = i
					End If
				End If
			Next i
		ElseIf MinID < 0 Then
			MaxVal = SecHeader(MaxID).lVirtualAddress
			For i = LBound(SecHeader) To UBound(SecHeader)
				If SecHeader(i).lVirtualSize > 0 Then
					If SecHeader(i).lVirtualAddress < MaxVal Then
						If MinVal = 0 Then
							MinVal = SecHeader(i).lVirtualAddress
							MinID = i
						ElseIf SecHeader(i).lVirtualAddress > MinVal Then
							MinVal = SecHeader(i).lVirtualAddress
							MinID = i
						End If
					End If
				End If
			Next i
			GetSectionID = IIf(MinID < 0,MaxID,MinID)
		ElseIf MaxID < 0 Then
			MinVal = SecHeader(MinID).lVirtualAddress
			For i = LBound(SecHeader) To UBound(SecHeader)
				If SecHeader(i).lVirtualSize > 0 Then
					If SecHeader(i).lVirtualAddress > MinVal Then
						If MaxVal = 0 Then
							MaxVal = SecHeader(i).lVirtualAddress
							MaxID = i
						ElseIf SecHeader(i).lVirtualAddress < MaxVal Then
							MaxVal = SecHeader(i).lVirtualAddress
							MaxID = i
						End If
					End If
				End If
			Next i
			GetSectionID = IIf(MaxID < 0,MinID,MaxID)
		End If
	End If
End Function


'ļ
'ImageSize = 0 ļĳʼС򿪣ָС
'ReadOnly = 0 ֻʽ򿪣дʽ
'ImageByte = 0 ȡֽ飬 ImageByte ָСȡ
'Mode < 0 ֱӷʽMode = 0 淽ʽMode > 0 ӳ䷽ʽ
'IsPE = 0 һļӳ䣬 PE ļӳ(ÿڶ)
'LoadFile = -2 ʧܣʵʴ򿪷ʽ
'LoadedImage ļȡ
Private Function LoadFile(ByVal strFilePath As String,LoadedImage As FILE_IMAGE,ByVal ImageSize As Long,ByVal ReadOnly As Long, _
		ByVal ImageByte As Long,ByVal Mode As Long,Optional ByVal IsPE As Long,Optional ByVal WaitTime As Double = 0.5) As Long
	Dim i As Long
	'Դļ
	If IsOpen(strFilePath,WaitTime) = True Then
		LoadFile = -2
		Exit Function
	End If
	'ļ
	On Error GoTo ErrorHandle
	LoadedImage.ModuleName = strFilePath
	If Mode < 0 Then
		LoadedImage.hFile = FreeFile
		If ReadOnly = 0 Then
			Open strFilePath For Binary Access Read Lock Write As #LoadedImage.hFile
		Else
			Open strFilePath For Binary Access Read Write Lock Write As #LoadedImage.hFile
		End If
		LoadedImage.SizeOfFile = LOF(LoadedImage.hFile)
		If ImageByte > 0 Then
			LoadedImage.SizeOfImage = ImageByte
			LoadedImage.ImageByte = GetBytes(LoadedImage,ImageByte,0,-1)
		Else
			LoadedImage.SizeOfImage = LoadedImage.SizeOfFile
			ReDim LoadedImage.ImageByte(0) 'As Byte
		End If
	Else
		If Mode > 0 Then
			If MapFile(strFilePath,LoadedImage,ImageSize,ReadOnly,0,IsPE) = True Then
				If ImageByte > 0 Then
					LoadedImage.ImageByte = getBytesByMap(LoadedImage.MappedAddress,LoadedImage.SizeOfFile)
					If ImageByte <> LoadedImage.SizeOfFile Then
						ReDim Preserve LoadedImage.ImageByte(ImageByte - 1) 'As Byte
					End If
				Else
					ReDim LoadedImage.ImageByte(0) 'As Byte
				End If
			Else
				UnMapFile(LoadedImage,0)
				Mode = 0
			End If
		End If
		If Mode = 0 Then
			LoadedImage.hFile = FreeFile
			Open strFilePath For Binary Access Read Lock Write As #LoadedImage.hFile
			LoadedImage.SizeOfFile = LOF(LoadedImage.hFile)
			If ImageByte > 0 Then
				LoadedImage.SizeOfImage = ImageByte
				LoadedImage.ImageByte = GetBytes(LoadedImage,ImageByte,0,-1)
			Else
				LoadedImage.SizeOfImage = LoadedImage.SizeOfFile
				LoadedImage.ImageByte = GetBytes(LoadedImage,LoadedImage.SizeOfFile,0,-1)
			End If
			Close #LoadedImage.hFile
		End If
	End If
	LoadFile = Mode
	Exit Function
	ErrorHandle:
	UnLoadFile(LoadedImage,0,Mode)
	LoadFile = -2
	Err.Source = IIf(ReadOnly = 0,"NotOpenFile","NotWriteFile")
	Err.Description = Err.Description & TextJoinStr & strFilePath
	Call sysErrorMassage(Err,3)
End Function


'жļ
'SizeOfFile = 0 д룬ָСд룬ڻӳ䷽ʽʱЧ
Private Function UnLoadFile(LoadedImage As FILE_IMAGE,ByVal SizeOfFile As Long,ByVal Mode As Long) As Boolean
	On Error GoTo ErrorHandle
	If Mode < 0 Then
		Close #LoadedImage.hFile
		LoadedImage.ModuleName = ""
		LoadedImage.hFile = 0
		LoadedImage.hMap = 0
		LoadedImage.MappedAddress = 0
		LoadedImage.SizeOfFile = 0
		LoadedImage.SizeOfImage = 0
		Erase LoadedImage.ImageByte
		UnLoadFile = True
	ElseIf Mode = 0 Then
		If SizeOfFile > 0 Then
			LoadedImage.hFile = FreeFile
			Open LoadedImage.ModuleName For Binary Access Write Lock Write As #LoadedImage.hFile
			ReDim Preserve LoadedImage.ImageByte(LoadedImage.SizeOfFile - 1) 'As Byte
			Put #LoadedImage.hFile,1,LoadedImage.ImageByte
			Close #LoadedImage.hFile
		End If
		LoadedImage.ModuleName = ""
		LoadedImage.hFile = 0
		LoadedImage.hMap = 0
		LoadedImage.MappedAddress = 0
		LoadedImage.SizeOfFile = 0
		LoadedImage.SizeOfImage = 0
		Erase LoadedImage.ImageByte
		UnLoadFile = True
	ElseIf UnMapFile(LoadedImage,SizeOfFile) = True Then
		UnLoadFile = True
	End If
	ErrorHandle:
End Function


'ôб
'fType < 0 еõַбҷôбfType Ϊԭķ뿪ʼַ
'fType = 0 Դбô
'fType = 1 ҷбô룬 RefAdds Ϊգԭõַô
'fType = 2 ҷбô룬 RefAdds Ϊգʼб
'fType > 2 ʼշбô
'ַ(VA) = StartPos + ImageBase + VRK
Private Function getVARefList(File As FILE_PROPERTIE,FN As Variant,strData As STRING_SUB_PROPERTIE, _
	ByVal RefAdds As String,ByVal fType As Long,ByVal Mode As Long,Optional ShowMsg As Long) As Long
	Dim i As Long,j As Long,k As Long,m As Long,n As Long
	Dim RVA As Long,VRK As Long,MaxPos As Long,RSize As Long,SkipVal As Long
	Dim Msg As PROGRESS_MSG,TempList() As String
	On Error GoTo ExitFunction
	If File.PEBitType = 0 Then GoTo ExitFunction
	If fType > 2 Then GoTo ExitFunction
	With strData
	If fType > -1 Then
		If .inSectionID < 0 Then .inSectionID = SkipSection(File,.lStartAddress,0,0)
		If .inSectionID < 0 Then GoTo ExitFunction
		If ShowMsg > 0 Then
			'ReDim TempList(PSL.OutputWnd(0).LineCount - 1) As String
			'For i = 1 To PSL.OutputWnd(0).LineCount
			'	TempList(i - 1) = PSL.OutputWnd(0).Text(i)
			'Next i
			'Msg.Massage = Join$(TempList,vbCrLf) & " "
			Msg.Massage = GetDlgString(ShowMsg) & " "
		End If
		If fType > 0 Then RefAdds = Trim$(RefAdds)
	End If
	If File.PEBitType = FILE_BIT_TYPE64 Then
		'ԭ뿪ʼַôȡµַôб
		If fType < 0 Then
			'If RefAdds <> "" Then Call getRefList(strData,Split(RefAdds,RefJoinStr),TempList,True)
			If .lReferenceNum = 0 Then GoTo ExitFunction
			i = .Reference(0).inSecID
			VRK = File.SecHeader(i).lVirtualAddress - File.SecHeader(i).lPointerToRawData
			RVA = Val("&H" & ReverseHexCode(.Reference(0).sCode,8)) + .Reference(0).lAddress + VRK + 4
			RVA = RVA + fType + .lStartAddress
			For i = 0 To .lReferenceNum - 1
				j = .Reference(i).inSecID
				VRK = File.SecHeader(j).lVirtualAddress - File.SecHeader(j).lPointerToRawData
				.Reference(i).sCode = ReverseHexCode(Hex$(RVA - (.Reference(i).lAddress + VRK + 4)),8)
				'.Reference(i).sCode = Byte2CodeStr(Val2Bytes(RVA - (.Reference(i).lAddress + VRK + 4),4),0,3)
			Next i
			.GetRefState = 1
			Exit Function
		End If
		'ȡִַ
		With File.SecHeader(.inSectionID)
			If strData.lStartAddress >= .lPointerToRawData And strData.lStartAddress < .lPointerToRawData + .lSizeOfRawData Then
				RVA = strData.lStartAddress + .lVirtualAddress - .lPointerToRawData
			Else
				GoTo ExitFunction
			End If
		End With
		If fType = 0 Then
			MaxPos = strData.lStartAddress - 4
			.lReferenceNum = 0
			ReDim strData.Reference(0) 'As REFERENCE_PROPERTIE
			For j = 0 To UBound(File.SecHeader)
				With File.SecHeader(j)
					i = .lPointerToRawData
					RSize = i + .lSizeOfRawData - 4
					VRK = .lVirtualAddress - .lPointerToRawData
				End With
				If RSize > MaxPos Then RSize = MaxPos
				If i > MaxPos Then Exit For
				SkipVal = i - 1
				Do While i < RSize
					'ųĳЩĿ¼κ .NET ļ
					If i > SkipVal Then
						k = i: m = SkipHeader(File,k,SkipVal,1)
						If m = 2 Or m = 4 Or m = 5 Or m > 15 Then i = k
						If i > SkipVal Or SkipVal > RSize Then SkipVal = RSize
						If i > RSize Then Exit Do
					End If
					i = i + GetVAListPE64(FN,strData,n,j,RVA - VRK - 4,i,SkipVal,Mode) + 1
					If ShowMsg > 0 Then
						'PSL.OutputWnd(0).Clear
						'PSL.Output Msg.Massage & Format$(i / MaxPos,"#%")
						SetDlgString(ShowMsg,Msg.Massage & Format$(i / MaxPos,"#%"))
					End If
				Loop
			Next j
			If .lReferenceNum > 0 Then
				ReDim Preserve strData.Reference(.lReferenceNum - 1) 'As REFERENCE_PROPERTIE
				'If TagType > 1 Then Call GetCustomStrType(FN,strData,TypeList,Mode,-1)
			End If
			.GetRefState = 1
		ElseIf RefAdds <> "" Or (.lReferenceNum > 0 And fType < 2) Then
			If RefAdds <> "" Then Call getRefList(strData,Split(RefAdds,RefJoinStr),TempList,True)
			If .lReferenceNum > 0 Then
				For i = 0 To .lReferenceNum - 1
					j = .Reference(i).inSecID
					VRK = File.SecHeader(j).lVirtualAddress - File.SecHeader(j).lPointerToRawData
					.Reference(i).sCode = ReverseHexCode(Hex$(RVA - (.Reference(i).lAddress + VRK + 4)),8)
					'.Reference(i).sCode = Byte2CodeStr(Val2Bytes(RVA - (.Reference(i).lAddress + VRK + 4),4),0,3)
					If ShowMsg > 0 Then
						'PSL.OutputWnd(0).Clear
						'PSL.Output Msg.Massage & Format$(i / .lReferenceNum,"#%")
						SetDlgString(ShowMsg,Msg.Massage & Format$(i / .lReferenceNum,"#%"))
					End If
				Next i
				.GetRefState = 1
			End If
		Else
			GoTo ExitFunction
		End If
	Else
		'ԭ뿪ʼַôȡµַôб
		If fType < 0 Then
			'If RefAdds <> "" Then Call getRefList(strData,Split(RefAdds,RefJoinStr),TempList,True)
			If .lReferenceNum = 0 Then GoTo ExitFunction
			VRK = Val("&H" & ReverseHexCode(.Reference(0).sCode,8)) + fType
			.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress + VRK),8)
			'.Reference(0).sCode = Byte2CodeStr(Val2Bytes(.lStartAddress + VRK,4),0,3)
			For i = 0 To .lReferenceNum - 1
				.Reference(i).sCode = .Reference(0).sCode
			Next i
			.GetRefState = 1
			Exit Function
		End If
		'ȡִַ
		With File.SecHeader(.inSectionID)
			If strData.lStartAddress >= .lPointerToRawData And strData.lStartAddress < .lPointerToRawData + .lSizeOfRawData Then
				VRK = .lVirtualAddress - .lPointerToRawData + File.PEHeader.OptionalHeader.dImageBase
			Else
				GoTo ExitFunction
			End If
		End With
		'ȡõַôб
		If fType = 0 Then
			With File
				SkipVal = .SecHeader(.MinSecID).lPointerToRawData
				If .PEHeader.OptionalHeader.DataDirectory(2).lVirtualAddress > 0 Then
					If SkipSection(File,.PEHeader.OptionalHeader.DataDirectory(2).lVirtualAddress,0,0) > -1 Then
						RSize = .PEHeader.OptionalHeader.DataDirectory(2).lVirtualAddress - 1
					Else
						RSize = .SecHeader(.MaxSecID).lPointerToRawData + .SecHeader(.MaxSecID).lSizeOfRawData - 1
					End If
				Else
					RSize = .SecHeader(.MaxSecID).lPointerToRawData + .SecHeader(.MaxSecID).lSizeOfRawData - 1
				End If
			End With
			.lReferenceNum = 0
			ReDim strData.Reference(0) 'As REFERENCE_PROPERTIE
			.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress + VRK),8)
			If Mode = 0 Then
				TempList = GetVAList(FN.ImageByte,Val2Bytes(.lStartAddress + VRK,4),SkipVal,RSize)
			Else
				TempList = GetVAListRegExp(ByteToString(GetBytes(FN,RSize - SkipVal + 1,SkipVal,Mode),CP_ISOLATIN1),HexStr2RegExpPattern(.Reference(0).sCode,1),SkipVal)
			End If
			If CheckArray(TempList) = True Then
				.lReferenceNum = UBound(TempList) + 1
				ReDim Preserve strData.Reference(.lReferenceNum - 1) 'As REFERENCE_PROPERTIE
				m = 0: n = 0
				For i = 0 To .lReferenceNum - 1
					.Reference(i).lAddress = CLng(TempList(i))
					.Reference(i).sCode = .Reference(0).sCode
					If .Reference(i).lAddress < n Or .Reference(i).lAddress > m Then
						MaxPos = SkipSection(File,.Reference(i).lAddress,n,m)
					End If
					.Reference(i).inSecID = MaxPos
					If ShowMsg > 0 Then
						'PSL.OutputWnd(0).Clear
						'PSL.Output Msg.Massage & Format$(i / .lReferenceNum,"#%")
						SetDlgString(ShowMsg,Msg.Massage & Format$(i / .lReferenceNum,"#%"))
					End If
				Next i
				'If TagType > 1 Then Call GetCustomStrType(FN,strData,TypeList,Mode,-1)
			End If
			.GetRefState = 1
		ElseIf RefAdds <> "" Or (.lReferenceNum > 0 And fType < 2) Then
			If RefAdds <> "" Then Call getRefList(strData,Split(RefAdds,RefJoinStr),TempList,True)
			If .lReferenceNum > 0 Then
				.Reference(0).sCode = ReverseHexCode(Hex$(.lStartAddress + VRK),8)
				'.Reference(0).sCode = Byte2CodeStr(Val2Bytes(.lStartAddress + VRK,4),0,3)
				For i = 0 To .lReferenceNum - 1
					.Reference(i).sCode = .Reference(0).sCode
					If ShowMsg > 0 Then
						'PSL.OutputWnd(0).Clear
						'PSL.Output Msg.Massage & Format$(i / .lReferenceNum,"#%")
						SetDlgString(ShowMsg,Msg.Massage & Format$(i / .lReferenceNum,"#%"))
					End If
				Next i
				.GetRefState = 1
			End If
		Else
			GoTo ExitFunction
		End If
	End If
	getVARefList = .lReferenceNum
	End With
	If ShowMsg > 0 Then
		'PSL.OutputWnd(0).Clear
		'PSL.Output Msg.Massage & "100%"
		SetDlgString(ShowMsg,Msg.Massage & "100%")
	End If
	Exit Function
	'˳
	ExitFunction:
	ReDim strData.Reference(0) 'As REFERENCE_PROPERTIE
	strData.lReferenceNum = 0
	strData.GetRefState = 0
	If ShowMsg > 0 Then
		'PSL.OutputWnd(0).Clear
		'PSL.Output Msg.Massage & "100%"
		SetDlgString(ShowMsg,Msg.Massage & "100%")
	End If
End Function


'ȡ PE64 ԭʼִõַʹ
' GetVAListPE = 
Private Function GetVAListPE64(FN As Variant,strData As STRING_SUB_PROPERTIE,RefMaxNum As Long,ByVal SecID As Long, _
				ByVal RVAVRK As Long,ByVal StartPos As Long,ByVal RSize As Long,ByVal Mode As Long) As Long
	Dim i As Long,j As Long,Temp As String,TempList() As String
	With strData
		'GetVAListPE64 = (RVAVRK - StartPos) And &HFF		'3ֽڲңٶȽ
		'GetVAListPE64 = Val("&H" & Right$("0000" & Hex$(RVAVRK - StartPos),4))	'2ֽڲңٶȽϿ
		GetVAListPE64 = (RVAVRK - StartPos) And 65535	'2ֽڲңٶȽϿ죬 65535 滻 &HFFFFΪ &HFFFF Ϊ -1
		If GetVAListPE64 > RSize - StartPos Then GetVAListPE64 = RSize - StartPos
		If GetVAListPE64 > .lStartAddress - StartPos - 4 Then GetVAListPE64 = .lStartAddress - StartPos - 4
		If GetVAListPE64 > 0 Then
			'ʽңٶȽϿ죬3ֽڲʱʼַΪ StartPos + 1Ϊ StartPos + 2
			Temp = HexStr2RegExpPattern(Right$(ReverseHexCode(Hex$(RVAVRK - StartPos),8),4),1)
			TempList = GetVAListRegExp(ByteToString(GetBytes(FN,GetVAListPE64 + 1,StartPos + 2,Mode),CP_ISOLATIN1),Temp,StartPos + 2)
			'ֽңٶȽ3ֽڲʱʼַΪ StartPos + 1Ϊ StartPos + 2
			'TempList = GetVAList(FN.ImageByte,Val2BytesRev(RVAVRK - StartPos,4,2),StartPos + 2,StartPos + 2 + GetVAListPE64)
			If CheckArray(TempList) = True Then
				For i = 0 To UBound(TempList)
					'3ֽڲʱΪ1-12ֽڲʱΪ2-1
					For j = 2 To 1 Step -1
						StartPos = CLng(TempList(i)) - j
						If RVAVRK - StartPos <> 0 Then
							If GetLong(FN,StartPos,Mode) = RVAVRK - StartPos Then
								If .lReferenceNum > RefMaxNum Then
									RefMaxNum = .lReferenceNum + 20
									ReDim Preserve strData.Reference(RefMaxNum) 'As REFERENCE_PROPERTIE
								End If
								'ҵõַô
								.Reference(.lReferenceNum).lAddress = StartPos
								.Reference(.lReferenceNum).sCode = Byte2CodeStr(GetBytes(FN,4,StartPos,Mode),0,3)
								.Reference(.lReferenceNum).inSecID = SecID
								.lReferenceNum = .lReferenceNum + 1
								Exit For
							End If
						End If
					Next j
				Next i
			End If
		ElseIf RVAVRK - StartPos <> 0 Then
			If GetLong(FN,StartPos,Mode) = RVAVRK - StartPos Then
				If .lReferenceNum > RefMaxNum Then
					RefMaxNum = .lReferenceNum + 20
					ReDim Preserve strData.Reference(RefMaxNum) 'As REFERENCE_PROPERTIE
				End If
				'ҵõַô
				.Reference(.lReferenceNum).lAddress = StartPos
				.Reference(.lReferenceNum).sCode = Byte2CodeStr(GetBytes(FN,4,StartPos,Mode),0,3)
				.Reference(.lReferenceNum).inSecID = SecID
				.lReferenceNum = .lReferenceNum + 1
				GetVAListPE64 = 3
			End If
		End If
	End With
End Function


'ȡֽҵƥб(VBʽ)
'ע⣺StartPosEndPos Ϊ 0 ʼĵַ
Private Function GetVAList(Bytes() As Byte,Find() As Byte,Optional ByVal StartPos As Long,Optional ByVal EndPos As Long) As String()
	Dim i As Long,j As Long,k As Long,m As Long,n As Long,Length As Long,tempByte() As Byte
	Length = UBound(Find) + 1
	tempByte = Find
	k = -1
	For i = 0 To Length - 1
		If Find(i) <> 0 Then
			If i <> 0 Then
				ReDim tempByte(Length - i - 1) As Byte
				CopyMemory tempByte(0), Find(i), Length - i
			End If
			k = i
			Exit For
		End If
	Next i
	If k = -1 Then
		If EndPos <= StartPos Then Exit Function
		Dim Matches As Object
		RegExp.Global = True
		RegExp.IgnoreCase = False
		RegExp.Pattern = "[\x00]{" & Length & ",}"
		ReDim tempByte(EndPos - StartPos) As Byte
		CopyMemory tempByte(0), Bytes(StartPos), EndPos - StartPos + 1
		Set Matches = RegExp.Execute(ByteToString(tempByte,CP_ISOLATIN1))
		If Matches.Count > 0 Then
			ReDim TempList(Matches.Count - 1) As String
			For i = 0 To Matches.Count - 1
				TempList(i) = CStr$(StartPos + Matches(i).FirstIndex)
			Next i
			GetVAList = TempList
		End If
		Exit Function
	End If
	m = 50
	ReDim TempList(m) As String
	i = InStrB(StartPos + k + 1,Bytes,tempByte)
	Do While i > 0
		If k > 0 Then
			For j = i - k - 1 To i - 2
				If Bytes(j) <> 0 Then GoTo NextNum
			Next j
			i = i - k
		End If
		If EndPos > 0 Then
			If i + Length - 2 > EndPos Then Exit Do
		End If
		If n > m Then
			m = m * 2
			ReDim Preserve TempList(m) As String
		End If
		TempList(n) = CStr(i - 1)    'ע InStrB ҵһͷ"1"
		n = n + 1
		NextNum:
		i = InStrB(i + Length,Bytes,tempByte)
	Loop
	If n > 0 Then n = n - 1
	ReDim Preserve TempList(n) As String
	GetVAList = TempList
End Function


'ȡֽҵƥб(ʽʽ)
'ע⣺StartPosEndPos Ϊ 0 ʼĵַ
Function GetVAListRegExp(strText As String,ByVal Patrn As String,ByVal StartPos As Long) As String()
	Dim i As Long,Matches As Object
	On Error GoTo ExitFunction
	RegExp.Global = True
	RegExp.IgnoreCase = False
	RegExp.Pattern = Patrn
	Set Matches = RegExp.Execute(strText)
	If Matches.Count = 0 Then Exit Function
	ReDim TempList(Matches.Count - 1) As String
	For i = 0 To Matches.Count - 1
		TempList(i) = CStr$(StartPos + Matches(i).FirstIndex)
	Next i
	GetVAListRegExp = TempList
	Exit Function
	ExitFunction:
End Function


'ת Hex 
Private Function ReverseHexCode(ByVal HexStr As String,ByVal Num As Long) As String
	Dim i As Long
	i = Len(HexStr)
	If i < Num Then HexStr = String$(Num - i,"0") & HexStr
	ReverseHexCode = HexStr
	For i = 1 To Num - 1 Step 2
		Mid$(ReverseHexCode,i,2) = Mid$(HexStr,Num - i,2)
	Next i
End Function


'ȡ Hex 
'StartNo <= EndNo ȡλλ Hex 룬ȡλλ Hex 
Public Function Byte2CodeStr(Bin() As Byte,ByVal StartNo As Long,ByVal EndNo As Long) As String
	Dim i As Long,n As Long
	If StartNo < 0 Then StartNo = UBound(Bin)
	If EndNo < 0 Then EndNo = UBound(Bin)
	Byte2CodeStr = Space$((Abs(EndNo - StartNo) + 1) * 2)
	n = 1
	For i = StartNo To EndNo Step IIf(StartNo <= EndNo,1,-1)
		Mid$(Byte2CodeStr,n,2) = Right$("0" & Hex$(Bin(i)),2)
		n = n + 2
	Next i
End Function


'תֵΪֽ
Private Function Val2Bytes(ByVal Value As Long,ByVal Length As Integer) As Byte()
	On Error GoTo errHandle
	ReDim Bytes(Length - 1) As Byte
	CopyMemory Bytes(0), Value, Length
	Val2Bytes = Bytes
	Exit Function
	errHandle:
	ReDim Bytes(0) As Byte
	Val2Bytes = Bytes
End Function


'תֵΪֽ(ڳȵĵλض)
Private Function Val2BytesRev(ByVal Value As Long,ByVal MaxLength As Integer,ByVal Length As Integer) As Byte()
	On Error GoTo errHandle
	If GetEvenPos(Len(Hex$(Value))) \ 2 > MaxLength Then GoTo errHandle
	ReDim Bytes(MaxLength - 1) As Byte
	CopyMemory Bytes(0), Value, MaxLength
	If MaxLength > Length Then
		CopyMemory Bytes(0), Bytes(MaxLength - Length), Length
		ReDim Preserve Bytes(Length - 1) As Byte
	End If
	Val2BytesRev = Bytes
	Exit Function
	errHandle:
	ReDim Bytes(0) As Byte
	Val2BytesRev = Bytes
End Function


'תƫôΪֽ
Public Function HexStr2Bytes(ByVal HexStr As String) As Byte()
	Dim i As Long,n As Long,Length As Long
	Length = Len(HexStr)
	If Length > 1 Then
		ReDim tempByte(Length \ 2 - 1) As Byte
		For i = 1 To Length Step 2
			tempByte(n) = Val("&H" & Mid$(HexStr,i,2))
			n = n + 1
		Next i
	Else
		ReDim tempByte(0) As Byte
	End If
	HexStr2Bytes = tempByte
End Function


'ִǷΪգǿշ True
Private Function CheckArray(DataList() As String) As Boolean
	Dim i As Long
	On Error GoTo errHandle
	For i = LBound(DataList) To UBound(DataList)
		If DataList(i) <> "" Then
			CheckArray = True
			Exit For
		End If
	Next i
	errHandle:
End Function


'Hex ַתʽʹõ Hex תģ
'Mode = 0 תΪ [] ʽΪ [] ʽ
Public Function HexStr2RegExpPattern(ByVal HexStr As String,Optional ByVal Mode As Long) As String
	Dim i As Long,j As Long,n As Long
	j = Len(HexStr)
	If j = 0 Then Exit Function
	If Mode = 0 Then
		HexStr2RegExpPattern = "[" & Space$(j * 2) & "]"
		n = 2
	Else
		HexStr2RegExpPattern = Space$(j * 2)
		n = 1
	End If
	For i = 1 To j Step 2
		Mid$(HexStr2RegExpPattern,n,4) = "\x" & Mid$(HexStr,i,2)
		n = n + 4
	Next i
End Function


'ʽ HEX ִ
Private Function FormatHexStr(ByVal textStr As String,ByVal Length As Integer) As String
	If textStr = "" Then Exit Function
	If (Len(textStr) Mod Length) = 0 Then
		FormatHexStr = textStr
	Else
		FormatHexStr = "0" & textStr
	End If
End Function


'תִ
Private Function Reference2Str(File As FILE_PROPERTIE,strData As STRING_SUB_PROPERTIE) As String
	Dim i As Long,n As Long,Temp As String,SecList() As String
	On Error Resume Next
	If strData.lReferenceNum = 0 Then
		Reference2Str = MsgList(30)
		Exit Function
	End If
	Temp = String$(Len(CStr$(File.FileSize)),"0")
	n = Len(Temp)
	SecList = getSectionNames(File,"")
	With strData
		ReDim TempList(.lReferenceNum + 4) As String
		TempList(0) = MsgList(37)
		TempList(1) = MsgList(38)
		TempList(2) = MsgList(37)
		For i = 0 To .lReferenceNum - 1
			TempList(i + 3) = Replace$(MsgList(39),"%no",CStr$(i + 1))
			TempList(i + 3) = Replace$(TempList(i + 3),"%da",Format$(.Reference(i).lAddress,Temp))
			TempList(i + 3) = Replace$(TempList(i + 3),"%ha",Right$(Temp & Hex$(.Reference(i).lAddress),n))
			TempList(i + 3) = Replace$(TempList(i + 3),"%sc",SecList(SkipSection(File,.Reference(i).lAddress,0,0,1)))
			TempList(i + 3) = Replace$(TempList(i + 3),"%dc",MsgList(42 + SkipHeader(File,.Reference(i).lAddress) + 1))
			TempList(i + 3) = Replace$(TempList(i + 3),"%rc",strData.Reference(i).sCode)
		Next i
	End With
	TempList(i + 3) = MsgList(37)
	Reference2Str = Join$(TempList,TextJoinStr)
End Function


'Ϣ
Private Sub sysErrorMassage(sysError As ErrObject,ByVal fType As Long)
	Dim TempArray() As String,MsgList() As String
	Dim ErrorNumber As Long,ErrorSource As String,ErrorDescription As String
	Dim TitleMsg As String,ContinueMsg As String,Msg As String

	ErrorNumber = sysError.Number
	ErrorSource = sysError.Source
	ErrorDescription = sysError.Description

	TitleMsg = "Error"
	Select Case fType
	Case 0
		ContinueMsg = vbCrLf & vbCrLf & "The program cannot continue and will exit."
	Case 1
		ContinueMsg = vbCrLf & vbCrLf & "Do you want to continue?"
	Case 2
		ContinueMsg = vbCrLf & vbCrLf & "The program will continue to run."
	End Select

	If CheckArray(MsgList) = True Then
		TitleMsg = MsgList(0)
		Select Case fType
		Case 0
			ContinueMsg = MsgList(1)
		Case 1
			ContinueMsg = MsgList(2)
		Case 2
			ContinueMsg = MsgList(3)
		End Select

		Select Case ErrorSource
		Case ""
			If ErrorNumber = 10051 And PSL.Version >= 1500 Then
				Msg = Replace$(MsgList(4),"%s",ErrorSource)
			Else
				Msg = Replace$(Replace$(MsgList(5),"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
			End If
		Case "NotSection"
			TempArray = Split(ErrorDescription,TextJoinStr,-1)
			Msg = Replace$(Replace$(MsgList(6),"%s",TempArray(1)),"%d",TempArray(0))
		Case "NotValue"
			TempArray = Split(ErrorDescription,TextJoinStr,-1)
			Msg = Replace$(Replace$(MsgList(7),"%s",TempArray(1)),"%d",TempArray(0))
		Case "NotReadFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotWriteFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotUnWriteFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotOpenFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotINIFile"
			Msg = Replace$(MsgList(8),"%s",ErrorDescription)
		Case "NotExitFile"
			Msg = Replace$(MsgList(9),"%s",ErrorDescription)
		Case "NotVersion"
			TempArray = Split(ErrorDescription,TextJoinStr,-1)
			Msg = Replace$(MsgList(10),"%s",TempArray(0))
			Msg = Replace$(Replace$(Msg,"%d",TempArray(1)),"%v",TempArray(2))
		Case Else
			Msg = Replace$(MsgList(11),"%s",ErrorSource)
			Msg = Replace$(Replace$(Msg,"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
		End Select
	Else
		Select Case ErrorSource
		Case ""
			If ErrorNumber = 10051 And PSL.Version >= 1500 Then
				Msg = "Unable to open the file. Please verify the file path and file name" & _
						"contains characters in Asian languages. " & vbCrLf & _
						"Note: Passolo 2015 Version of the macro engine does not recognize" & _
						"the file path and file name contains Asian language characters."
			Else
				Msg = "An Error occurred in the program design." & vbCrLf & "Error Code: %d, Content: %v" & _
						vbCrLf & "Please restart the Passolo try and please report to the software developer."
				Msg = Replace$(Replace$(Msg,"%s",CStr(ErrorNumber)),"%v",ErrorDescription)
			End If
		Case "NotSection"
			TempArray = Split(ErrorDescription,TextJoinStr,-1)
			Msg = "The following file is missing [%s] section." & vbCrLf & "%d"
			Msg = Replace$(Replace$(Msg,"%s",TempArray(1)),"%d",TempArray(0))
		Case "NotValue"
			TempArray = Split(ErrorDescription,TextJoinStr,-1)
			Msg = "The following file is missing [%s] Value." & vbCrLf & "%d"
			Msg = Replace$(Replace$(Msg,"%s",TempArray(1)),"%d",TempArray(0))
		Case "NotReadFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotWriteFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotUnWriteFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotOpenFile"
			Msg = Replace$(ErrorDescription,TextJoinStr,vbCrLf)
		Case "NotINIFile"
			Msg = "The following contents of the file is not correct." & vbCrLf & "%s"
			Msg = Replace$(Msg,"%s",ErrorDescription)
		Case "NotExitFile"
			Msg = "The following file does not exist! Please check and try again." & vbCrLf & "%s"
			Msg = Replace$(Msg,"%s",ErrorDescription)
		Case "NotVersion"
			TempArray = Split(ErrorDescription,TextJoinStr,-1)
			Msg = "The following file version is %d, requires version at least %v." & vbCrLf & "%s"
			Msg = Replace$(Msg,"%s",TempArray(0))
			Msg = Replace$(Replace$(Msg,"%d",TempArray(1)),"%v",TempArray(2))
		Case Else
			Msg = "Your system is missing %s server." & vbCrLf & "Error Code: %d, Content: %v"
			Msg = Replace$(Msg,"%s",ErrorSource)
			Msg = Replace$(Replace$(Msg,"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
		End Select
	End If

	If Msg = "" Then Exit Sub
	Select Case fType
	Case 0
		MsgBox(Msg & ContinueMsg,vbOkOnly+vbInformation,TitleMsg)
		Exit All
	Case 1
		If MsgBox(Msg & ContinueMsg,vbYesNo+vbInformation,TitleMsg) = vbNo Then
			Exit All
		End If
	Case Else
		MsgBox(Msg & ContinueMsg,vbOkOnly+vbInformation,TitleMsg)
	End Select
End Sub


'˳ֽвƥ
'Mode = 0 StartPos  EndPos ֮λ( StartPos  EndPos)
'Mode <> 0ҳ StartPos  EndPos ֮λ( StartPos  EndPos)
' InByte ֵ = 0ûҵ> 0 ҵ ( 1 ʼĵַ)
'ע⣺StartPosEndPos  MaxPos Ϊ 0 ʼĵַ
Public Function InByte(Bytes() As Byte,Find() As Byte,ByVal StartPos As Long,ByVal EndPos As Long,Optional ByVal MaxPos As Long,Optional Mode As Long) As Long
	Dim i As Long,j As Long,k As Long,Length As Long,tempByte() As Byte
	Length = UBound(Find) + 1
	tempByte = Find
	k = -1
	For i = 0 To Length - 1
		If Find(i) <> 0 Then
			If i <> 0 Then
				ReDim tempByte(Length - i - 1) As Byte
				CopyMemory tempByte(0), Find(i), Length - i
			End If
			k = i
			Exit For
		End If
	Next i

	If k = -1 Then
		If Mode = 0 Then
			InByte = NullInByteRegExp(Bytes,StartPos,EndPos,Length)
		Else
			InByte = NullInByteRegExp(Bytes,0,StartPos - 1,Length)
			If InByte = 0 Then
				InByte = NullInByteRegExp(Bytes,EndPos + 1,MaxPos,Length)
			End If
		End If
		Exit Function
	End If

	If Mode = 0 Then
		i = InStrB(StartPos + k + 1,Bytes,tempByte)
	Else
		i = InStrB(k + 1,Bytes,tempByte)
	End If
	Do While i > 0
		If k > 0 Then
			For j = i - k - 1 To i - 2
				If Bytes(j) <> 0 Then GoTo NextNum
			Next j
			i = i - k
		End If
		If Mode = 0 Then
			If EndPos > 0 Then
				If i + Length - 2 > EndPos Then Exit Do
			End If
			InByte = i	'ע InStrB ҵһͷ"1"
			Exit Do
		ElseIf (i + Length - 2 < StartPos) Or (i + Length - 2 > EndPos) Then
			If MaxPos > 0 Then
				If i + Length - 2 > MaxPos Then Exit Do
			End If
			InByte = i	'ע InStrB ҵһͷ"1"
			Exit Do
		End If
		NextNum:
		i = InStrB(i + Length,Bytes,tempByte)
	Loop
End Function


'ָ˫ֽλã˫ֽڿʼλ ( 1 ʼĵַ)
'Mode = 0ҵĵһ򷵻ҵһ
' NullBytePosRegExp ֵ = 0ûҵ> 0 ҵ ( 1 ʼĵַ)
'ע⣺StartPosEndPos Ϊ 0 ʼĵַ
Public Function NullInByteRegExp(Bytes() As Byte,ByVal StartPos As Long,ByVal EndPos As Long, _
				Optional ByVal MinLength As Long = 1,Optional ByVal Mode As Long) As Long
	Dim Matches As Object
	If EndPos = 0 Then EndPos = UBound(Bytes)
	If EndPos - StartPos + 1 < MinLength Then Exit Function
	With RegExp
		.Global = IIf(Mode = 0,False,True)
		.IgnoreCase = False
		.Pattern = "[\x00]{" & MinLength & ",}"
		ReDim tempByte(EndPos - StartPos) As Byte
		CopyMemory tempByte(0), Bytes(StartPos), EndPos - StartPos + 1
		Set Matches = .Execute(ByteToString(tempByte,CP_ISOLATIN1))
		If Matches.Count > 0 Then
			If Mode = 0 Then
				NullInByteRegExp = StartPos + Matches(0).FirstIndex + 1
			Else
				NullInByteRegExp = StartPos + Matches(Matches.Count - 1).FirstIndex + 1
			End If
		End If
	End With
End Function


'ֽתַ
Private Function ByteToString(Bytes() As Byte,ByVal CodePage As Long) As String
	Select Case CodePage
	Case CP_UNICODELITTLE
		ByteToString = Bytes
	Case CP_UNICODEBIG
		Call LowByte2HighByte(Bytes)
		ByteToString = Bytes
	Case Else
		ByteToString = MultiByteToUTF16(Bytes,CodePage)
	End Select
End Function


'ÿֽڵĸֽں͵ֽڻ UNICODE LITTLE  UNICODE BIG ֽ໥ת
Private Sub LowByte2HighByte(Bytes() As Byte)
	Dim i As Long,Temp As Byte
	For i = LBound(Bytes) To UBound(Bytes) -1 Step 2
		Temp = Bytes(i)
		Bytes(i) = Bytes(i + 1)
		Bytes(i + 1) = Temp
	Next i
End Sub


'õĴҳUTF-8:65001GB2312:936GB1803054936UTF-765000
Private Function MultiByteToUTF16(UTF8() As Byte, ByVal CodePage As Long) As String
	On Error GoTo errHandle
	Dim bufSize As Long,lRet As Long
	'bufSize = MultiByteToWideChar(CodePage, 0&, VarPtr(UTF8(0)), UBound(UTF8) + 1, 0, 0)
	bufSize = MultiByteToWideChar(CodePage, 0&, UTF8(0), UBound(UTF8) + 1, 0, 0)
	'If CodePage = CP_UTF8 Then bufSize = (UBound(UTF8) + 1) * 2 Else bufSize = UBound(UTF8) + 1
	MultiByteToUTF16 = Space(bufSize)
	'lRet = MultiByteToWideChar(CodePage, 0&, VarPtr(UTF8(0)), UBound(UTF8) + 1, StrPtr(MultiByteToUTF16), bufSize)
	lRet = MultiByteToWideChar(CodePage, 0&, UTF8(0), UBound(UTF8)+1, StrPtr(MultiByteToUTF16), bufSize)
	If lRet > 0 Then
		MultiByteToUTF16 = Left$(MultiByteToUTF16, lRet)
	End If
	Exit Function
	errHandle:
	MultiByteToUTF16 = ""
End Function


'ȡżλ
'Mode = 0  1 ֽڣMode = 1  1 ֽ
Private Function GetEvenPos(ByVal Pos As Long,Optional ByVal Mode As Long) As Long
	If Pos And 1 Then
		If Mode = 0 Then
			GetEvenPos = Pos + 1
		Else
			GetEvenPos = Pos - 1
		End If
	Else
		GetEvenPos = Pos
	End If
End Function


'в
Private Function SplitArgument(ByVal Argument As String,ByVal SplitChar As String,ByVal MaxNum As Long) As String()
	Dim i As Long,j As Long,TempList() As String
	TempList = Split(Argument,SplitChar)
	For i = UBound(TempList) To 0 Step -1
		If IsNumeric(TempList(i)) = False Then Exit For
		j = j + 1
	Next i
	If j = 0 Then
		ReDim TempList(0) As String
		TempList(0) = Argument
	ElseIf UBound(TempList) < MaxNum Then
		For i = 1 To UBound(TempList)
			TempList(i) = Trim$(TempList(i))
		Next i
	Else
		If j > MaxNum Then j = MaxNum - 1
		MaxNum = UBound(TempList)
		For i = 0 To j - 1
			TempList(i + 1) = TempList(MaxNum - j + i + 1)
		Next i
		ReDim Preserve TempList(j) As String
		TempList(0) = ""
		TempList(0) = Split(Argument,Join$(TempList,SplitChar))(0)
		For i = 1 To j
			TempList(i) = Trim$(TempList(i))
		Next i
	End If
	If Trim$(Split(TempList(0),"""")(0) & Split(TempList(0),"""")(UBound(Split(TempList(0),"""")))) = "" Then
		TempList(0) = RemoveBackslash(TempList(0),"""","""",2)
	End If
	SplitArgument = TempList
End Function


'ȥִǰָ PreStr  AppStr
'fType = -1 ȥִǰĿոָ PreStr  AppStrȥִǰո
'fType = 0 ȥִǰĿոָ PreStr  AppStrȥִǰո
'fType = 1 ȥִǰĿոָ PreStr  AppStrȥִǰո
'fType = 2 ȥִǰĿոָ PreStr  AppStr 1 Σȥִǰո
'fType > 2 ȥִǰĿոָ PreStr  AppStr 1 Σȥִǰո
Private Function RemoveBackslash(ByVal Path As String,ByVal PreStr As String,ByVal AppStr As String,ByVal fType As Long) As String
	Dim i As Long,a As Long,p As Long,Stemp As Boolean
	RemoveBackslash = Path
	If Path = "" Then Exit Function
	a = Len(AppStr)
	p = Len(PreStr)
	If fType > -1 Then RemoveBackslash = Trim(RemoveBackslash)
	Do
		Stemp = False
		If p <> 0 Then
			If Left$(RemoveBackslash,p) = PreStr Then
				RemoveBackslash = Mid$(RemoveBackslash,p + 1)
				Stemp = True
			End If
		End If
		If a <> 0 Then
			If Right$(RemoveBackslash,a) = AppStr Then
				RemoveBackslash = Left$(RemoveBackslash,Len(RemoveBackslash) - a)
				Stemp = True
			End If
		End If
		If fType = 1 Or fType > 2 Then RemoveBackslash = Trim$(RemoveBackslash)
		If Stemp = True Then
			If fType < 2 Then i = 0 Else i = 1
		Else
			i = 1
		End If
	Loop Until i = 1
End Function


'ضԻĳؼеִ
Private Function GetDlgString(ByVal hwnd As Long) As String
	Dim i As Long
	On Error GoTo errHandle
	i = SendMessageLNG(hwnd,WM_GETTEXTLENGTH,0&,0&)
	If i > 0 Then
		GetDlgString = String$(i,0)
		SendMessageLNG(hwnd,WM_GETTEXT,i,StrPtr(GetDlgString))
		GetDlgString = Replace$(StrConv$(GetDlgString,vbUnicode),vbNullChar,"")
	End If
	Exit Function
	errHandle:
	GetDlgString = ""
End Function


'öԻĳؼеִ
Private Function SetDlgString(ByVal hwnd As Long,ByVal StrText As String) As Boolean
	On Error GoTo errHandle
	SendMessageLNG(hwnd,WM_SETTEXT,0&,StrPtr(StrConv$(StrText,vbFromUnicode)))
	SetDlgString = True
	errHandle:
End Function


'Ϣַ
Private Function GetMsgList(MsgList() As String) As Boolean
	Dim i As Integer
	ReDim MsgList(58) As String
	On Error GoTo errHandle
	MsgList(0) = "Error"
	MsgList(1) = "\r\n\r\nThe program cannot continue and will exit."
	MsgList(2) = "\r\n\r\nDo you want to continue?"
	MsgList(3) = "\r\n\r\nThe program will continue to run."
	MsgList(4) = "Unable to open the file. Please verify the file path and file name" & _
				"contains characters in Asian languages.\r\n" & _
				"Note: Passolo 2015 Version of the macro engine does not recognize" & _
				"the file path and file name contains Asian language characters."
	MsgList(5) = "An Error occurred in the program design.\r\nError Code: %d, Content: %v\r\n" & _
				"Please restart the Passolo try and please report to the software developer."
	MsgList(6) = "The following file is missing [%s] section.\r\n%d"
	MsgList(7) = "The following file is missing [%s] Value.\r\n%d"
	MsgList(8) = "The following contents of the file is not correct.\r\n%s"
	MsgList(9) = "The following file does not exist! Please check and try again.\r\n%s"
	MsgList(10) = "The following file version is %d, requires version at least %v.\r\n%s"
	MsgList(11) = "Your system is missing %s server.\r\nError Code: %d, Content: %v"

	MsgList(12) = "Reference Search - Version %v (Build %b)"
	MsgList(13) = "..."
	MsgList(14) = "Dec"
	MsgList(15) = "Hex"
	MsgList(16) = "Bit"
	MsgList(17) = "About"
	MsgList(18) = "RVA"
	MsgList(19) = "Offset"
	MsgList(20) = "Code"
	MsgList(21) = "Search"
	MsgList(22) = "References (%s):"
	MsgList(23) = "Copy"

	MsgList(24) = "Unknown;Not PE;PE32;PE64"
	MsgList(25) = "No Section"
	MsgList(26) = "Hide Section"
	MsgList(27) = "Outside File"
	MsgList(28) = "File Header"
	MsgList(29) = "Sub PE File"
	MsgList(30) = "No References"
	MsgList(31) = "Version: %v (Build %b)\r\n" & _
				"OS Version: Windows XP/2000 or higher\r\n" & _
				"Passolo Version: Passolo 5.0 or higher\r\n" & _
				"Copyright: Hanzify\r\nLicense: Freeware\r\n" & _
				"HomePage: http://www.hanzify.org\r\n" & _
				"Author: Hanzify member - wanfu (2015)\r\n" & _
				"E-mail: z_shangyi@163.com"
	MsgList(32) = "About Reference Search"
	MsgList(33) = "Executable file (*.exe;*.dll;*.ocx)|*.exe;*.dll;*.ocx|All file (*.*)|*.*||"
	MsgList(34) = "Select file"
	MsgList(35) = "Searching references, please wait..."
	MsgList(36) = "File: %p\r\nOffset: %o, RVA: %r\r\n%s"

	MsgList(37) = "================================================"
	MsgList(38) = "No.\tDec Offset\tHex Offset\tSection\tDirectory\tRef Code"
	MsgList(39) = "#%no\t%da\t%ha\t%sc\t%dc\t%rc"
	MsgList(40) = "Address entered is illegal."
	MsgList(41) = "Address entered more than the length of this file."
	MsgList(42) = "Outside"
	MsgList(43) = "Export"			'Ŀ¼
	MsgList(44) = "Import"			'Ŀ¼
	MsgList(45) = "Resource"		'ԴĿ¼
	MsgList(46) = "Exception"		'쳣Ŀ¼
	MsgList(47) = "Security"		'ȫĿ¼
	MsgList(48) = "Basereloc"		'ضλ
	MsgList(49) = "Debug"			'Ŀ¼
	MsgList(50) = "Copyright"		'X86ʹ-
	'Msglist(50) = "Architecture"	'Architecture Specific Data
	MsgList(51) = "Globalptr"		'ֵ(Mips GP), RVA Of Globalptr
	MsgList(52) = "TLS"				'̱߳ش洢(Thread Local Storage,Tls)Ŀ¼
	MsgList(53) = "Load Config"		'Ŀ¼
	MsgList(54) = "Bound Import"	'(Bound Import Directory in Headers)
	MsgList(55) = "IAT"				'ַ
	MsgList(56) = "Delay Import"	'Delay Load Import Descriptors
	MsgList(57) = "COM Descriptor"	'COM б־
	MsgList(58) = "Reserved"		'
	For i = 0 To UBound(MsgList)
		If InStr(MsgList(i),"\\") Then MsgList(i) = Replace$(MsgList(i),"\\","*a!N!d*")
		If InStr(MsgList(i),"\r\n") Then MsgList(i) = Replace$(MsgList(i),"\r\n",vbCrLf)
		If InStr(MsgList(i),"\t") Then MsgList(i) = Replace$(MsgList(i),"\t",vbTab)
		If InStr(MsgList(i),"*a!N!d*") Then MsgList(i) = Replace$(MsgList(i),"*a!N!d*","\")
	Next i
	GetMsgList = True
	Exit Function
	errHandle:
	ReDim MsgList(0) As String
End Function
